#ifndef _AFF_CRTO_H
#define _AFF_CRTO_H

//*****************************************************************************.
//*****************************************************************************.

#ifndef MAX_AXES
 #define MAX_AXES     8
#endif

#define OFFSET_INDEX 4096  // 4 K octets rservs pour le "nature" au dpart

#define NB_SEUILS_MAX               16
#define NB_SEUILS_ERREUR            0x10  //Mettre toujours en "puissance de 2"
#define NB_COULEUR_DOS              16
#define NB_MAX_COULEUR              256

#define TAILLE_LIGNE_MAX_ECRAN      1280
#define LIGNE_NON_ACQUISE           0xFFFFFFFF
#define POS_VIRGULE_AFFI_CARTO      16
#define NB_LETTRES_UNIT_MECA        4
#define NB_LIGNES_A_AFFICHER_MAX	16
#define NB_POINTS_DEGAGEMENT_MAX	20
#define NB_COORD_DEGAGEMENT			3

#define MAX_FICHIERS_CARTO_ASSOCIES	10
#define TAILLE_COMMENTAIRE_CONTENU 80

#define  VAL_MAX_PEIGNE 20

extern char _FAR_DATA *Carto_Mode_Comp[];
extern char _FAR_DATA *Carto_Type_Unite_Carto[];
extern int  _FAR_DATA Carto_Extension_Carto;

enum
{
UNITE_AFF_PIXEL, 
UNITE_AFF_METRE, 
UNITE_AFF_IMPRIMANTE
};

enum
{
SAUT, 
MINI, 
MAXI, 
MOYENNE, 
MAX_DEF_SAUT_LIGNE 
};

enum
{
CURSEUR_EFFACE,
CURSEUR_NORMAL,
CURSEUR_CARRE
};

enum
{
INIT_CURSEUR_CARTO, 
DESSINE_CURSEUR_CARTO, 
EFFACE_CURSEUR_CARTO, 
MODE_NORMAL_CURSEUR_CARTO,
MODE_CARRE_CURSEUR_CARTO, 
AUTORISE_CURSEUR_CARTO, 
INTERDIT_CURSEUR_CARTO, 
FIN_CURSEUR_CARTO
};

enum
{
SEUIL_NO_ACQUI, 
SEUIL_NO_ECHO, 
SEUIL_NO_SYNCHRO, 
SEUIL_ERREUR 
};

enum e_block_fin_ligne_carto {BLOCK_POSITION_AXES_DEBUT_LIGNE,
BLOCK_POSITION_AXES_FIN_LIGNE,
BLOCK_PAS_LIGNE,BLOCK_CONTENU_PLUS_SENS};

#define NOM_VAR_VALEUR_CARTO "#_F_VAL_CARTO_"

//************************************************************************
struct s_signal_carto
	{
	long resultat;			// resultat potentiel apres un traitement
	int unsigned offset;	// (buffer_acqui + offset) => l'acquisition pure sur n octet
	int unsigned len_descriptif;	// longueur de la struct desciptive du signal stock
   // struct s_descriptif ...    // soit s_us_ascan, s_cf_signal ...   
   // data divers ...            // si besoin
};

//************************************************************************

struct s_config_carto
	{
	int first_carto;		//Utilis en multi dition de carto
	int multi_edition;	//"		 "	 "	    "       "  "

	int en_memoire;
	int isometrique;		// Si on doit garder un affichage isomtrique
	int unite_visu;
	int mode_compression;

	int peigne_pair;		// == 1 si le peigne est sur les ligne paires
	int compensation_peigne;	// En nb d'acquisition

	int valeur;				// Affichage des valeur pour l'dition

	int marge_x;			// Affichage d'une marge pour le B/DSCAN ou autre
	int marge_y;			// Affichage d'une marge pour le B/DSCAN ou autre
	int echelle_x;			// Affichage des chelles
	int echelle_y;			// Affichage des chelles

	int signal;				// Affichage du signal.
	int palette;			// Affichage de la palette.
	int coupe_x;			// Affichage d'une coupe en x
	int coupe_y;			// Affichage d'une coupe en y
	int ligne_coupe;		// Affichage de la coupe en reliant les points
	int remplir_coupe;	// Affichage d'une coupe remplie
	int inverse_coupe;	// Affichage inverse d'une coupe 
	int bscan_epaisseur;	// Affichage d'une coupe sur une epaisseur

	int mirroir_x;			// Si x est en mirroir  l'affichage
	int mirroir_y;			// Si y est en mirroir  l'affichage
	int inversion_x_y;	// Si x et y sont inverss  l'affichage
	int curseur_x;			// autorisation en x
	int curseur_y;			// autorisation en y

	int fcouleur_carto;
	int couleur_curseur;
	int couleur_echelles;	// Couleurs des chelles de la carto
	int fcouleur_echelles;

	double taille_ecran_x;	// Taille du moniteur en m en x
	double taille_ecran_y;	// Taille du moniteur en m en y
	double taille_papier_x;	// Taille du papier en m en x
	double taille_papier_y;	// Taille du papier en m en y

	unsigned int marge_echelles;	// Taille de la marge pour les chelles ( en pixels )
	unsigned int marge_palette;	// Taille de la marge pour la palette ou les ascan ( en pixels )
	unsigned int marge_coupes;	// Taille de la marge pour les coupes ( en pixels )

	char fichier_ascan[ MAX_LEN_PATH];

	int		conserve_derniere_palette;
	char	fichier_palette[ MAX_LEN_PATH];
};

//************************************************************************
struct s_config_generale_carto
	{
	int multi_palette;
	int multi_edition;

	unsigned int nb_cartos;	// en cours d'affichage
	unsigned int nb_cartos_horizontales;	// en cours d'affichage
	unsigned int nb_affi_cartos_max;	// maximum a traiter

	struct s_config_carto config;
};
//************************************************************************
struct s_fenetre_carto
	{
	int active;
	int ecran;

	struct s_pos_carto
		{
		int   x;
		int   y;
		int   lng_x;
		int   lng_y;
	} carto;					// Positionnement de la cartographie en elle mme

	struct s_pos_echelle_x
		{
		int   x;
		int   y;
		int   lng_x;
		int   lng_y;
	} ech_x;					// positionnement des echelles en x

	struct s_pos_echelle_y
		{
		int   x;
		int   y;
		int   lng_x;
		int   lng_y;
	} ech_y;					// positionnement des echelles en y

	struct s_pos_marge_x
		{
		int   x;
		int   y;
		int   lng_x;
		int   lng_y;
	} mrg_x;					// positionnement des marges en x ( par exemple pour les coupes )

	struct s_pos_marge_y
		{
		int   x;
		int   y;
		int   lng_x;
		int   lng_y;
	} mrg_y;					// positionnement des marges en y ( par exemple pour les coupes )
};
//************************************************************************
struct s_curseur_carto
	{
	int ecran;
	int couleur;

	int type;				// Croix, croix + carr
	int dessine;			// Curseur dessin ou non        
	int autorise;			// autorisation de le dessiner
	int autorise_x;		// autorisation en x
	int autorise_y;		// autorisation en y

	int   xc1, yc1;		// Position du curseur
	int   xc2, yc2;		// Position du carr (depart)

	int   oxc1, oyc1;		// Ancienne Position du curseur

	int   oxdh, oxfh;		// Ancienne Position du carr
	int   oydh, oyfh;		// Ancienne Position du carr
	int   oxdv, oxfv;		// Ancienne Position du carr
	int   oydv, oyfv;		// Ancienne Position du carr
	int   olngx, olngy;	// Ancienne Position du carr

	int offset_x;			// Offset de position de la carto en x x_dessin=pox_x+xc1+offset_x
	int offset_y;			// Offset de position de la carto en y y_dessin=pox_y+yc1+offset_y

	int pos_x, pos_y;		// Cadre de travail de la carto
	int lng_x, lng_y;

	unsigned char * buffer_sav;	// Pour sauver ce qu'il y a dessous unsigned 
	unsigned char *buf1, *buf2, *buf3, *buf4;
};
//************************************************************************
struct s_coupe_carto
	{
	int bscan_epaisseur;	// si le l'affichage du bscan ce fait sur une epaisseur > 1 acquisition
	int go_bscan_epaisseur;	// flag de depart pour le dessin du bscan epaisseur
	int xc_bscan, yc_bscan;	// pour un bscan epaisseur, progression de l'affichage !
};
//************************************************************************
struct s_asm_carto
	{
	int active;				// carto active / inactive 
	char * buffer_trace;	// buffer contenant la ligne a tracer en valeur brute ( amplitude, temps ... )
	char * buffer_travail;	// buffer contenant la ligne a tracer en couleur.
	char * tab_val_couleur;	// tableau de correspondance valeur / couleur
	unsigned long fin_tab_coul;	// maxi de la table
	long offset_data;		// Valeur a ajouter pour traiter les ngatifs

	int pos_x;				// position en x de la carto  
	int pos_y;				// position en y de la carto
	int lng_x;				// place disponible en x   
	int lng_y;				// place disponible en y   

	int x;					// position de l'affichage du point en instantan en x
	int y;					// position de l'affichage du point en instantan en y

	int avance_buffer;	// valeur d'avance dans le buffer de trac ( +1 ou -1, -2, +2 ... )
	int pointeur_affi;	// pointeur d'affichage sur le buffer d'affichage
	int offset_dest;		// Offset sur le pointeur de destination POUR LA COMPRESSION 
	int nb_pixels_affi;	// nb de pixels a afficher
	int nb_acq_affi;		// nb de points d'acqui a afficher
	int nb_oct;				// nb d'octets par point d'acquisition

   //------------------- dfinissions pour la compression -------------------------

	int mode_compression;	// mode trace saut mini maxi ou moyenne
   // .................................................................................................................
	char *somme_coul;		// mmorisation du nb de pixels pour la division
	char *last_coul_comp;	// buffer des couleurs traces pour la compression * 4 pour la moyenne
	char *last_coul_zoom;	// buffer des couleurs traces pour le zoom
   // .................................................................................................................

	long inc_pix_x;		// Compression en virgule fixe en x:   65536 == pas de compression, 32767 = compression * 2
	long inc_pix_y;		// Compression en virgule fixe en y.   65536 + 32767 = zoom par 1.5
	long comp_x_act;		// Compression actuelle en x
	long comp_y_act;		// Compression actuelle en y

	unsigned long mask_stockage;
	char tab_err_couleur[NB_SEUILS_ERREUR];

	long mask_err_stockage;	// voir s_convert_data !
	long erreur_stockage;

	int offset_palette_err;	// offset + erreur = numero de couleur en erreur
	int unsigned nb_division_par_2;	// nb de div par 2
};
//************************************************************************
struct s_flags_affi_carto
	{
	int active;				// A 1 si est autorise  tracer
	int demande_trace_carto;	// Mettre  1 pour retracer la cartographie.
	int trace_en_cours;	// Indique si le trac est en cours.
	int tracee;				// Si la cartographie est finie d'tre trace.
	int ligne_carto_tracee;	// Si la ligne courante est finie d'tre trace.
	int force_affichage_y;	// Si on veut absolument tracer la ligne

	int interdit_affichage_carto;	// si  1 pas d'affichage de la carto mme si demande_trace_carto = 1.
	int interdit_re_affichage_menu;	// si  1 pas de r-affichage du menu.
	int interdit_re_calcule_palette;	// si  1 pas de recalcule de la palette.
};
//************************************************************************
struct s_palette_carto
	{
	char nom[LNG_MAX_PATH];

	int nb_couleurs_max;	// Nb de couleurs  ne pas dpasser.

								// "local" pour la struct affi_carto	
	int offset_couleur_local;	// Offset des couleurs pour l'affichage
	int nb_couleurs_local;	// Nb de couleurs disponibles pour l'affichage

	int offset_couleur_val;	// Offset des couleurs pour l'affichage des valeurs bonnes
	int nb_couleurs_val;	// Nb de couleurs disponibles pour l'affichage des valeurs bonnes

	int offset_couleur_err;	// Offset des couleurs pour l'affichage des erreurs
	int nb_couleurs_err;	// Nb de couleurs disponibles pour l'affichage des erreurs


	unsigned char rouge[256];	// Palette RVB des couleurs
	unsigned char vert[256];
	unsigned char bleu[256];

	int rouge_seuil[NB_SEUILS_MAX];	// Palette RVB des seuils
	int vert_seuil[NB_SEUILS_MAX];
	int bleu_seuil[NB_SEUILS_MAX];

	int rouge_erreur[NB_SEUILS_ERREUR + 1];	// Palette RVB des defauts
	int vert_erreur[NB_SEUILS_ERREUR + 1];
	int bleu_erreur[NB_SEUILS_ERREUR + 1];

	int nb_seuils;			// Nb de seuils utiliss.
	double seuils[NB_SEUILS_MAX + 1];	// en amplitude ou en distance ou en cf ...
                                       // Compris entre 0 et 1. 0 -> 0, 1 -> maxi
	double seuil_central;
	double ecart_seuils;

	int degrade;
	struct s_unite_carto unite;
};                                                                        

//************************************************************************

enum e_ordre_edit_carto
{
EC_INIT = 0, 
EC_CARTO, 
EC_MENU, 
EC_DEMANDE_COUPE,
EC_DEMANDE_INFO, 
EC_TACHE_FOND, 
EC_EFFACE_CURSEUR, 
EC_EFFACE_INFO, 
EC_INIT_CURSEUR,
EC_FIN
};

//************************************************************************

struct s_edit_carto
	{
	int multi;

	int touche;
	int sortir;
	int mouse_out;

	double pos_x;
	double pos_y;
	struct s_commande com;

	int num;
	int etape[10];
	int dessine_info[10];
	int dessine_coupe[10];
};

//************************************************************************

struct s_affi_carto
	{
	struct s_asm_carto asm;
	struct s_flags_affi_carto flags;	// Flags concernant l'affichage de la carto
	struct s_config_carto config;

	int num_ligne_affi;	// numero de ligne en cours d'affichage

	int offset_carto_x;	// offset debut carto/debut affichage x
	int offset_carto_y;	// offset debut carto/debut affichage y

	double zoom_x;			// zoom de visualisation (rt-xy)
	double zoom_y;			// zoom de visualisation (rt-xy)
	int centre_zoom_x;	// Centre du zoom en x
	int centre_zoom_y;	// Centre du zoom en y

	double echelle_x;		// echelle en x en flottant ( echelle 1 -> 1 mm ecran = 1 mm rel  2 -> 2 mm ecran = 2 mm rel )
	double echelle_y;		// echelle en y en flottant ( echelle 1 -> 1 mm ecran = 1 mm rel  2 -> 2 mm ecran = 2 mm rel )

	double ech_pix_x;		// echelle en x en flottant ( echelle 1 -> 1 pix ecran = 1 acq  2 -> 2 pix ecran = 1 acq  )
	double ech_pix_y;		// echelle en y en flottant ( echelle 1 -> 1 pix ecran = 1 acq  2 -> 2 pix ecran = 1 acq  )

	double ech_pap_x;		// echelle en x en flottant ( echelle 1 -> 1 mm papier = 1 mm rel  2 -> 2 mm papier = 2 mm rel )
	double ech_pap_y;		// echelle en y en flottant ( echelle 1 -> 1 mm papier = 1 mm rel  2 -> 2 mm papier = 2 mm rel )

	int pos_curseur_x;	// Mmorisation des positions du curseur en x pour l'dition de la cartographie.
	int pos_curseur_y;	// Mmorisation des positions du curseur en y pour l'dition de la cartographie.

	double offset_origine_x;	// Dcalage du zro
	double offset_origine_y;	// Dcalage du zro

	struct s_dialogue menu;
	struct s_coupe_carto coupe;
	struct s_palette_carto palette;
	struct s_curseur_carto curseur;
	struct s_fenetre_carto fenetre;
	struct s_data_carto * data_carto;

	struct s_us_affi_ascan * aff_ascan;	// ncessaire pour l'affichage d'un ascan (voie = 0)
	struct s_affi_carto * next_affi_carto;
	struct s_data_carto * signal_carto;	// si une carto des ascan ou signal CF est associe
	struct s_multi_objet_carto * multi_objet;
	void (*function_edit_carto)(struct s_commande * com, struct s_affi_carto * affi_carto);

	struct s_variable_logi *valeur_carto;
};

//************************************************************************
struct s_flags_data_carto
	{
	int used;

	int demande_index_en_memoire;	// Flag si demande l'index de la carto stock ou non en mmoire
	int demande_data_en_memoire;	// Flag si demande  carto stocke ou non en mmoire

	int index_en_memoire;	// Flag si l'index de la carto est stock ou non en mmoire
	int data_en_memoire;	// Flag si la carto est stocke ou non en mmoire

	// Modifs EB le 8/3/99
	int pas_variable;		// Flag si le pas est variable dans la cartographie
	int position_par_ligne;	// Flag si position axes sauve  chaque ligne
	int carto_2d;

//TCO Le 28/08/2003 flag permettant de dterminer si c'est une carto 3d ou pas
// afin de savoir si on commande directement la mecanique ou pas (cf AF 2272)
	int carto_3d;

	int carto_multi_voies;
	int contenu_ligne_plus_sens;	// Si sens + contenu stock  chaque ligne

};
//************************************************************************
struct s_fichier_carto
	{
	struct s_flags_data_carto flags;

	int handle;				// handle du fichier
	long  pos;				// pos courante dans le fichier carto

	char nom[LNG_MAX_PATH];	// nom du fichier de stockage
	// EB 18/11/99
	char nom_historique[LNG_MAX_PATH];	// nom du fichier d'historique
	int version;			// Numro de version du fichier
	char balayage[LNG_MAX_PATH];	// nom du fichier de balayage

	unsigned int nb_lignes_data;	// Pour controler les accs
	unsigned int offset_index;	// offset de l'index carto
	struct s_index_carto *index;	// index de la position de la ligne dans le fichier de la carto en fct du num de la ligne

	unsigned long offset_data;	// offset de la carto
	unsigned long taille_block_fin_de_ligne;	// taille du block de fin de chaque ligne de carto
	unsigned long taille_fichier;

	void ** bitmap;		// Bitmap de la cartographie
	void *  reccord;		// stockage d'un seul enregistrement => fonction_xxx_fast();

	unsigned long next_free_space;	// Prochain espace de libre sur le disque ( normalement la fin du fichier )

	unsigned int time;	// Heure de dernire modif
	unsigned int date;	// Date de dernire modif
};
#define LNG_CONTENU_LIGNE 32
//---------------------------------------------------------------------------
struct s_memo_position_axe
	{
	int longueur_struct;
	enum e_block_fin_ligne_carto type_struct;
	double pos_axes[MAX_AXES];
	int axe_used[MAX_AXES];
//TCO Le 28/08/2003 pour la gestion du numro de balayage/trajectoire (AF 2272)
	long num_balayage;
};

//---------------------------------------------------------------------------
struct s_contenu_ligne_plus_sens
	{
	int longueur_struct;
	enum e_block_fin_ligne_carto type_struct;
	char contenu_ligne[ LNG_CONTENU_LIGNE];
	int sens_deplacement;	// Sens du dplacement  de la ligne
	int num_balayage;		// Numro de balayage de la ligne
};


struct s_pas_variable
	{
	int longueur_struct;
	enum e_block_fin_ligne_carto type_struct;
	double pas;
};

//************************************************************************
struct s_data_carto
	{
	struct s_fichier_carto fichier;

	/// modif rvf le 14/03/96
	char nom_fichier_parametres[LNG_MAX_PATH];

	//Modif EB 8/6/99
	char nom_cartos_associees[MAX_FICHIERS_CARTO_ASSOCIES][LNG_MAX_PATH];

	/// modif rvf le 28/03/97
	char nom_fichier_palette[MAX_LEN_PATH];	// fichier associer !

	unsigned int num_ligne_data;	// numero de ligne demande

	int peigne_pair;		// == 1 si le peigne est sur les ligne paires
	int compensation_peigne;	// En nb d'acquisition

	char * ligne_actuelle;	// ligne actuellement disponible
	unsigned int  ligne_data_act;	// Numro de la ligne actuellement disponible
	unsigned long longueur_ligne;	// longueur de la ligne courante en nb d'acquisition
	int offset_ligne;		// Offset de la ligne courante en nb d'acquisition

	// Modifs EB le 8/3/99
	void * pt_block_fin_de_ligne_actuel;
	struct s_pas_variable pas_ligne;	// Pas d'acquisition de la ligne courante

	struct s_convert_data convert;

	unsigned int  nb_lignes_acquises;	// Nb de lignes dj acquises
	unsigned int  nb_lignes_total;	// Nb de lignes qui seront acquises  la fin de la cartographie ( calculs d'chelles automatiques )
	unsigned long largeur_maxi_ligne;	// Largeur maximale d'une ligne en nb d'acquisitions
	unsigned long largeur_carto;	// Largeur de la cartographie en nb d'acquisitions
	int lignes_a_afficher[NB_LIGNES_A_AFFICHER_MAX];	// Pendant la cartographie

	unsigned int  nb_balayages_total;	// Nb de balayages ( pour continuer les cartos )
	unsigned int  nb_balayages_deja_faits;	// Nb de balayages ( pour continuer les cartos )
	unsigned int  num_balayage_en_cours;	// Nb de balayages ( pour continuer les cartos )

	double reference[MAX_AXES];	// rfrence mcanique (pt de ref)
	double origine[MAX_AXES];	// origine mecanique (bord HG carto)
	double pas_horiz;		// pas horizontal ( taille d'une acquisition en m )
	double pas_vert;		// pas vertical   ( taille d'une acquisition en m )


	double offset_metre_x;	// Origine en metre 
	double offset_metre_y;	// Origine en metre 

	int axe_horiz_inverse;	// si le dplacement est en ngatif
	int axe_vert_inverse;	// si le dplacement est en ngatif

	char lettre_unite_meca_horiz[NB_LETTRES_UNIT_MECA];
	char lettre_unite_meca_vert[NB_LETTRES_UNIT_MECA];

	int axe_horiz;			// axe_horizontal d'origine
	int axe_vert;			// axe_vertical d'origine

	int voie;				// Voie(s) d'acquisition
	int porte;				// Porte(s) d'acquisition
	int num_unite;			// Numro de l'unit  l'acquisition.

	// Modifs EB le 8/3/99
	char contenu_carto[TAILLE_COMMENTAIRE_CONTENU];

	struct s_degagement_axes
		{
		// Modifs EB le 8/3/99
		int axe;				// Pour le suivit de profil
		double valeur;		// Pour le suivit de profil

		double point[NB_POINTS_DEGAGEMENT_MAX][NB_COORD_DEGAGEMENT];
		int point_actif[NB_POINTS_DEGAGEMENT_MAX][NB_COORD_DEGAGEMENT];
		struct
			{
			int axe_plan_1;
			int axe_plan_2;
			double num_point_en_cours;
			int num_point_a_atteindre;
		} interne;
	} degagement;

	// Modifs EB le 8/3/99
	struct s_memo_position_axe pos_axes_debut_ligne;
	struct s_memo_position_axe pos_axes_fin_ligne;
	double bord_carto;	// Bord sur le(s) axes balayants

	// Modifs EB le 1/8/99
	struct s_contenu_ligne_plus_sens contenu_ligne_plus_sens;
};

//************************************************************************
#define SHIFT_INDEX_CARTO 3

struct s_index_carto
	{
	long position;			// Position de la ligne dans le fichier
                          // Si sur le disque en relatif par rapport au dbut de la carto, en mmoire, en absolu
	int offset;				// offset de la ligne en nb d'acquisition par rapport au dbut de la ligne
	int unsigned longueur;	// longueur de la ligne en nb d'acquisitions
};

//************************************************************************
//************************************************************************

#define TAILLE_NOM_DIAL_CARTO 18

struct s_dialogue_carto
	{
	int actif;
	int relance_module_demande;
	char nom[TAILLE_NOM_DIAL_CARTO + 1];
	char nom_pays[NB_LANGUES_MAXI][TAILLE_NOM_DIAL_CARTO + 1];

	void (*function)();
	struct s_affi_carto * affi_carto;
	struct s_config_generale_carto *cfg_carto;

	char * help;
	char * help_pays[NB_LANGUES_MAXI];
	struct s_dial_menu
		{
		int ecran;
		struct s_carre pos;	// si il y a un menu, position et surface a occuper

		///RVF le 16/04/99                 
		int num_carto_select;
		int utilise_dial_menu;
		int no_select_multi_objet;

		struct s_dialogue * menu;
	} pmenu;
};

//************************************************************************
//************************************************************************

extern struct s_carre _FAR_DATA Carto_Cadre_cartos;
extern struct s_config_generale_carto _FAR_DATA Carto_Cfg_Carto;

// ASSEMBLEUR ----------------------------

int  size_asm_carto();
void calcule_moyenne_ligne_carto( struct s_asm_carto *asm);
void calcul_couleur_ligne_carto( struct s_asm_carto *asm);
void compress_ligne_carto_x( struct s_asm_carto *asm);
void compress_ligne_carto_y( struct s_asm_carto *asm);
void zoom_ligne_carto( struct s_asm_carto *asm);
void invert_mem( char *buffer, unsigned int size);

//--- C ------------------------------------------ BASE_C.c

#include "..\carto\bas_crto.h"

//*****************************************************************************.
//*****************************************************************************.

int impose_extention_cfc(char *fichier);
void init_base_funct_carto(void);
void affiche_carto(struct s_affi_carto *affi_carto);
int bouche_peigne(long a1, char *a2, struct s_data_carto *a3);
void fin_affiche_carto(struct s_affi_carto *affi_carto);
void affiche_ligne_carto(struct s_affi_carto *affi_carto, char *ligne);
void transforme_ligne_carto(struct s_affi_carto *affi_carto, char *ligne);
void reset_ligne_carto(struct s_affi_carto *affi_carto);
int reset_malloc_affiche_carto(struct s_affi_carto *a1);
void init_affiche_carto(struct s_affi_carto *affi_carto);
void init_carto_champ(struct s_affi_carto *carto, struct s_dialogue *menu, struct s_champ *champ);
void affiche_echelles_carto(struct s_affi_carto *affi_carto);
int affiche_coupes_carto(struct s_affi_carto *affi_carto);
void cree_buffer_stratif(struct s_affi_carto *affi_carto, char *buf_strat);
void cls_carto(struct s_affi_carto *carto);
void set_palette_carto(struct s_affi_carto *carto);
void calcule_palette_carto(struct s_affi_carto *affi_carto);
int calcul_RVB_carto(struct s_palette_carto *a1, struct s_convert_data *a2);
int calcule_couleur_carto(struct s_palette_carto *a1, char *a2, struct s_convert_data *a3);
void defaut_seuils_carto(struct s_palette_carto *palette);
void init_struct_carto(int ecran, struct s_affi_carto *affi_carto);
void fin_struct_carto(struct s_affi_carto *affi_carto);
void calcule_zones_carto(struct s_affi_carto *affi_carto);
void calcule_zoom_carto(struct s_affi_carto *affi_carto, double coeff);
void calcule_zoom_zone_carto(struct s_affi_carto *affi_carto, int x1, int y1, int x2, int y2);
void calcule_plein_ecran_carto(struct s_affi_carto *affi_carto);
void set_champs_affi_carto(struct s_affi_carto *affi_carto);
int affi_info_carto(int niveau, char *status, struct s_affi_carto *affi_carto);
int xy_sur_carto(int x, int y, struct s_affi_carto *affi_carto);
void write_affi_carto(struct s_affi_carto *affi_carto, char *data);
int edit_multi_carto(int touche, int nb_carto, struct s_commande *com, struct s_affi_carto **affi_carto);
int edit_multi_carto_non_bloquant(int touche, int nb_carto, struct s_commande *com, struct s_affi_carto **affi_carto);
int edit_mono_carto(int touche, int nb_carto, struct s_commande *com, struct s_affi_carto **affi_carto);
int edit_mono_carto_non_bloquant(int touche, int nb_carto, struct s_commande *com, struct s_affi_carto **affi_carto);
int edit_carto(int a1, struct s_affi_carto *a2);
int edit_carto_non_bloquant(int ordre, int touche_boutonD, struct s_commande *com, struct s_affi_carto *affi_carto);
int edit_carto_commande(enum e_ordre_edit_carto ordre, struct s_edit_carto *edit, struct s_commande *com, struct s_affi_carto *affi_carto);
int edit_carto_mouse(struct s_edit_carto *a1, struct s_commande *a2, struct s_affi_carto *a3);
int edit_carto_touche(struct s_edit_carto *a1, struct s_commande *a2, struct s_affi_carto *a3);
int edit_carto_menu(struct s_edit_carto *a1, struct s_commande *a2, struct s_affi_carto *a3);
int edit_carto_taches_de_fond(struct s_edit_carto *a1, struct s_commande *a2, struct s_affi_carto *a3);
void dialogue_edit_palette_carto(struct s_dialogue_carto *dial_carto);
void dialogue_edit_palette_defaut(struct s_dialogue_carto *dial_carto);
int affi_palette_carto(struct s_affi_carto *affi_carto, int gere_affiche_carto);
void edit_palette_carto(struct s_dial_menu *pmenu, struct s_affi_carto *affi_carto, int gere_affiche_carto);
void edit_palette_defaut(struct s_dial_menu *pmenu, struct s_affi_carto *affi_carto, int gere_affiche_carto);
void calcule_seuils_lineaires(struct s_palette_carto *palette);
void calcule_chps_palette_carto(struct s_dialogue *menu, struct s_palette_carto *palette);
void affiche_palette_lineaire(int ecran, int pos_x, int pos_y, int lng_x, int lng_y, struct s_palette_carto *palette);
void affiche_palette_seuil(int ecran, int pos_x, int pos_y, int lng_x, int lng_y, struct s_palette_carto *palette);
int teste_coherence_min_max(struct s_palette_carto *palette);
int teste_coherence_palette(struct s_palette_carto *palette, int numero_depart);
int zoom_change(struct s_commande *com, struct s_affi_carto *affi_carto, double coeff);
void read_write_palette_carto(int ordre, char *buffer, struct s_palette_carto *palette);
int lire_palette_carto(char *nom_fichier, struct s_palette_carto *palette);
int ecrire_palette_carto(char *nom_fichier, struct s_palette_carto *palette);
void read_write_cfg_ecran_carto(int ordre, char *buffer, struct s_config_generale_carto *cfg_generale);
int lire_cfg_ecran_carto(char *nom_fichier, struct s_config_generale_carto *cfg_generale);
int ecrire_cfg_ecran_carto(char *nom_fichier, struct s_config_generale_carto *cfg_generale);
void read_write_cfg_carto(int ordre, char *buffer, struct s_config_carto *cfg_carto);
int lire_cfg_carto(char *nom_fichier, struct s_config_carto *cfg_carto);
int ecrire_cfg_carto(char *nom_fichier, struct s_config_carto *cfg_carto);
void edit_config_ecran_carto(int select_affi_carto, struct s_carre *carre, struct s_affi_carto **affi_carto, struct s_config_generale_carto *cfg_carto);
void edit_config_visu(struct s_dial_menu *pmenu, struct s_affi_carto *affi_carto, struct s_config_carto *cfg_carto);
void edit_config_carto(struct s_dial_menu *pmenu, struct s_affi_carto *affi_carto, struct s_config_carto *cfg_carto);
int mov_chps_config_ecran(int sens, struct s_champ *champs, struct s_config_generale_carto *cfg_carto);
void mov_chps_config_visu(int sens, struct s_champ *champs, struct s_config_carto *cfg_carto, struct s_affi_carto *affi_carto);
void mov_chps_config_carto(int sens, struct s_champ *champs, struct s_config_carto *cfg_carto, struct s_affi_carto *affi_carto);
void dialogue_config_visu(struct s_dialogue_carto *dial_carto);
void dialogue_config_carto(struct s_dialogue_carto *dial_carto);
void set_config_carto(struct s_affi_carto *affi_carto, struct s_config_generale_carto *cfg_carto);
void set_config_ecran_carto(struct s_affi_carto *affi_carto, struct s_config_generale_carto *cfg_carto);
void calcule_positions_cartos(struct s_carre *carre, struct s_affi_carto **affi_carto, struct s_config_generale_carto *cfg_carto, int max_carto);
void calcule_place_palette_carto(int max_carto, struct s_affi_carto **affi_carto, struct s_config_generale_carto *cfg_carto);
void init_chp_peigne_carto(struct s_champ *champ, struct s_affi_carto *affi_carto);
void gere_chp_peigne_carto(struct s_champ *champ, struct s_affi_carto *affi_carto);
int affiche_info_carto(int ecran, struct s_affi_carto *affi_carto);
void dialogue_palette_glissante(struct s_dialogue_carto *dial_carto);
void dialogue_affiche_info_carto(struct s_dialogue_carto *dial_carto);
void palette_glissante(struct s_dial_menu *pmenu, struct s_affi_carto *affi_carto);
int dec_largeur_seuils(int nb_seuils, int *tab);
int inc_largeur_seuils(int seuil_debut, int nb_seuils, int *tab, int *tab_max);
int init_champ_couleur_palette_glissante(struct s_affi_carto *carto, struct s_dialogue *menu);
int init_couleur_seuil_palette_glissante(int offset_couleur, int *tab, struct s_affi_carto *carto, struct s_dialogue *menu);
int init_champs_palette_glissante(struct s_affi_carto *carto, struct s_dialogue *menu);
int calcul_largeur_seuils(int *tab, int *tab_max, struct s_palette_carto *palette);
void glissement_palette(struct s_affi_carto *carto, int old_debut, int debut, int largeur_palette, int *largeur_couleur);
int gere_champs_seuils_palette_glissante(int couleur_debut, int *tab, struct s_dialogue *menu, struct s_affi_carto *carto);
void calcule_cartos_actives(int carto, struct s_config_generale_carto *cfg_carto, struct s_affi_carto **affi_cartos);
int change_configuration_carto(int select_affi_carto, struct s_carre *carre, struct s_config_generale_carto *cfg_carto, struct s_affi_carto **affi_cartos);
int gere_petite_palette(struct s_affi_carto *a1);
int fermer_toutes_carto(struct s_affi_carto **carto);
int init_couleurs_config_carto( struct s_affi_carto *affi_carto );

//*****************************************************************************.
//*****************************************************************************.

#endif //_AFF_CRTO_H
//EOF
