#include "..\carto\bas_crto.cpl"

#if bas_crto_declare_asm && bas_crto_declare_c
	//voir lib_crto.inc -> "aff_crto.lib" 
	#include "..\carto\aff_crto.ica"
	#include "..\carto\bas_crto.icc"
#else
	#if bas_crto_declare_asm
		//voir lib_crto.inc -> "aff_crto.lib" 
		//#loadobj "..\carto\$aff_crto.obj"
#include "..\carto\aff_crto.ica"
	#endif
#endif

#if bas_crto_compile_icm

#include "..\lib\all_h.h"
#include "..\lib\instantc.h"
#include "..\lib\conf_pv.h"

#if 0
#include "key.h"
#include "util.h"
#include "fonte.h"

#include "graphic.h"
#include "lmouse.h"
#include "dialogue.h"
#include "formules.h"
#include "echelles.h"
#include "polygone.h"
#endif

#include "..\lib\lib.lh"

#include "..\soniscop\soniscop.def"
#include "..\soniscop\soniscop.h"

//***************************************************
//***************************************************

#include "..\carto\carto.lh"

//***************************************************
//***************************************************
#if 0
#include "..\carto\crto_edt.hbx"

//***************************************************
//***************************************************

#pragma data_seg ("carto_data")

//***************************************************
//***************************************************
#endif
/*
	Ne pas dclarer de variable global ici,
	il faut les dclarer dans INI_CRTO.C (PV:31.07.98)
*/

//***************************************************
//***************************************************

int get_valeur_peigne( int ligne, struct s_data_carto *carto)
{
	int sens;

	if (! carto->compensation_peigne)
		return 0;

	if (carto->fichier.flags.contenu_ligne_plus_sens)
	{
		carto->num_ligne_data = ligne;
		get_ligne_carto( carto );
		read_block_fin_de_ligne( carto );
		sens = carto->contenu_ligne_plus_sens.sens_deplacement;
	}
	else
	{
		if (ligne & 1)
			sens = 1;
		else
			sens = -1;
	}

	if (sens > 0)
	{
		if (carto->peigne_pair)
			return carto->compensation_peigne;
	}
	else
	{
		if (! carto->peigne_pair)
			return carto->compensation_peigne;
	}
	return 0;
}

//***************************************************

double pixel_x_to_acqui( int pixel, struct s_affi_carto *affi_carto )
{
	double a;

	// soustraction en pixel
	a = pixel - affi_carto->fenetre.carto.x;

	// passage en acquisition
	a = a / affi_carto->ech_pix_x + affi_carto->offset_carto_x;

	return (a);
}

/***********************************************************/

double pixel_y_to_acqui( int pixel, struct s_affi_carto * affi_carto )
{
	double a;

	// soustraction en pixels 
	a = pixel - affi_carto->fenetre.carto.y;

	// passage en acquisition 
	a = a / affi_carto->ech_pix_y + affi_carto->offset_carto_y;

	return (a);
}

int pixel_xy_to_acqui( 	int pixel_x, 
								int pixel_y, 
								double * acqui_x, 
								double * acqui_y, 
								struct s_affi_carto * affi_carto )
{
	*acqui_x = pixel_x_to_acqui( pixel_x, affi_carto );
	*acqui_y = pixel_y_to_acqui( pixel_y, affi_carto );

	if (! affi_carto->data_carto->fichier.flags.data_en_memoire)
		if (get_valeur_peigne( ftoi( *acqui_y ), affi_carto->data_carto ))
		{
			//	if ((_ftol( *acqui_y ) & 1) == (affi_carto->config.peigne_pair))
			*acqui_x = *acqui_x - (double) affi_carto->config.compensation_peigne;
		}

	return (1);
}

int acqui_x_to_pixel( double acqui, struct s_affi_carto *affi_carto )
{
	int p;

	// passage en acquisition
	acqui = (acqui - affi_carto->offset_carto_x) * affi_carto->ech_pix_x;

	// soustraction en pixel
	p = ftoi( acqui + affi_carto->fenetre.carto.x );

	return (p);
}


int acqui_y_to_pixel( double acqui, struct s_affi_carto *affi_carto )
{
	int p;

	// passage en acquisition
	acqui = (acqui - affi_carto->offset_carto_y) * affi_carto->ech_pix_y;

	// soustraction en pixel
	p = ftoi( acqui + affi_carto->fenetre.carto.y );

	return (p);
}

double acqui_x_to_m( double acqui, struct s_affi_carto *affi_carto )
{
	double m;

	// passage en metre
	m = (acqui * affi_carto->data_carto->pas_horiz)
	+ affi_carto->data_carto->offset_metre_x;

	return (m);
}

double acqui_y_to_m( double acqui, struct s_affi_carto *affi_carto )
{
	double m;

	// passage en metre
	m = (acqui * affi_carto->data_carto->pas_vert)
	+ affi_carto->data_carto->offset_metre_y;

	return (m);
}


/***********************************************************/

double pixel_x_to_m( int pixel, struct s_affi_carto *affi_carto )
{
	double a, m;

	// passage en mm
	a = pixel_x_to_acqui( pixel, affi_carto );
	m = acqui_x_to_m( a, affi_carto );

	return (m);
}

//******************************************************************************

double pixel_y_to_m( int pixel, struct s_affi_carto *affi_carto )
{
	double a, m;

	// passage en mm
	a = pixel_y_to_acqui( pixel, affi_carto );
	m = acqui_y_to_m( a, affi_carto );

	return (m);
}

//-----------------------------------------------------------------------------.

double valeur_carto_to_variable(	int x,
											int y,
											struct s_variable_logi *v,
											struct s_data_carto *data )
{
	double valeur;
//-----------------------------------------------
	valeur = get_fvaleur_carto( ON, x, y, data );
	copy_to_variable_numerique( -1, v, valeur );

	return (valeur);
}

//******************************************************************************

double m_to_acqui_x( double m, struct s_affi_carto *affi_carto )
{
	double acqui;

	// passage en acquisition
	acqui = (m - affi_carto->data_carto->offset_metre_x)
	/ (affi_carto->data_carto->pas_horiz);

	return (acqui);
}

//******************************************************************************

double m_to_acqui_y( double m, struct s_affi_carto *affi_carto )
{
	double acqui;

	// passage en acquisition
	acqui = (m - affi_carto->data_carto->offset_metre_y)
	/ (affi_carto->data_carto->pas_vert);

	return (acqui);
}

//******************************************************************************

int m_to_pixel_x( double m, struct s_affi_carto *affi_carto )
{
	int pixel;
	double acqui;

	// passage en acquisition
	acqui = m_to_acqui_x( m, affi_carto );

	// passage en pixel	
	pixel = acqui_x_to_pixel( acqui, affi_carto );

	return (pixel);
}

//******************************************************************************

int m_to_pixel_y( double m, struct s_affi_carto *affi_carto )
{
	int pixel;
	double acqui;

	// passage en acquisition
	acqui = m_to_acqui_y( m, affi_carto );

	// passage en pixel	
	pixel = acqui_y_to_pixel( acqui, affi_carto );

	return (pixel);
}

double m_x_to_rm( double m, struct s_affi_carto *affi_carto )
{
	m = m + affi_carto->offset_origine_x;
	return (m);
}

double m_y_to_rm( double m, struct s_affi_carto *affi_carto )
{
	m = m + affi_carto->offset_origine_y;
	return (m);
}

double rm_to_m_x( double m, struct s_affi_carto *affi_carto )
{
	m = m - affi_carto->offset_origine_x;
	return (m);
}


double rm_to_m_y( double m, struct s_affi_carto *affi_carto )
{
	m = m - affi_carto->offset_origine_y;
	return (m);
}

double rm_to_acqui_x( double m, struct s_affi_carto *affi_carto )
{
	double acqui;

	// passage en acquisition
	m = rm_to_m_x( m, affi_carto );
	acqui = m_to_acqui_x( m, affi_carto );

	return (acqui);
}

double rm_to_acqui_y( double m, struct s_affi_carto *affi_carto )
{
	double acqui;

	// passage en acquisition
	m = rm_to_m_y( m, affi_carto );
	acqui = m_to_acqui_y( m, affi_carto );

	return (acqui);
}

double acqui_x_to_rm( double acqui, struct s_affi_carto *affi_carto )
{
	double m;

	// passage en acquisition
	m = acqui_x_to_m( acqui, affi_carto );
	m = m + affi_carto->offset_origine_x;

	return m;
}


double acqui_y_to_rm( double acqui, struct s_affi_carto *affi_carto )
{
	double m;

	// passage en acquisition
	m = acqui_y_to_m( acqui, affi_carto );
	m = m + affi_carto->offset_origine_y;

	return m;
}




/***********************************************************/
#pragma message("free_carto")
/*
#COM free_carto :    liberation automatique du stockage
#COM 						
#COM         IN: 		struct s_data_carto
#COM             
#COM 
#COM        OUT:    
#COM  
*/

free_carto( struct s_data_carto *carto )
{
//---------------------------------------------------------
	if (carto->fichier.reccord)
		D16MemFreeClear( (void **) &carto->fichier.reccord );

	if (carto->fichier.bitmap)
	{
		if (carto->fichier.flags.data_en_memoire)
			multi_free( carto->fichier.bitmap );
		else
			D16MemFree( carto->fichier.bitmap );
	}

	carto->fichier.bitmap = NULL;
	carto->fichier.flags.data_en_memoire = OFF;

	carto->longueur_ligne = 0;
	carto->ligne_data_act = -1;
	carto->ligne_actuelle = NULL;
}

/***********************************************************/
#pragma message("malloc_carto")
/*
#COM malloc_carto :  malloc automatique pour le stockage
#COM 						
#COM         IN: 		struct s_data_carto
#COM             
#COM 
#COM        OUT:    == 0 si choue, != 0 si OK
#COM  
*/

int malloc_carto( int demande_data_en_memoire, struct s_data_carto *carto )
{
	long len;
//---------------------------------------------------------
	free_carto( carto );

	if (demande_data_en_memoire)
	{
		if ((carto->convert.type == TYPE_SIGNAL_US)
		|| (carto->convert.type == TYPE_SIGNAL_US_AMP)
		|| (carto->convert.type == TYPE_SIGNAL_US_TPS))
			return (OFF);

		if ((carto->fichier.bitmap = 
		(void **) multi_malloc_idx( (int) carto->nb_lignes_total, (struct s_index_carto *) carto->fichier.index, (int) carto->convert.nb_octets, carto->fichier.taille_block_fin_de_ligne )) != NULL)
		{
			carto->fichier.flags.data_en_memoire = 1;
		}
		else
		{
			carto->fichier.flags.data_en_memoire = 0;
		}
	}
	else
	{
		len = (long) (carto->largeur_maxi_ligne + VAL_MAX_PEIGNE) * (long) carto->convert.nb_octets + 4L + carto->fichier.taille_block_fin_de_ligne;
		if (len >= 0x10000)
			carto->fichier.bitmap = D16HugeAlloc( len );
		else
			carto->fichier.bitmap = (void **) D16MemAlloc( (int unsigned) len );

		if (carto->fichier.bitmap == NULL)
		{
			(*Print)( "Erreur:  (Carto) plus de mmoire.\n", PRINT_ERREUR_GRAVE );
			close_carto( carto );
		}
		else
		{
			D16HugeMemSet( carto->fichier.bitmap, 0, len );
		}
	}

	len = (long) carto->convert.nb_octets + 4L;
	carto->fichier.reccord = D16MemAllocClear( (int unsigned) len, 0 );

	carto->longueur_ligne = 0;
	carto->ligne_data_act = -1;
	carto->ligne_actuelle = NULL;

	if ((carto->fichier.bitmap == NULL)
	|| (carto->fichier.reccord == NULL))
		return (OFF);

	return (ON);
}



/***********************************************************/
#pragma message("get_ligne_carto")
/*
#COM get_ligne_carto : Renvoie le pointeur sur la ligne de carto demande. La lit sur disque ou non en fonction
#COM 							de si elle est en mmoire ou non
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

char * get_ligne_carto( struct s_data_carto *carto )
{
	struct s_index_carto *idx;
	int sens;
//-----------------------------------------------------------
	if (carto->fichier.bitmap == NULL)
		return (NULL);

	if (carto->num_ligne_data >= carto->fichier.nb_lignes_data)
		return (NULL);

	if (carto->num_ligne_data != carto->ligne_data_act)
	{
		if ((idx = get_index_carto( carto )) == NULL)
			return (NULL);

		carto->ligne_data_act = carto->num_ligne_data;
		carto->longueur_ligne = idx->longueur;
		carto->offset_ligne = idx->offset;

		if (carto->longueur_ligne > carto->largeur_maxi_ligne)
		{
			carto->ligne_actuelle = NULL;
			carto->ligne_data_act = -1;
			return (NULL);
		}

		if (carto->fichier.flags.data_en_memoire)
		{
			carto->ligne_actuelle = carto->fichier.bitmap[carto->num_ligne_data];
		}
		else
		{
			lseek( carto->fichier.handle, idx->position, 0 );
			D16HugeRead( carto->fichier.handle, carto->fichier.bitmap, (long) idx->longueur * carto->convert.nb_octets + carto->fichier.taille_block_fin_de_ligne );
			carto->ligne_actuelle = (char *) carto->fichier.bitmap;

			if (get_valeur_peigne( carto->num_ligne_data, carto ))
				bouche_peigne( (long) carto->longueur_ligne, carto->ligne_actuelle, carto );
		}
	}

	return (carto->ligne_actuelle);
}


/***********************************************************/
#pragma message("get_index_carto")
/*
#COM get_index_carto : Renvoie le pointeur sur l'index de la ligne de carto demande. La lit sur disque ou non en fonction
#COM 							de si elle est en mmoire ou non
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

struct s_index_carto * get_index_carto( struct s_data_carto *carto )
{
	static struct s_index_carto idx;
	long val_seek;
//---------------------------------------------------------------
	if (carto->num_ligne_data >= carto->fichier.nb_lignes_data)
		return (NULL);

	if (carto->fichier.index != NULL && carto->fichier.flags.index_en_memoire)
	{
		//Ligne non acquise.
		if (carto->fichier.index[carto->num_ligne_data].position < carto->fichier.offset_data)
			return NULL;

		return (&carto->fichier.index[carto->num_ligne_data]);
	}
	else
	{
		if (carto->fichier.handle == -1)
			return (NULL);
		val_seek = ((long) carto->num_ligne_data << SHIFT_INDEX_CARTO) + (long) carto->fichier.offset_index;

		if (lseek( carto->fichier.handle, val_seek, 0 ) != val_seek)
			return NULL;

		if (read( carto->fichier.handle, &idx, sizeof (idx) ) != sizeof (idx))
			return NULL;

		if (idx.position < 0)
			return NULL;

		idx.position += carto->fichier.offset_data;
		return (&idx);
	}
}


/***********************************************************/
#pragma message("get_index_carto_fast")
/*
#COM get_index_carto : Renvoie le pointeur sur l'index de la ligne de carto demande. La lit sur disque ou non en fonction
#COM 							de si elle est en mmoire ou non
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

struct s_index_carto * get_index_carto_fast( int unsigned num_ligne_data, struct s_data_carto *carto )
{
	static struct s_index_carto idx;
//---------------------------------------------------------------
	if (num_ligne_data >= carto->fichier.nb_lignes_data)
		return (NULL);

	if (carto->fichier.index != NULL && carto->fichier.flags.index_en_memoire)
	{
		return (&carto->fichier.index[num_ligne_data]);
	}
	else
	{
		if (carto->fichier.handle == -1)
			return (NULL);

		lseek( carto->fichier.handle, ((long) num_ligne_data << SHIFT_INDEX_CARTO) + (long) carto->fichier.offset_index, 0 );
		read( carto->fichier.handle, &idx, sizeof (idx) );
		idx.position += carto->fichier.offset_data;
		return (&idx);
	}
}

void *get_addr_carto_base( int x, int y, struct s_data_carto * carto )
{
	long len;
	char * ligne;
//-----------------------------------------------------
	carto->num_ligne_data = y;
	if ((ligne = get_ligne_carto( carto )) == NULL)
		return (NULL);

	x -= carto->offset_ligne;
	if (x >= carto->longueur_ligne || x < 0)
		return (NULL);

	len = (long) x * (long) carto->convert.nb_octets;
	ligne = PT_HUGE_CHAR(ligne, len);

	return ((void *) ligne);
}

/***********************************************************/
#pragma message("get_addr_carto_fast")
/*
#COM get_addr_carto : Renvoie le pointeur sur la valeur stocke
#COM 
#COM         IN: position x,y en pas d'acquisition, structure de data_carto
#COM 					ou NULL si impossible !
#COM        OUT:
#COM  
*/

void * get_addr_carto_base_fast( int x, int y, struct s_data_carto * carto )
{
	long len, pos;
	char * ligne = NULL;
	struct s_index_carto *idx;
//-----------------------------------------------------------
	carto->num_ligne_data = y;

	if (carto->fichier.flags.data_en_memoire)
		ligne = get_addr_carto_base( x, y, carto );
	else if (carto->num_ligne_data == carto->ligne_data_act)
		ligne = get_addr_carto_base( x, y, carto );
	else
	{
		if (carto->fichier.reccord == NULL)
			return (NULL);

		if (carto->num_ligne_data >= carto->fichier.nb_lignes_data)
			return (NULL);

		if ((idx = get_index_carto( carto )) == NULL)
			return (NULL);

		if (idx->longueur > carto->largeur_maxi_ligne)
			return (NULL);

		// Modif EB 19/8/99
		carto->offset_ligne = idx->offset;

		x -= carto->offset_ligne;
		if (x >= idx->longueur || x < 0)
			return (NULL);

		carto->offset_ligne = 0;
		carto->longueur_ligne = 0;
		carto->ligne_data_act = -1;
		carto->ligne_actuelle = NULL;

		ligne = (char *) carto->fichier.reccord;
		len = (long) x * (long) carto->convert.nb_octets;
		pos = idx->position + len;

		lseek( carto->fichier.handle, pos, 0 );
		D16HugeRead( carto->fichier.handle, ligne, (long) 1 * carto->convert.nb_octets );
	}

	return ((void *) ligne);
}

/***********************************************************/
#pragma message("get_addr_carto")
/*
#COM get_addr_carto : Renvoie le pointeur sur la valeur stocke
#COM 
#COM         IN: position x,y en pas d'acquisition, structure de data_carto
#COM 					ou NULL si impossible !
#COM        OUT:
#COM  
*/

void *get_addr_carto( int fast, int x, int y, struct s_data_carto * carto )
{
	if (fast)
		return get_addr_carto_base( x, y, carto );
	else
		return get_addr_carto_base_fast( x, y, carto );
}

/***********************************************************/
#pragma message("get_stockage_carto")
/*
#COM get_stockage_carto : Renvoie dans (long) la valeur stocker brute
#COM 
#COM         IN: position x,y en pas d'acquisition, structure de data_carto
#COM 					ou (erreur_stockage) si impossible !
#COM        OUT:
#COM  
*/

long get_stockage_carto( int fast, int x, int y, struct s_data_carto *carto )
{
	long mesure = 0;
	void * pt = NULL;
//-----------------------------------------------------
	if (! (pt = get_addr_carto( fast, x, y, carto )))
		return (carto->convert.erreur_stockage);

	mesure = get_stockage_from_pt( pt, &carto->convert );

	return mesure;
}

/***********************************************************/
#pragma message("get_valeur_carto")
/*
#COM get_valeur_carto : Renvoie la valeur en 1 point de la carto demande.
#COM 
#COM         IN: position x,y en pas d'acquisition, structure de data_carto
#COM             
#COM 
#COM        OUT:
#COM  
*/

long get_valeur_carto( int fast, int x, int y, struct s_data_carto *carto )
{
	void * pt;
	long mesure = 0;
//-----------------------------------------------------
	if (! (pt = get_addr_carto( fast, x, y, carto )))
		return (carto->convert.erreur_mesure);

	conv_stockage_to_mesure( &mesure, pt, &carto->convert );

	return (mesure);
}

double get_fvaleur_carto( int fast, int x, int y, struct s_data_carto * carto )
{
	void * pt;
	long   mesure = 0;
	double valeur = 0;
//-----------------------------------------------------
	mesure = get_valeur_carto( fast, x, y, carto );
	valeur = conv_mesure_to_fmesure( mesure, &carto->convert );
	return (valeur);
}

int set_valeur_carto( int fast, int x, int y, struct s_data_carto *carto, long mesure )
{
	void * pt;
//-----------------------------------------------------
	if (! (pt = get_addr_carto( fast, x, y, carto )))
		return OFF;

	conv_mesure_to_stockage( mesure, pt, &carto->convert );
	return ON;
}

int set_fvaleur_carto( int fast, int x, int y, struct s_data_carto *carto, double mesure )
{
	void * pt;
//-----------------------------------------------------
	if (! (pt = get_addr_carto( fast, x, y, carto )))
		return OFF;

	conv_fmesure_to_stockage( mesure, pt, &carto->convert );
	return ON;
}


/***********************************************************/
#pragma message("write_index_carto")
/*
#COM write_index_carto : Ecrit l'index de la carto dans le fichier
#COM
#COM         IN: carto->ligne_data_act 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void write_index_carto(struct s_data_carto *carto, struct s_index_carto * idx)
{
	struct s_index_carto idxw;
	long position;
//-----------------------------------------------------------
	// modif eb 09/12/2003
	if (carto->fichier.handle == -1)
	{
		sprintf( Buffer_Print, "Erreur accs  l'index de %s handle incorrect.\n", carto->fichier.nom );
		print_etat( Buffer_Print, PRINT_ERREUR_GRAVE );
		return;
	}

	if (carto->ligne_data_act >= carto->nb_lignes_total)
	{
		sprintf( Buffer_Print, "Erreur index de %s n de ligne incorrect.\n", carto->fichier.nom );
		print_etat( Buffer_Print, PRINT_ERREUR_GRAVE );
		return;
	}
//-----------------------------------------------------------

	idxw = *idx;
	idxw.position -= carto->fichier.offset_data;
	position = ((long) carto->ligne_data_act << SHIFT_INDEX_CARTO) + (long) carto->fichier.offset_index;
	if (lseek( carto->fichier.handle, position, 0 ) != position)
	{
		sprintf( Buffer_Print, "Erreur seek accs  l'index de %s.\n", carto->fichier.nom );
		print_etat( Buffer_Print, PRINT_ERREUR_GRAVE );
	}
	if (write( carto->fichier.handle, &idxw, sizeof(struct s_index_carto) ) != sizeof(struct s_index_carto))
	{
		sprintf( Buffer_Print, "Erreur d'criture accs  l'index de %s.\n", carto->fichier.nom );
		print_etat( Buffer_Print, PRINT_ERREUR_GRAVE );
	}

	if (carto->fichier.index != NULL && carto->fichier.flags.index_en_memoire)
	{
		carto->fichier.index[carto->ligne_data_act] = idxw;
	}
}


/***********************************************************/
#pragma message("write_data_carto")
/*
#COM write_data_carto : Ecrit data de la carto dans le fichier
#COM
#COM         IN: carto->ligne_data_act
#COM             
#COM 
#COM        OUT:
#COM  
*/

void write_data_carto(struct s_data_carto * carto, char * data)
{
	char * ligne;
	struct s_index_carto * idx;
//-----------------------------------------------------------
	if (carto->ligne_data_act >= carto->nb_lignes_total)
		return;

	if (carto->fichier.handle == -1)
		return;
//-----------------------------------------------------------
	carto->num_ligne_data = carto->ligne_data_act;
	if ((idx = get_index_carto( carto )) != NULL)
	{
		lseek( carto->fichier.handle, (long) idx->position, 0 );
		D16HugeWrite( carto->fichier.handle, data, idx->longueur * carto->convert.nb_octets );
		carto->offset_ligne = idx->offset;
		carto->longueur_ligne = idx->longueur;
	}

	if (ligne = get_ligne_carto( carto ))
	{
		if (ligne != data)
			D16HugeMemCpy( ligne, data, carto->longueur_ligne * carto->convert.nb_octets );
	}
}



/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

double position_mecanique_pixel_x( int x, struct s_affi_carto *carto)
{

}

/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

double position_mecanique_pixel_y( int y, struct s_affi_carto *carto)
{

}

/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int position_pixel_mecanique_x( double x, struct s_affi_carto *carto)
{

}

/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int position_pixel_mecanique_y( double y, struct s_affi_carto *carto)
{

}

/***********************************************************/
#pragma message("start_carto")
/*
#COM start_carto: Ouvre la cartographie en memoire
#COM 					(voir flags_data_carto). Rserve la place mmoire.
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

struct s_data_carto * start_carto( 	char * nom_fichier,   
												int data_en_memoire,
												struct s_convert_data * conv,
												long unsigned nb_colonne,
												long unsigned nb_ligne)
{
	unsigned i, c;
	int ret = OFF;

	long unsigned erreur;
	char unsigned stockageB, **dataB = NULL;
	int  unsigned stockageW, **dataW = NULL;
	long unsigned stockageL, **dataL = NULL;

	struct s_index_carto  * idx;
	struct s_data_carto * carto = NULL;
//-----------------------------------------------------
	if (carto = D16MemAllocClear( sizeof(struct s_data_carto), 0 ))
	{
		if (nom_fichier)
		{
			remplace( strupr( nom_fichier ), " ", "" );
			strcpy( carto->fichier.nom, nom_fichier );
			set_ext_fichier( carto->fichier.nom, ".DAT" );
		}

		carto->pas_horiz = 1;
		carto->pas_vert = 1;
		carto->axe_horiz = 0;
		carto->axe_vert = 0;
		carto->lettre_unite_meca_horiz[0] = '?';
		carto->lettre_unite_meca_vert[1] = 0;
		carto->lettre_unite_meca_vert[0] = '?';
		carto->lettre_unite_meca_horiz[1] = 0;

		carto->fichier.handle = -1;
		carto->fichier.flags.used = 1;

		carto->fichier.version = 100;
		carto->fichier.offset_index = OFFSET_INDEX;
		carto->fichier.offset_data = nb_ligne * sizeof(struct s_index_carto) + OFFSET_INDEX;

		carto->fichier.nb_lignes_data = 
		carto->nb_lignes_acquises = 
		carto->nb_lignes_total = nb_ligne;

		carto->largeur_carto = 
		carto->largeur_maxi_ligne = nb_colonne;

		carto->convert = *conv;

		if (carto->fichier.index = D16MemAllocClear( sizeof(struct s_index_carto ) * carto->fichier.nb_lignes_data, 0 ))
		{
			carto->fichier.flags.index_en_memoire = 1;

			for (i = 0;  i < carto->nb_lignes_total;  i++)
			{
				carto->num_ligne_data = i;
				if (idx = &carto->fichier.index[carto->num_ligne_data])
				{
					idx->offset = 0;
					idx->longueur = carto->largeur_carto;
					idx->position = (long) i * idx->longueur * carto->convert.nb_octets + carto->fichier.offset_data;
				}
			}

			if (malloc_carto( data_en_memoire, carto ))
			{
				ret = ON;
				if (carto->fichier.flags.data_en_memoire)
				{
					erreur = conv->erreur_stockage & conv->mask_stockage;
					switch (conv->nb_octets)
					{
					case 1:
						stockageB = erreur;
						dataB = (void *) carto->fichier.bitmap;
						for (i = 0;  i < carto->nb_lignes_total;  i++)
							for (c = 0;  c < nb_colonne;  c++)
								dataB[i][c] = stockageB;
						break;

					case 2:
						stockageW = erreur;
						dataW = (void *) carto->fichier.bitmap;
						for (i = 0;  i < carto->nb_lignes_total;  i++)
							for (c = 0;  c < nb_colonne;  c++)
								dataW[i][c] = stockageW;
						break;

					case 4:
						stockageL = erreur;
						dataL = (void *) carto->fichier.bitmap;
						for (i = 0;  i < carto->nb_lignes_total;  i++)
							for (c = 0;  c < nb_colonne;  c++)
								dataL[i][c] = stockageL;
						break;

					default:
						;
					}
				}
			}
		}

		if (ret == OFF)
		{
			close_carto( carto );
			D16MemFreeClear( (void **) &carto );
		}
	}

	return (carto);
}


/***********************************************************/
#pragma message("open_carto")
/*
#COM open_carto: Ouvre la cartographie et la lit si c'est demand. 
#COM 					(voir flags_data_carto). Rserve la place mmoire.
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int open_carto( char * nom_fichier, struct s_data_carto * carto )
{
	if (carto->fichier.flags.used)
		close_carto( carto );

	remplace( strupr( nom_fichier ), " ", "" );
	strcpy( carto->fichier.nom, nom_fichier );
	lire_carto( carto );
}


/***********************************************************/
#pragma message("close_carto")
/*
#COM close_carto: Libre la mmoire utilise par la carto
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int close_carto( struct s_data_carto * carto )
{
	if (carto->fichier.handle != -1)
		close( carto->fichier.handle );

	carto->fichier.handle = -1;

	if (carto->fichier.index)
	{
		D16MemFreeClear( &carto->fichier.index );
		carto->fichier.flags.index_en_memoire = 0;
	}

	free_carto( carto );
	carto->fichier.flags.used = 0;

	close_convert( &carto->convert );
}

//-----------------------------------------------------------------------------.

fermer_carto( struct s_affi_carto *carto )
{
	if (! carto)
		return (OFF);

	if (carto->data_carto->fichier.handle == -1)
		return (OFF);

	close_multi_objet( carto );
	close_carto( carto->data_carto );
	affiche_curseur_carto( FIN_CURSEUR_CARTO, &carto->curseur );

	memset( &carto->flags, 0, sizeof( struct s_flags_affi_carto ) );
	memset( carto->data_carto, 0, sizeof( struct s_data_carto ) );

	//EB le 22/01/02
//	memset( &carto->config, 0, sizeof( struct s_config_carto ) );
	carto->config.first_carto = 0;
	carto->config.en_memoire = 0;

	carto->data_carto->fichier.handle = -1;
	return (ON);
}


/***********************************************************/
#pragma message("sauve_carto")
/*
#COM sauve_carto: 
#COM 
#COM         IN: struct s_data_carto *
#COM             
#COM 
#COM        OUT: != 0 si OK
#COM  
*/

int sauve_carto( struct s_data_carto * carto )
{
	unsigned retour = OFF;
//----------------------------------------------------
	if (carto == NULL)
		return (retour);

	if (ecrire_descriptif_carto( carto ))
		if (sauve_index_carto( carto ))
			if (sauve_data_carto( carto ))
				retour = ON;

	return (retour);
}

/***********************************************************/
#pragma message("sauve_index_carto")
/*
#COM sauve_index_carto: 
#COM 
#COM         IN: struct s_data_carto *
#COM             
#COM 
#COM        OUT: != 0 si OK
#COM  
*/

int sauve_index_carto( struct s_data_carto * carto )
{
	unsigned int i;
	int handle, retour = OFF;

	struct s_attente at;
	struct s_index_carto * idx, idxsav;
//----------------------------------------------------
	if (carto == NULL)
		return (retour);

	at.cpt = 0;
	at.x = 100;
	at.y = 100;
	at.ecran = Screen_Out;
	at.commentaire = "Sauve Index Carto.";
	at.total = (unsigned long) carto->nb_lignes_total + 2;
//----------------------------------------------------
	handle = carto->fichier.handle;
	if (carto->fichier.handle == -1)
	{
		if (access( carto->fichier.nom, 0 ) == 0)
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY );
		}
		else
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY | O_CREAT, S_IWRITE | S_IREAD );
		}
	}

	if (carto->fichier.handle != -1)
	{
		retour = ON;
		attente( &at );

		lseek( carto->fichier.handle, carto->fichier.offset_index, 0 );
		for (i = 0;  i < carto->nb_lignes_total;  i++)
		{
			at.cpt++;
			attente( &at );
			carto->num_ligne_data = i;
			if ((idx = get_index_carto( carto )) != NULL)
			{
				idxsav = *idx;
				idxsav.position -= carto->fichier.offset_data;
				write( carto->fichier.handle, &idxsav, sizeof(struct s_index_carto) );
			}
		}
		at.cpt = at.total;
		attente( &at );
	}

	if (handle == -1)
	{
		close( carto->fichier.handle );
		carto->fichier.handle = -1;
	}

	return (retour);
}

/***********************************************************/
#pragma message("sauve_data_carto")
/*
#COM sauve_data_carto: 
#COM 
#COM         IN: struct s_data_carto *
#COM             
#COM 
#COM        OUT: != 0 si OK
#COM  
*/

int sauve_data_carto( struct s_data_carto * carto )
{
	unsigned int i;
	int handle, retour = OFF;

	char *ligne;
	struct s_attente at;
//----------------------------------------------------
	if (carto == NULL)
		return (retour);

	at.cpt = 0;
	at.x = 100;
	at.y = 100;
	at.ecran = Screen_Out;
	at.commentaire = "Sauve Data Carto.";
	at.total = (unsigned long) carto->nb_lignes_total + 2;
//----------------------------------------------------
	handle = carto->fichier.handle;
	if (carto->fichier.handle == -1)
	{
		if (access( carto->fichier.nom, 0 ) == 0)
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY );
		}
		else
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY | O_CREAT, S_IWRITE | S_IREAD );
		}
	}

	if (carto->fichier.handle != -1)
	{
		retour = ON;
		attente( &at );

		lseek( carto->fichier.handle, carto->fichier.offset_data, 0 );
		for (i = 0;  i < carto->nb_lignes_total;  i++)
		{
			at.cpt++;
			attente( &at );
			carto->num_ligne_data = i;
			if (ligne = get_ligne_carto( carto ))
			{
				D16HugeWrite( carto->fichier.handle, ligne, carto->longueur_ligne * carto->convert.nb_octets + carto->fichier.taille_block_fin_de_ligne );
			}
		}
		at.cpt = at.total;
		attente( &at );
	}

	if (handle == -1)
	{
		close( carto->fichier.handle );
		carto->fichier.handle = -1;
	}

	return (retour);
}


/***********************************************************/
#pragma message("lire_carto")
/*
#COM lire_carto:  Lit le dscriptif de la cartographie puis l'index et les datas
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void lire_carto( struct s_data_carto *carto )
{
	char * buffer = NULL;
//-------------------------------------------------------
	if (strlen( ltrim( rtrim( carto->fichier.nom ) ) ))
	{
		if ((buffer = lire_ascii_carto( &carto->fichier )) != NULL)
		{
			carto->offset_metre_x = 0;
			carto->offset_metre_y = 0;
			carto->lettre_unite_meca_horiz[0] = 0;
			carto->lettre_unite_meca_vert[0] = 0;

			read_write_carto( D_READ, buffer, carto );
			D16MemFreeClear( (void **) &buffer );

			if (*carto->lettre_unite_meca_horiz == 0)
			{
				carto->lettre_unite_meca_horiz[0] = '?';
				carto->lettre_unite_meca_horiz[1] = 0;
			}
			if (*carto->lettre_unite_meca_vert == 0)
			{
				carto->lettre_unite_meca_vert[0] = '?';
				carto->lettre_unite_meca_vert[1] = 0;
			}

			lire_index_carto( carto );
			lire_data_carto( carto );
			carto->fichier.flags.used = 1;
		}
	}
}

/***********************************************************/
#pragma message("read_write_carto")
/*
#COM read_write_carto: Lit et crit le descriptif de la carto
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void read_write_carto(  int ordre , char *buffer , struct s_data_carto *carto )
{
	int i;
	char buf[80];
	unsigned long maxi;
	int taille_pts_degagement = NB_POINTS_DEGAGEMENT_MAX * NB_COORD_DEGAGEMENT;
//-----------------------------------------------
	if (ordre == D_WRITE)
	{
		strcpy( buffer, "LOGISONIC: CARTO\n\n" );
		strcat( buffer, "ATTENTION: CECI N'EST PAS UN FICHIER TEXTE.\nNE PAS EDITER AVEC UN EDITEUR DE TEXTES.\n\n" );
	}

	fich( ordre | D_INT, buffer, "VERSION: ", &carto->fichier.version );
	fich( ordre | D_CHAR, buffer, "FICH BALAYAGE: ", &carto->fichier.balayage );

	//modif rvf le 18/03/96
	fich( ordre | D_CHAR, buffer, "FICH PARAMETRES: ", &carto->nom_fichier_parametres );
	//modif rvf le 28/03/97
	fich( ordre | D_CHAR, buffer, "FICH PALETTE: ", &carto->nom_fichier_palette );

	fich( ordre | D_INT, buffer, "NB LIGNES TOTALES: ", &carto->nb_lignes_total );
	fich( ordre | D_INT, buffer, "NB LIGNES ACQUISES: ", &carto->nb_lignes_acquises );
	fich( ordre | D_INT, buffer, "LARGEUR MAXI LIGNE: ", &carto->largeur_maxi_ligne );
	fich( ordre | D_INT, buffer, "LARGEUR CARTO: ", &carto->largeur_carto );

	fich( ordre | D_INT, buffer, "NB BALAYAGES TOTAL: ", &carto->nb_balayages_total );
	fich( ordre | D_INT, buffer, "NB BALAYAGES FAITS: ", &carto->nb_balayages_deja_faits );

//-----------------------------------------------------------------

	fich( ordre | D_INT, buffer, "TYPE CONTENU: ", &carto->convert.type );
	fich( ordre | D_LONG, buffer, "NB OCTETS: ", &carto->convert.nb_octets );

	carto->convert.old_type = carto->convert.type;
	if (ordre == D_READ)
		init_convert_data( &carto->convert );

	fich( ordre | D_INT, buffer, "VALEURS SIGNER: ", &carto->convert.signer );

	fich( ordre | D_LONG, buffer, "OFFSET VALEURS: ", &carto->convert.offset_stockage );
	fich( ordre | D_DOUBLE, buffer, "COEFF VALEURS: ", &carto->convert.coef );

	fich( ordre | D_LONG, buffer, "ERREUR MESURE: ", &carto->convert.erreur_mesure );
	fich( ordre | D_LONG, buffer, "MASQUE ERREUR MESURE: ", &carto->convert.masque_err_mesure );
	fich( ordre | D_LONG, buffer, "ERREUR STOCKAGE: ", &carto->convert.erreur_stockage );
	fich( ordre | D_LONG, buffer, "MASQUE ERREUR STOCKAGE: ", &carto->convert.masque_err_stockage );

	fich( ordre | D_CHAR, buffer, "FORMULE UNITE.........: ", &carto->convert.formule.txt_unite );
	fich( ordre | D_CHAR, buffer, "FORMULE DATA TO MESURE: ", &carto->convert.formule.txt_stockage_to_mesure );
	fich( ordre | D_CHAR, buffer, "FORMULE MESURE TO DATA: ", &carto->convert.formule.txt_mesure_to_stockage );

	if (ordre == D_READ)
		confirme_convert_data( &carto->convert );

//-------------------------------------------------------------------

	fich( ordre | D_DOUBLE, buffer, "ORIGINE X METRE: ", &carto->offset_metre_x );
	fich( ordre | D_DOUBLE, buffer, "ORIGINE Y METRE: ", &carto->offset_metre_y );

	fich( ordre | D_DOUBLE, buffer, "BORD MM : ", &carto->bord_carto );

	for (i = 0;  i < MAX_AXES;  i++)
	{
		fich( ordre | D_DOUBLE, buffer, chaine_rech( i, "REFERENCE (mm) ", buf ), &carto->reference[i] );
		fich( ordre | D_DOUBLE, buffer, chaine_rech( i, "ORIGINE (mm) ", buf ), &carto->origine[i] );
	}

//-----------------------------------------------------
// les polygones ne fonctionnent pas avec un pas negatif
// Modification ERIC 8 / 11 / 1995
// rsolution Pb retour sur pice avec un pas tous le temps positif
// Cration de deux flags d'inversion d'axe.

#if 0 //PV 29/01/97
	if (carto->axe_horiz_inverse || carto->pas_horiz < 0)
		carto->pas_horiz = -fabs( carto->pas_horiz );	// si le dplacement est en ngatif

	if (carto->axe_vert_inverse || carto->pas_vert < 0)
		carto->pas_vert = -fabs( carto->pas_vert );	// si le dplacement est en ngatif
#endif

	fich( ordre | D_DOUBLE, buffer, "PAS HORIZ (mm): ", &carto->pas_horiz );
	fich( ordre | D_DOUBLE, buffer, "PAS VERT (mm): ", &carto->pas_vert );

#if 0 //PV 29/01/97
	if (carto->pas_horiz < 0)
	{
		carto->axe_horiz_inverse = 1;
	}
	else
	{
		carto->axe_horiz_inverse = 0;
	}
	if (carto->pas_vert < 0)
	{
		carto->axe_vert_inverse = 1;
	}
	else
		carto->axe_vert_inverse = 0;

	carto->pas_horiz = fabs( carto->pas_horiz );
	carto->pas_vert = fabs( carto->pas_vert );
#endif
//---------------------------------------------------

	fich( ordre | D_INT, buffer, "AXE HORIZ: ", &carto->axe_horiz );
	fich( ordre | D_INT, buffer, "AXE VERT: ", &carto->axe_vert );

	fich( ordre | D_CHAR, buffer, "UNITE HORIZ: ", &carto->lettre_unite_meca_horiz );
	fich( ordre | D_CHAR, buffer, "UNITE VERT: ", &carto->lettre_unite_meca_vert );

	fich( ordre | D_INT, buffer, "VOIE: ", &carto->voie );
	fich( ordre | D_INT, buffer, "PORTE: ", &carto->porte );
	fich( ordre | D_INT, buffer, "NUM UNITE: ", &carto->num_unite );

	fich( ordre | D_INT, buffer, "OFFSET INDEX: ", &carto->fichier.offset_index );
	fich( ordre | D_LONG, buffer, "OFFSET DATA: ", &carto->fichier.offset_data );
	if (ordre & D_READ)
		carto->fichier.taille_block_fin_de_ligne = 0;
	fich( ordre | D_LONG, buffer, "BLOCK FIN LIGNE: ", &carto->fichier.taille_block_fin_de_ligne );

	for (i = 0;  i < MAX_FICHIERS_CARTO_ASSOCIES;  i++)
	{
		fich( ordre | D_CHAR, buffer, chaine_rech( i, "CARTOS ASSOCIEES ", buf ), carto->nom_cartos_associees[i] );
	}
	fich( ordre | D_CHAR, buffer, "TXT CONTENU CARTO: ", carto->contenu_carto );

	fich( ordre | D_FLAG, buffer, "PAS VARIABLE: ", &carto->fichier.flags.pas_variable );
	fich( ordre | D_FLAG, buffer, "POS PAR LIGNE: ", &carto->fichier.flags.position_par_ligne );
	fich( ordre | D_FLAG, buffer, "CARTO 2D: ", &carto->fichier.flags.carto_2d );

//TCO Le 28/08/2003 AF_2272
	if (ordre & D_READ)
		carto->fichier.flags.carto_3d = 0;
	fich( ordre | D_FLAG, buffer, "CARTO 3D: ", &carto->fichier.flags.carto_3d );

	fich( ordre | D_FLAG, buffer, "CONTENU PLUS SENS: ", &carto->fichier.flags.contenu_ligne_plus_sens );


	fich( ordre | D_INT, buffer, "AXE DEGAGEMENT: ", &carto->degagement.axe );
	fich( ordre | D_DOUBLE, buffer, "VALEUR DEGAGEMENT: ", &carto->degagement.valeur );


	fich( ordre | D_INT, buffer, "TAILLE PTS DEGAGE: ", &taille_pts_degagement );
	if (taille_pts_degagement != NB_POINTS_DEGAGEMENT_MAX * NB_COORD_DEGAGEMENT)
	{
		print_etat( "Erreur de version de fichier carto.\n", PRINT_ERREUR );
	}
	else
	{
		fich_tableau_double( ordre, buffer, "COORD PTS DEGAGE: ", (double *) carto->degagement.point, taille_pts_degagement );
		fich_tableau_int( ordre, buffer, "ACTIF PTS DEGAGE: ", (int *) carto->degagement.point_actif, taille_pts_degagement );
	}
}

/***********************************************************/
#pragma message("lire_ascii_carto")
/*
#COM lire_ascii_carto: Permet de lire les OFFSET_INDEX premier octets situs 
#COM 							Au dbut de ca carto et dcrivant son contenu
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

char * lire_ascii_carto(  struct s_fichier_carto *fichier )
{
	char * buffer;
	if ((buffer = D16MemAlloc( OFFSET_INDEX + 1 )) != NULL)
	{
		memset( buffer, 0, OFFSET_INDEX + 1 );
		if ((fichier->handle = open( fichier->nom, O_RDWR | O_BINARY )) != -1)
		{
			_dos_getftime( fichier->handle, &fichier->date, &fichier->time );
			read( fichier->handle, buffer, OFFSET_INDEX );
		}
		else
		{
			sprintf( buffer, "Fichier cartographie %s introuvable.\n", (char _FAR_DATA *) fichier->nom );
			(*Print)( buffer, PRINT_ERREUR );
			close( fichier->handle );
			fichier->handle = -1;
			D16MemFree( buffer );
			buffer = NULL;
		}
	}
	return (buffer);
}


/***********************************************************/
#pragma message("lire_index_carto")
/*
#COM lire_index_carto: Lire l'index de taille et positionnement de la carto
#COM 
#COM         IN: structure de la cartographie
#COM             
#COM 
#COM        OUT: -1 si chou, 0 si OK
#COM  
*/

int lire_index_carto( struct s_data_carto *carto )
{
	int i;
	char txt[255];

	if (carto->fichier.index)
	{
		D16MemFree( &carto->fichier.index );
		carto->fichier.flags.index_en_memoire = 0;

		// EB 14/01/2004
		carto->fichier.index = NULL;
	}
	carto->fichier.nb_lignes_data = carto->nb_lignes_total;

	if (carto->fichier.handle != -1)
	{
		if (carto->fichier.flags.demande_index_en_memoire)
		{
			if (carto->fichier.nb_lignes_data > 0xFFFFL / sizeof(struct s_index_carto ))
			{
				// Pour les cartographies dont l'index ne tient pas sur 64 K  
				carto->fichier.flags.index_en_memoire = 0;	//-> pas en mmoire
				sprintf( txt, "Carto '%s': Nb de lignes trop grand -> ne tient pas en mmoire.\n", (char _FAR_DATA *) carto->fichier.nom );
				(*Print)( txt, PRINT_ERREUR );
			}
			else
			{
				if ((carto->fichier.index = D16MemAlloc( sizeof(struct s_index_carto ) * carto->fichier.nb_lignes_data )) == NULL)
				{
					// Si la rservation en mmoire de l'index est chou -> pas en mmoire
					carto->fichier.flags.index_en_memoire = 0;	//-> pas en mmoire
					sprintf( txt, "Carto '%s': Nb de lignes trop grand ( plus assez de mmoire ).\n", (char _FAR_DATA *) carto->fichier.nom );
					(*Print)( txt, PRINT_ERREUR );
				}
				else
				{
					lseek( carto->fichier.handle, carto->fichier.offset_index, 0 );
					if (read( carto->fichier.handle, carto->fichier.index,
					sizeof(struct s_index_carto ) * carto->fichier.nb_lignes_data )
					!= sizeof(struct s_index_carto ) * carto->fichier.nb_lignes_data)
					{
						sprintf( txt, "Carto '%s': Erreur de lecture sur l'index.\n", (char _FAR_DATA *) carto->fichier.nom );
						(*Print)( txt, PRINT_ERREUR );
						D16MemFree( carto->fichier.index );
						carto->fichier.flags.index_en_memoire = 0;	//-> pas en mmoire
						carto->fichier.index = NULL;
						return (0);
					}
					carto->fichier.flags.index_en_memoire = 1;	//-> en mmoire
					for (i = 0;  i < carto->fichier.nb_lignes_data;  i++)
					{
						carto->fichier.index[i].position += carto->fichier.offset_data;
					}
				}
			}
		}
	}

}

/***********************************************************/
#pragma message("lire_data_carto")
/*
#COM lire_data_carto: lit les datas contenus dans la carto si c'est demand
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int lire_data_carto(  struct s_data_carto *carto )
{
	int i;
	long len;
	struct s_attente at;
	char commentaire[25];
//---------------------------------------------------------
	if (! carto->fichier.flags.index_en_memoire)
	{
		carto->fichier.flags.demande_data_en_memoire = 0;
	}

	if (carto->fichier.flags.demande_data_en_memoire && carto->fichier.handle != -1)
	{
		at.cpt = 0;
		at.x = 100;
		at.y = 100;
		at.ecran = Screen_Out;

		set_nom_fichier_chaine( commentaire, carto->fichier.nom, sizeof (commentaire) );
		at.commentaire = commentaire;
		at.total = carto->nb_lignes_acquises;

		if (malloc_carto( ON, carto ))
		{
			for (i = 0;  i < carto->nb_lignes_acquises;  i++)
			{
				if (carto->fichier.bitmap[i] == NULL)
					break;

				at.cpt = i;
				attente( &at );

				lseek( carto->fichier.handle, carto->fichier.index[i].position, 0 );
				read( carto->fichier.handle, carto->fichier.bitmap[i], (unsigned int) ((carto->fichier.index[i].longueur * carto->convert.nb_octets) + carto->fichier.taille_block_fin_de_ligne) );
				carto->ligne_actuelle = carto->fichier.bitmap[i];
				carto->ligne_data_act = i;
				carto->longueur_ligne = carto->fichier.index[i].longueur;
				if (get_valeur_peigne( i, carto ))
					bouche_peigne( (long) carto->longueur_ligne, carto->ligne_actuelle, carto );
			}
			at.cpt = at.total;
			attente( &at );
		}
	}

	if (! carto->fichier.flags.data_en_memoire)	// 4 octet de plus pour une lecture asm en Dword
		if (malloc_carto( OFF, carto ))
		{
		}

	carto->longueur_ligne = 0;
	carto->ligne_data_act = -1;
	carto->ligne_actuelle = NULL;
}



/***********************************************************/
#pragma message("creat_carto")
/*
#COM creat_carto:  Utilitaire crant une carto 'hard copy' de l'cran 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int creat_carto_hard_copy( char * nom_fichier )
{
	#define CARTO_HARD_COPY_X 640L
	#define CARTO_HARD_COPY_Y 480L

	int i;
	char *buffer;

	struct s_index_carto idx;
	struct s_data_carto carto;
//------------------------------------------------------
	memset( &carto, 0, sizeof (carto) );
	carto.fichier.offset_index = OFFSET_INDEX;
	carto.fichier.offset_data = CARTO_HARD_COPY_Y * sizeof(struct s_index_carto) + OFFSET_INDEX;
	strcpy( carto.fichier.nom, nom_fichier );
	carto.fichier.version = 100;
	carto.nb_lignes_acquises = CARTO_HARD_COPY_Y;
	carto.nb_lignes_total = CARTO_HARD_COPY_Y;
	carto.largeur_maxi_ligne = CARTO_HARD_COPY_X;
	carto.largeur_carto = CARTO_HARD_COPY_X;

	carto.convert.nb_octets = 1;

	carto.pas_horiz = carto.pas_horiz = 237.0 / 640.0;
	carto.pas_vert = carto.pas_vert = 178.0 / 480.0;
	carto.axe_horiz = 0;
	carto.axe_vert = 1;


	if ((carto.fichier.handle = open( nom_fichier, O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE )) != -1)
	{
		if ((buffer = D16MemAlloc( 10000 )) != NULL)
		{
			memset( buffer, 0, 10000 );
			read_write_carto( D_WRITE, buffer, &carto );

			buffer[OFFSET_INDEX - 3] = 0x0d;
			buffer[OFFSET_INDEX - 2] = 0x0a;
			buffer[OFFSET_INDEX - 1] = 0x1A;
			write( carto.fichier.handle, buffer, OFFSET_INDEX );

			idx.offset = 0;
			idx.longueur = CARTO_HARD_COPY_X;
			for (i = 0;  i < CARTO_HARD_COPY_Y;  i++)
			{
				idx.position = CARTO_HARD_COPY_X * i;
				write( carto.fichier.handle, &idx, sizeof(struct s_index_carto) );
			}

			for (i = 0;  i < CARTO_HARD_COPY_Y;  i++)
			{
				get_ligne_bitmap( Screen_Out, 0, i, (unsigned char *) buffer, (int) CARTO_HARD_COPY_X );
				write( carto.fichier.handle, buffer, (unsigned int) CARTO_HARD_COPY_X );
			}

			D16MemFree( buffer );
			buffer = NULL;
		}
		close( carto.fichier.handle );
		carto.fichier.handle = -1;
	}
}

/***********************************************************/
#pragma message("creat_carto_essai")
/*
#COM creat_carto:  Utilitaire crant une carto d'essai 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int creat_carto( char * nom_fichier )
{
	#define SINUSOIDE 0
	#define CARTO_ESSAIS_X 256L
	#define CARTO_ESSAIS_Y 100L

	char * buffer;
	unsigned int i, j;
	unsigned int t1, t2;

	struct s_data_carto carto;
	struct s_index_carto idx;

	memset( &carto, 0, sizeof (carto) );
	carto.fichier.offset_index = OFFSET_INDEX;
	carto.fichier.offset_data = CARTO_ESSAIS_Y * sizeof(struct s_index_carto) + OFFSET_INDEX;
	strcpy( carto.fichier.nom, nom_fichier );
	carto.fichier.version = 100;
	carto.nb_lignes_acquises = CARTO_ESSAIS_Y;
	carto.nb_lignes_total = CARTO_ESSAIS_Y;
	carto.largeur_maxi_ligne = CARTO_ESSAIS_X;
	carto.largeur_carto = CARTO_ESSAIS_X + SINUSOIDE;

	carto.convert.nb_octets = 1;
	carto.convert.type = TYPE_AMPLITUDE_US;
	init_convert_data( &carto.convert );

//	carto.convert.coef = 1;
//	carto.convert.offset_stockage = 0;

	carto.pas_horiz = 0.001;
	carto.pas_vert = 0.001;
	carto.axe_horiz = 0;
	carto.axe_vert = 1;
	strcpy( carto.lettre_unite_meca_horiz, "m" );
	strcpy( carto.lettre_unite_meca_vert, "" );

	if ((carto.fichier.handle = open( nom_fichier, O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE )) != -1)
	{
		if ((buffer = D16MemAlloc( 10000 )) != NULL)
		{
			switch (carto.convert.nb_octets)
			{
			case 1:

				carto.convert.coef = 1000.0 / 128.0;
				carto.convert.offset_stockage = -128;
				break;
			case 2:

				carto.convert.coef = 1.0;
				carto.convert.offset_stockage = 0;
				break;
			case 4:

				carto.convert.coef = 1.0;
				carto.convert.offset_stockage = 0;
				break;
			}

			memset( buffer, 0, (unsigned int) CARTO_ESSAIS_X );
			read_write_carto( D_WRITE, buffer, &carto );

			buffer[OFFSET_INDEX - 3] = 0x0d;
			buffer[OFFSET_INDEX - 2] = 0x0a;
			buffer[OFFSET_INDEX - 1] = 0x1A;
			write( carto.fichier.handle, buffer, OFFSET_INDEX );

			idx.offset = 0;
			idx.longueur = CARTO_ESSAIS_X;
			t1 = CARTO_ESSAIS_Y / 10;
			t2 = 0;

			for (i = 0;  i < CARTO_ESSAIS_Y;  i++)
			{
				if (i > t2)
				{
					printf( "%lf   \r", i * 100.0 / CARTO_ESSAIS_Y );
					t2 += t1;
				}
				idx.position = CARTO_ESSAIS_X * i * carto.convert.nb_octets;
				idx.offset = ((1 + sin( i / 20.0 )) * SINUSOIDE);
				idx.offset = 0;
				//				idx.longueur = CARTO_ESSAIS_X - idx.offset;
				write( carto.fichier.handle, &idx, sizeof(struct s_index_carto) );
			}
			D16MemFree( buffer );
		}

		if ((buffer = (void *) D16MemAlloc( (unsigned int) CARTO_ESSAIS_X * (unsigned int) carto.convert.nb_octets )) != NULL)
		{
			t2 = 0;
			memset( buffer, 0, (unsigned int) CARTO_ESSAIS_X );
			switch (carto.convert.nb_octets)
			{
			case 1:
/*
				for (i = 0;  i < CARTO_ESSAIS_Y;  i++)
				{
					for (j = 0;  j < CARTO_ESSAIS_X;  j++)
					{
						buffer[j] = sqrt( pow( j - CARTO_ESSAIS_X / 2.0, 2 ) + pow( i - CARTO_ESSAIS_Y / 2.0, 2 ) );
					}
					write( carto.fichier.handle, buffer, (unsigned int) CARTO_ESSAIS_X * carto.nb_octets );
				}
*/

				for (j = 0;  j < CARTO_ESSAIS_X;  j++)
					buffer[j] = (char) j;

/*
					if ((i > (CARTO_ESSAIS_Y * .3)) && (i < (CARTO_ESSAIS_Y * .7)))
						for (j = CARTO_ESSAIS_X * .3;  j <= CARTO_ESSAIS_X * .6;  j++)
							buffer[j] = 20;
*/

				for (i = 0;  i < CARTO_ESSAIS_Y;  i++)
				{
					write( carto.fichier.handle, buffer, (unsigned int) ((unsigned int) CARTO_ESSAIS_X * carto.convert.nb_octets) );
				}

				break;

			case 2:

				for (i = 0;  i < CARTO_ESSAIS_X;  i++)
				{
					((int *) buffer)[i] = (int) i - 5;	//* 10;
				}

				for (i = 0;  i < CARTO_ESSAIS_Y;  i++)
				{
					write( carto.fichier.handle, buffer, (unsigned int) ((unsigned int) CARTO_ESSAIS_X * carto.convert.nb_octets) );
				}
				break;

			case 4:

				for (i = 0;  i < CARTO_ESSAIS_X;  i++)
				{
					((long *) buffer)[i] = i * 2L - 500L;
				}

				for (i = 0;  i < CARTO_ESSAIS_Y;  i++)
				{
					write( carto.fichier.handle, buffer, (unsigned int) ((unsigned int) CARTO_ESSAIS_X * carto.convert.nb_octets) );
				}
				break;

			}

			D16MemFree( buffer );
			buffer = NULL;
		}
		close( carto.fichier.handle );
		carto.fichier.handle = -1;
	}
}


/***********************************************************/
#pragma message("multi_malloc_idx")
/*
#COM multi_malloc: Rserve un tableau de pt sur des chaines, de taille variable
#COM					 le tout > 64 K
#COM         IN: taille de chaque rservation, nb de rservations
#COM        OUT: void **
*/

void **  multi_malloc_idx(int nb_malloc, struct s_index_carto *idx, int nb_octets, long ajout)
{
	int num_malloc, i, j, nb_lignes_par_malloc, taille_D16malloc;
	int last_malloc = 0;
	long	pointeur = 0, old_pointeur;
	void  **tableau;
	char txt[255];
//---------------------------------------------------------------
	for (i = 0;  i < nb_malloc;  i++)
		pointeur += idx[i].longueur + VAL_MAX_PEIGNE * 4 + 4 + ajout;

	/*
	if ((D16ExtAvail( ) + D16LowAvail( )) < (pointeur + 128000L))
	{
		sprintf( txt, "Erreur Pas assez de mmoire pour rservation. %ld Demand, %ld Dispo.", pointeur + 128000, D16ExtAvail( ) + D16LowAvail( ) );
		(*Print)( txt, PRINT_ERREUR );
		return (NULL);
	} 
	*/

	tableau = D16MemAlloc( (nb_malloc + 1) * (sizeof(char *)) );	/*  reserve la place du tableau de pointeurs*/
	memset( tableau, 0, (nb_malloc + 1) * (sizeof(char *)) );

	pointeur = 0;
	num_malloc = 0;
	do	
	{							// i compte le  nb de malloc
		old_pointeur = pointeur;
		if (idx[num_malloc].position == LIGNE_NON_ACQUISE)
			break;

		pointeur += (long) (idx[num_malloc].longueur + VAL_MAX_PEIGNE) * nb_octets + 4 + ajout;	// asm move tjs en Dword !
		if (pointeur > 0xFFF0L)
		{
	      // On reserve par bloc les mallocs prcdents
			if ((pointeur = (long) D16MemAlloc( (unsigned int) old_pointeur )) == 0L)
			{
				multi_free( tableau );
				return (NULL);
			}
        	// remplit le tableau de pointeurs sur  pointeurs de lignes 
			for (i = last_malloc;  i < num_malloc;  i++)
			{
				tableau[i] = (char *) ((long) tableau[i] + pointeur);
			}
			pointeur = old_pointeur = 0;
			last_malloc = num_malloc;
		}
		else
		{
			tableau[num_malloc] = (char *) old_pointeur;
			num_malloc++;
		}
	}
	while (num_malloc < nb_malloc);

	if (pointeur != 0)
	{
		if ((pointeur = (long) D16MemAlloc( (unsigned int) pointeur )) == 0L)
		{
			multi_free( tableau );
			return ((void **) NULL);
		}
	  	// remplit le tableau de pointeurs sur  pointeurs de lignes 
		for (i = last_malloc;  i < num_malloc;  i++)
		{
			tableau[i] = (char *) ((long) tableau[i] + pointeur);
		}
	}
	tableau[num_malloc] = NULL;

	return (tableau);
}

/***********************************************************/
#pragma message("multi_malloc_idx")
/*
#COM multi_malloc: Met  0 un tableau de chaines, de taille variable
#COM					 le tout > 64 K
#COM         IN: tableau, index, nb octets
#COM        OUT: rien
*/

void  multi_raz_idx(void ** tableau, struct s_index_carto *idx, int nb_octets)
{
	int i;
	if (tableau != NULL && idx != NULL)
	{
		i = 0;
		while (tableau[i] != NULL)
		{
			memset( tableau[i], 0, idx[i++].longueur * nb_octets );
		}
	}
}


/***********************************************************/
#pragma message("affiche_curseur_carto")
/*
#COM affiche_curseur_carto: Gestion du curseur d'dition de la cartographie
#COM 
#COM         IN: Mettre  1 autorise_x et autorise_y AVANT l'INIT_CURSEUR_CARTO
#COM             Faire AUTORISE_CURSEUR_CARTO APRES l'INIT_CURSEUR_CARTO
#COM 
#COM        OUT:
#COM  
*/

void affiche_curseur_carto( int ordre, struct s_curseur_carto *curseur )
{
	int mem_aff;

	int xdh, xfh, lngx;
	int ydh, yfh, lngy;

	int xdv, xfv;
	int ydv, yfv;

	static struct s_attributs att = {0, 0, 0, 0, 0xff, 0xFFFF, 1, 0L};
//---------------------------------------------------------------
	if (curseur->buffer_sav)
	{
		att.mode = REPLACE;
		att.couleur = curseur->couleur;
	}
	else
	{
		att.mode = XOR;
	}
//---------------------------------------------------------------
	switch (ordre)
	{
	case INIT_CURSEUR_CARTO:
		if (curseur->buffer_sav)
			affiche_curseur_carto( FIN_CURSEUR_CARTO, curseur );
		/*Modif EB 04/12/2001 bug inconu lng_x peur tre infrieur  0 */
		if (curseur->lng_x > 0)
		{
			if (curseur->buffer_sav = D16MemAllocClear( (curseur->lng_x + 1) * 2 + (curseur->lng_y + 1) * 2, 0 ))
			{
				if (curseur->autorise_x)
					curseur->buf1 = curseur->buffer_sav;	// Pour le trait en x
				else
					curseur->buf1 = NULL;

				if (curseur->autorise_y)
					curseur->buf2 = curseur->buffer_sav + curseur->lng_x + 1;	// Pour le trait en y
				else
					curseur->buf2 = NULL;

				if (curseur->autorise_x && curseur->autorise_y)
				{
					curseur->buf3 = curseur->buf2 + curseur->lng_y + 1;	// Pour le trait en x du carr
					curseur->buf4 = curseur->buf3 + curseur->lng_x + 1;	// Pour le trait en y du carr
				}

			/*
			curseur->buf1 = curseur->buffer_sav;	// Pour le trait en x
			curseur->buf2 = curseur->buf1 + curseur->lng_x + 1;	// Pour le trait en y
			curseur->buf3 = curseur->buf2 + curseur->lng_y + 1;	// Pour le trait en x du carr
			curseur->buf4 = curseur->buf3 + curseur->lng_x + 1;	// Pour le trait en y du carr
			*/
			}
		}
		curseur->dessine = 0;
		curseur->autorise = 0;
		curseur->type = CURSEUR_NORMAL;
		break;

	case MODE_NORMAL_CURSEUR_CARTO:
		if (curseur->type != CURSEUR_NORMAL)
		{
			if (curseur->dessine)
			{
				affiche_curseur_carto( EFFACE_CURSEUR_CARTO, curseur );
				curseur->type = CURSEUR_NORMAL;
				affiche_curseur_carto( DESSINE_CURSEUR_CARTO, curseur );
			}
			else
			{
				curseur->type = CURSEUR_NORMAL;
			}
		}
		break;

	case AUTORISE_CURSEUR_CARTO:
		curseur->autorise = 1;
		break;

	case INTERDIT_CURSEUR_CARTO:
		if (curseur->dessine)
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, curseur );

		curseur->autorise = 0;
		break;

	case MODE_CARRE_CURSEUR_CARTO:
		if (curseur->type != CURSEUR_CARRE)
		{
			curseur->xc2 = curseur->xc1;
			curseur->yc2 = curseur->yc1;
			if (curseur->dessine)
			{
				affiche_curseur_carto( EFFACE_CURSEUR_CARTO, curseur );
				curseur->type = CURSEUR_CARRE;
				affiche_curseur_carto( DESSINE_CURSEUR_CARTO, curseur );
			}
			else
			{
				curseur->type = CURSEUR_CARRE;
			}
		}
		break;

	case DESSINE_CURSEUR_CARTO:
		if (curseur->dessine)
		{
			if (curseur->oxc1 == curseur->xc1 && curseur->oyc1 == curseur->yc1)
			{
				break;
			}
			else
			{
				affiche_curseur_carto( EFFACE_CURSEUR_CARTO, curseur );
			}
		}

		if (curseur->autorise)
		{
			xdh = curseur->xc1;
			ydh = curseur->yc1;

			if (curseur->buffer_sav != NULL)
			{
				if (curseur->buf1)
					get_ligne_bitmap( curseur->ecran, curseur->pos_x, ydh, curseur->buf1, curseur->lng_x + 1 );

				if (curseur->buf2)
					get_ligne_bitmap_vert( curseur->ecran, xdh, curseur->pos_y, curseur->buf2, curseur->lng_y + 1 );

			}
			if (curseur->autorise_x)
				line( curseur->ecran, curseur->pos_x, ydh, curseur->pos_x + curseur->lng_x, ydh, &att );

			if (curseur->autorise_y)
				line( curseur->ecran, xdh, curseur->pos_y, xdh, curseur->pos_y + curseur->lng_y, &att );

			curseur->oxc1 = xdh;
			curseur->oyc1 = ydh;

			if (curseur->autorise_x && curseur->autorise_y)
				if (curseur->type == CURSEUR_CARRE)
				{
					xfv = xdv = xfh = xdh = 0;
					yfh = ydh = yfv = ydv = 0;

					xdv += curseur->xc2;
					xfv += curseur->xc2;

					ydh += curseur->yc2;
					yfh += curseur->yc2;
					if (curseur->xc1 > curseur->xc2)
					{
						xdh += curseur->xc2;
						xfh += curseur->xc1;
						lngx = 0;
					}
					else
					{
						xdh += curseur->xc1 + 1;
						xfh += curseur->xc2;
						lngx = 1;
					}

					if (curseur->yc1 > curseur->yc2)
					{
						ydv += curseur->yc2;
						yfv += curseur->yc1;
						lngy = 0;
					}
					else
					{
						ydv += curseur->yc1 + 1;
						yfv += curseur->yc2;
						lngy = 1;
					}

					lngx += xfh - xdh;
					lngy += yfv - ydv;

					if (lngx > 0 && lngy > 0)
					{
						if (curseur->buffer_sav != NULL)
						{
							get_ligne_bitmap( curseur->ecran, xdh, ydh, curseur->buf3, lngx );
							get_ligne_bitmap_vert( curseur->ecran, xdv, ydv, curseur->buf4, lngy );
						}
						line( curseur->ecran, xdh, ydh, xfh, ydh, &att );
						line( curseur->ecran, xdv, ydv, xdv, yfv, &att );
					}
					curseur->oxdh = xdh;
					curseur->oxfh = xfh;
					curseur->oydh = ydh;
					curseur->oyfh = yfh;
					curseur->oxdv = xdv;
					curseur->oxfv = xfv;
					curseur->oydv = ydv;
					curseur->oyfv = yfv;
					curseur->olngx = lngx;
					curseur->olngy = lngy;
				}

			curseur->dessine = 1;
		}
		break;

	case EFFACE_CURSEUR_CARTO:
		if (curseur->dessine)
		{
			if (curseur->buffer_sav != NULL)
			{
				if (curseur->buf1)
					trace_ligne_bitmap( curseur->ecran, curseur->pos_x, curseur->oyc1, curseur->buf1, curseur->lng_x + 1 );

				if (curseur->buf2)
					trace_ligne_bitmap_vert( curseur->ecran, curseur->oxc1, curseur->pos_y, curseur->buf2, curseur->lng_y + 1 );

			}
			else
			{
				if (curseur->autorise_x)
					line( curseur->ecran, curseur->pos_x, curseur->oyc1, curseur->pos_x + curseur->lng_x, curseur->oyc1, &att );

				if (curseur->autorise_y)
					line( curseur->ecran, curseur->oxc1, curseur->pos_y, curseur->oxc1, curseur->pos_y + curseur->lng_y, &att );

			}
			if (curseur->autorise_x && curseur->autorise_y)
				if (curseur->type == CURSEUR_CARRE)
				{
					if (curseur->olngx > 0 && curseur->olngy > 0)
					{
						if (curseur->buffer_sav != NULL)
						{
							trace_ligne_bitmap( curseur->ecran, curseur->oxdh, curseur->oydh, curseur->buf3, curseur->olngx );
							trace_ligne_bitmap_vert( curseur->ecran, curseur->oxdv, curseur->oydv, curseur->buf4, curseur->olngy );
						}
						else
						{
							line( curseur->ecran, curseur->oxdh, curseur->oydh, curseur->oxfh, curseur->oydh, &att );
							line( curseur->ecran, curseur->oxdv, curseur->oydv, curseur->oxdv, curseur->oyfv, &att );
						}
					}
				}

			curseur->dessine = 0;
		}
		break;

	case FIN_CURSEUR_CARTO:
		if (curseur->dessine)
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, curseur );

		if (curseur->buffer_sav)
			D16MemFreeClear( (void **) &curseur->buffer_sav );

		break;

	default:
		break;
	}

}


/***********************************************************/
#pragma message("ecrire_descriptif_carto")
/*
#COM affiche_ligne_carto:  Ecriture du descriptif de la cartographie.
#COM         IN: 
#COM             
#COM 
#COM        OUT: 0 Si tout s'est bien pass 1 sinon.
#COM  
*/

int ecrire_descriptif_carto(struct s_data_carto * carto)
{
	char buffer[100];
	int handle, retour;
//----------------------------------------------------
	handle = carto->fichier.handle;
	if (carto->fichier.handle == -1)
	{
		if (access( carto->fichier.nom, 0 ) == 0)
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY );
		}
		else
		{
			carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY | O_CREAT, S_IWRITE | S_IREAD );
		}
	}

	if (carto->fichier.handle != -1)
	{
		_dos_getftime( carto->fichier.handle, &carto->fichier.date, &carto->fichier.time );
		retour = go_ecrire_descriptif_carto( carto );
	}
	else
	{
		sprintf( buffer, "Erreur d'accs au fichier '%s'.\n", (char _FAR_DATA *) carto->fichier.nom );
		(*Print)( buffer, PRINT_ERREUR_GRAVE );
		return (0);
	}

	if (handle == -1)
	{
		close( carto->fichier.handle );
		carto->fichier.handle = -1;
	}
	return (retour);
}

/***********************************************************/
#pragma message("go_ecrire_descriptif_carto")
/*
#COM affiche_ligne_carto:  Ecriture du descriptif de la cartographie.
#COM         IN: 
#COM             
#COM 
#COM        OUT: 0 Si tout s'est bien pass 1 sinon.
#COM  
*/

int go_ecrire_descriptif_carto(struct s_data_carto * carto)
{
	int l;
	char *buffer;
	char buffer_text[255];
//-----------------------------------------------------------
	if (carto->fichier.handle != -1)
	{
		if ((buffer = D16MemAllocBufferDisk( carto->fichier.offset_index )) == NULL)
		{
			(*Print)( "Pas assez de mmoire: sauvegarde impossible.\n", PRINT_ERREUR_GRAVE );
			return (0);
		}
		memset( buffer, 0, carto->fichier.offset_index );
		read_write_carto( D_WRITE, buffer, carto );

		buffer[carto->fichier.offset_index - 3] = 0x0d;
		buffer[carto->fichier.offset_index - 2] = 0x0a;
		buffer[carto->fichier.offset_index - 1] = 0x1A;

		lseek( carto->fichier.handle, 0, 0 );
		if ((l = write( carto->fichier.handle, buffer, carto->fichier.offset_index )) != carto->fichier.offset_index)
		{
			sprintf( buffer, "Erreur d'accs au fichier '%s'.\n", (char _FAR_DATA *) carto->fichier.nom );
			(*Print)( buffer, PRINT_ERREUR_GRAVE );
		}
		D16MemFree( buffer );
		buffer = NULL;
	}
	else
	{
		sprintf( buffer_text, "Erreur d'accs au fichier '%s'.\n", (char _FAR_DATA *) carto->fichier.nom );
		(*Print)( buffer_text, PRINT_ERREUR_GRAVE );
		return (0);
	}
	return (1);
}

/***********************************************************/
#pragma message("ecrire_init_index_carto")
/*
#COM ecrire_init_index_carto:  Initialise l'index de la cartographie  0.
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int ecrire_init_index_carto(struct s_data_carto * carto)
{
	struct s_index_carto idx;
	unsigned i;
	int handle;

	if (access( carto->fichier.nom, 0 ) == 0)
	{
		handle = open( carto->fichier.nom, O_RDWR | O_BINARY );
	}
	else
	{
		handle = open( carto->fichier.nom, O_RDWR | O_BINARY | O_CREAT, S_IWRITE | S_IREAD );
	}

	if (handle != -1)
	{
//		memset( &idx, 0xff, sizeof (idx) );
		memset( &idx, 0, sizeof (idx) );
		lseek( handle, carto->fichier.offset_index, 0 );
		for (i = 0;  i < carto->nb_lignes_total;  i++)
		{
			write( handle, &idx, sizeof (idx) );
		}
		close( handle );
	}
	else
	{
		(*Print)( "Erreur d'accs au fichier '", PRINT_ERREUR_GRAVE );
		(*Print)( carto->fichier.nom, PRINT_ERREUR_GRAVE );
		(*Print)( "'.\n", PRINT_ERREUR_GRAVE );
		return (0);
	}
	return (1);
}

export_carto_format_bmp(char *nom, struct s_affi_carto *carto_scr )
{
	int i	;
	int lng_y;
	int lng_x;
	int vert;
	int bleu;
	int rouge;
	int ecran;
	int handle;
	char *ligne;
	struct s_bmp bmp;
	struct s_lut_bmp lut;
	struct s_attente at;

	ecran = carto_scr->fenetre.ecran;
	lng_x = carto_scr->data_carto->largeur_carto;
	lng_y = carto_scr->data_carto->nb_lignes_total;

	at.cpt = 0;
	at.x = 100;
	at.y = 100;
	at.ecran = ecran;
	at.commentaire = "Exportation format BMP.";
	at.total = (unsigned long) lng_y;

	if ((carto_scr->asm.buffer_travail = D16MemAlloc( lng_x + 1 )) == NULL)
	{
		(*Print)( "Erreur: pas assez de mmoire pour convertir la carto en fichier BMP.\n", PRINT_ERREUR );
		return (0);
	}

	memset( &bmp, 0, sizeof(struct s_bmp) );
	bmp.lng_lecture = lng_x;
	if (bmp.lng_lecture % 4)
	{
		bmp.lng_lecture += (4 - (bmp.lng_lecture % 4));
	}

	bmp.entete.info_header.sizeimage = (long ) lng_y * (long ) bmp.lng_lecture;

	bmp.entete.file_header.type = 19778;
	bmp.entete.file_header.offbyte = sizeof(struct s_entete_bmp) + nb_couleurs_ecran( ecran ) * (long) sizeof(struct s_lut_bmp);
	bmp.entete.file_header.size = (long) bmp.entete.info_header.sizeimage + (long) bmp.entete.file_header.offbyte;

	bmp.entete.info_header.size = 40;
	bmp.entete.info_header.width = lng_x;
	bmp.entete.info_header.heigth = lng_y;
	bmp.entete.info_header.planes = 1;
	bmp.entete.info_header.bitcount = 8;
	bmp.entete.info_header.compression = 0;
	bmp.entete.info_header.xpixpermeter = 1.0 / carto_scr->data_carto->pas_horiz;
	bmp.entete.info_header.ypixpermeter = 1.0 / carto_scr->data_carto->pas_vert;
	bmp.entete.info_header.clrused = 0;
	bmp.entete.info_header.clrimportant = 0;

	if ((handle = open( nom, O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE )) != -1)
	{
		if (write( handle, &bmp.entete, sizeof (bmp.entete) ) == sizeof (bmp.entete))
		{
			lut.o = 0;
			for (i = 0;  i < nb_couleurs_ecran( ecran );  i++)
			{
				get_palette( ecran, i, &rouge, &vert, &bleu );
				lut.red = rouge;
				lut.green = vert;
				lut.bleu = bleu;
				write( handle, &lut, sizeof (lut) );
			}

			carto_scr->data_carto->ligne_data_act = -1;
			carto_scr->num_ligne_affi = lng_y - 1;
			attente( &at );
			for (i = 0;  i < lng_y;  i++)
			{
				at.cpt++;
				attente( &at );
				carto_scr->data_carto->num_ligne_data = carto_scr->num_ligne_affi;
				if ((ligne = get_ligne_carto( carto_scr->data_carto )) != NULL)
				{
					carto_scr->num_ligne_affi--;
					transforme_ligne_carto( carto_scr, ligne );
					write( handle, carto_scr->asm.buffer_travail, bmp.lng_lecture );
				}
			}
		}
		close( handle );
		at.cpt = at.total;
		attente( &at );
	}

}

int export_carto_format_logisonic(char *nom, struct s_affi_carto *carto_src)
{
	char *ligne;
	unsigned int i;
	struct s_attente at;
	struct s_data_carto *carto = NULL;

	if (! carto_src)
		return (0);

	if (! carto_src->data_carto)
		return (0);

	if (carto = start_carto( nom, OFF, &carto_src->data_carto->convert, carto_src->data_carto->largeur_carto, carto_src->data_carto->nb_lignes_total ))
	{
		at.cpt = 0;
		at.x = 100;
		at.y = 100;
		at.ecran = Screen_Out;
		at.commentaire = "Exportation carto en cours.";
		at.total = (unsigned long) carto->nb_lignes_total * 2L + 2;

		carto->pas_vert = carto_src->data_carto->pas_vert;
		carto->pas_horiz = carto_src->data_carto->pas_horiz;
		strcpy( carto->lettre_unite_meca_vert, carto_src->data_carto->lettre_unite_meca_vert );
		strcpy( carto->lettre_unite_meca_horiz, carto_src->data_carto->lettre_unite_meca_horiz );

		if (ecrire_descriptif_carto( carto ))
			if (sauve_index_carto( carto ))
			{
				if (carto->fichier.handle == -1)
				{
					if (access( carto->fichier.nom, 0 ) == 0)
					{
						carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY );
					}
					else
					{
						carto->fichier.handle = open( carto->fichier.nom, O_RDWR | O_BINARY | O_CREAT, S_IWRITE | S_IREAD );
					}
				}
				if (carto->fichier.handle != -1)
				{
					lseek( carto->fichier.handle, carto->fichier.offset_data, 0 );
					for (i = 0;  i < carto->nb_lignes_total;  i++)
					{
						at.cpt++;
						attente( &at );
						carto_src->data_carto->num_ligne_data = i;
						if (ligne = get_ligne_carto( carto_src->data_carto ))
							D16HugeWrite( carto->fichier.handle, ligne, carto_src->data_carto->longueur_ligne * carto->convert.nb_octets );

					}
					at.cpt = at.total;
					attente( &at );
					close_carto( carto );
					D16MemFreeClear( (void **) &carto );
				}
			}

	}
}

export_carto_format_excel(char *nom, struct s_affi_carto *carto_src)
{
	unsigned int x, y;
	long valeur, erreur;
	unsigned int nb_lignes_total, largeur_maxi_ligne;

	char *ligne;
	FILE *fichier;

	struct s_attente at;
	struct s_data_carto *data_carto;
//----------------------------------------------------
	if (carto_src == NULL)
		return (0);
	if ((data_carto = carto_src->data_carto) == NULL)
		return (0);

	nb_lignes_total = data_carto->nb_lignes_total;
	largeur_maxi_ligne = data_carto->largeur_maxi_ligne;

	at.cpt = 0;
	at.x = 100;
	at.y = 100;
	at.ecran = Screen_Out;
	at.total = (unsigned long) nb_lignes_total;
	at.commentaire = "Exportation carto en cours.";
//----------------------------------------------------
	if ((fichier = fopen( nom, "w+" )) != NULL)
	{
		erreur = data_carto->convert.erreur_mesure;
		for (y = 0;  y < nb_lignes_total;  y++)
		{
			at.cpt++;
			attente( &at );
			for (x = 0;  x < largeur_maxi_ligne;  x++)
			{
				valeur = get_valeur_carto( OFF, x, y, data_carto );
				if (valeur & erreur)
					valeur = 0;
				fprintf( fichier, "%ld \t", valeur );
			}
			fprintf( fichier, "\n" );
		}
	}
	fclose( fichier );
	fichier = 0L;
	at.cpt = at.total;
	attente( &at );
}

void calcule_taille_block_fin_de_ligne( struct s_fichier_carto *fichier_carto)
{
	fichier_carto->taille_block_fin_de_ligne = 0;
	if (fichier_carto->flags.pas_variable)
	{
		fichier_carto->taille_block_fin_de_ligne += sizeof(struct s_pas_variable);
	}
	if (fichier_carto->flags.position_par_ligne)
	{
		fichier_carto->taille_block_fin_de_ligne += sizeof(struct s_memo_position_axe) * 2;
	}
	if (fichier_carto->flags.contenu_ligne_plus_sens)
	{
		fichier_carto->taille_block_fin_de_ligne += sizeof(struct s_contenu_ligne_plus_sens);
	}

}

void sauve_block_fin_de_ligne( struct s_data_carto *pt_carto)
{
	unsigned long offset_block;
	struct s_memo_position_axe *memo_pos;
	void *pt_s, *pt_d;
	unsigned long lng;
	unsigned long taille_block_fin_de_ligne = 0;


	offset_block = (long) pt_carto->longueur_ligne * (long) pt_carto->convert.nb_octets;
	pt_d = (void *) ADD_PT_HUGE(pt_carto->ligne_actuelle, offset_block );

	if (pt_carto->fichier.flags.position_par_ligne)
	{
		pt_carto->pos_axes_debut_ligne.type_struct = BLOCK_POSITION_AXES_DEBUT_LIGNE;
		lng = pt_carto->pos_axes_debut_ligne.longueur_struct = sizeof(struct s_memo_position_axe);
		pt_s = &pt_carto->pos_axes_debut_ligne;

		taille_block_fin_de_ligne += lng;
		if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
		{
			print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", PRINT_ERREUR );
			return;
		}
		D16HugeMemCpy( pt_d, pt_s, lng );
		pt_d = (void *) ADD_PT_HUGE(pt_d , lng);

		pt_s = &pt_carto->pos_axes_fin_ligne;
		lng = pt_carto->pos_axes_fin_ligne.longueur_struct = sizeof(struct s_memo_position_axe);
		pt_carto->pos_axes_fin_ligne.type_struct = BLOCK_POSITION_AXES_FIN_LIGNE;
		taille_block_fin_de_ligne += lng;
		if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
		{
			print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", PRINT_ERREUR );
			return;
		}
		D16HugeMemCpy( pt_d, pt_s, lng );
		pt_d = (void *) ADD_PT_HUGE(pt_d , lng);
	}

	if (pt_carto->fichier.flags.pas_variable)
	{
		pt_s = &pt_carto->pas_ligne;
		pt_carto->pas_ligne.type_struct = BLOCK_PAS_LIGNE;
		lng = pt_carto->pas_ligne.longueur_struct = sizeof(struct s_pas_variable);
		pt_d = (void *) ADD_PT_HUGE(pt_carto->ligne_actuelle, offset_block + taille_block_fin_de_ligne);
		taille_block_fin_de_ligne += lng;
		if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
		{
			print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", PRINT_ERREUR );
			return;
		}
		D16HugeMemCpy( pt_d, pt_s, lng );
		pt_d = (void *) ADD_PT_HUGE(pt_d , lng);
	}

	if (pt_carto->fichier.flags.contenu_ligne_plus_sens)
	{
		pt_s = &pt_carto->contenu_ligne_plus_sens;
		pt_carto->contenu_ligne_plus_sens.type_struct = BLOCK_CONTENU_PLUS_SENS;
		lng = pt_carto->contenu_ligne_plus_sens.longueur_struct = sizeof(struct s_contenu_ligne_plus_sens);
		taille_block_fin_de_ligne += lng;
		if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
		{
			print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", PRINT_ERREUR );
			return;
		}
		D16HugeMemCpy( pt_d, pt_s, lng );
		pt_d = (void *) ADD_PT_HUGE(pt_d , lng);
	}
}

void get_block_fin_de_ligne( struct s_data_carto *pt_carto, int num_ligne)
{
	unsigned long offset_block;
	struct s_memo_position_axe *memo_pos;
	void *pt_so, *pt_do;
	unsigned long lng;
	int taille_block_fin_de_ligne = 0;
	int longueur_struct;
	void *ligne;
	enum e_block_fin_ligne_carto type_struct;

	pt_carto->num_ligne_data = num_ligne;
/*	if (num_ligne == 70)
		_( );*/
	if (ligne = get_ligne_carto( pt_carto ))
	{
		read_block_fin_de_ligne( pt_carto );
	}
}

int read_block_fin_de_ligne( struct s_data_carto *pt_carto)
{
#define TYPE_ERREUR PRINT_ERREUR
	unsigned long offset_block;
	struct s_memo_position_axe *memo_pos;
	void *pt_so, *pt_do;
	unsigned long lng;
	int taille_block_fin_de_ligne = 0;
	int longueur_struct;
	void *ligne;
	enum e_block_fin_ligne_carto type_struct;

	if ((ligne = pt_carto->ligne_actuelle) && (pt_carto->longueur_ligne > 0))
	{
		offset_block = (long) pt_carto->longueur_ligne * (long) pt_carto->convert.nb_octets;
		pt_so = (void *) ADD_PT_HUGE(ligne, offset_block );

		if (pt_carto->fichier.flags.position_par_ligne)
		{
			lng = sizeof(struct s_memo_position_axe);

			pt_do = &pt_carto->pos_axes_debut_ligne;

			taille_block_fin_de_ligne += lng;
			if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
			{
				print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", TYPE_ERREUR );
				return 0;
			}

			D16HugeMemCpy( pt_do, pt_so, lng );
			if (pt_carto->pos_axes_debut_ligne.type_struct != BLOCK_POSITION_AXES_DEBUT_LIGNE
			|| lng != pt_carto->pos_axes_debut_ligne.longueur_struct)
			{
				print_etat( "Erreur de lecture de block de fin de ligne, position axes dbut ligne.\n", TYPE_ERREUR );
				return 0;
			}
			pt_so = (void *) ADD_PT_HUGE(pt_so, lng );

			pt_do = &pt_carto->pos_axes_fin_ligne;
			lng = sizeof(struct s_memo_position_axe);
			taille_block_fin_de_ligne += lng;
			if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
			{
				print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", TYPE_ERREUR );
				return 0;
			}
			D16HugeMemCpy( pt_do, pt_so, lng );
			pt_so = (void *) ADD_PT_HUGE(pt_so, lng );
			if (pt_carto->pos_axes_fin_ligne.type_struct != BLOCK_POSITION_AXES_FIN_LIGNE
			|| lng != pt_carto->pos_axes_fin_ligne.longueur_struct)
			{
				print_etat( "Erreur de lecture de block de fin de ligne, position axes fin ligne.\n", TYPE_ERREUR );
				return 0;
			}
		}

		if (pt_carto->fichier.flags.pas_variable)
		{
			pt_do = &pt_carto->pas_ligne;
			pt_carto->pas_ligne.type_struct = BLOCK_PAS_LIGNE;
			lng = sizeof(struct s_pas_variable);
			taille_block_fin_de_ligne += lng;
			if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
			{
				print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", TYPE_ERREUR );
				return 0;
			}
			D16HugeMemCpy( pt_do, pt_so, lng );
			pt_so = (void *) ADD_PT_HUGE(pt_so, lng );
			if (pt_carto->pas_ligne.type_struct != BLOCK_PAS_LIGNE
			|| lng != pt_carto->pas_ligne.longueur_struct)
			{
				print_etat( "Erreur de lecture de block de fin de ligne, pas acqui.\n", TYPE_ERREUR );
				return 0;
			}
		}

		if (pt_carto->fichier.flags.contenu_ligne_plus_sens)
		{
			pt_do = &pt_carto->contenu_ligne_plus_sens;

			pt_carto->contenu_ligne_plus_sens.type_struct = BLOCK_CONTENU_PLUS_SENS;
			lng = sizeof(struct s_contenu_ligne_plus_sens);
			taille_block_fin_de_ligne += lng;
			if (taille_block_fin_de_ligne > pt_carto->fichier.taille_block_fin_de_ligne)
			{
				print_etat( "Erreur, taille de block de fin de ligne incorrect.\n", TYPE_ERREUR );
				return 0;
			}
			D16HugeMemCpy( pt_do, pt_so, lng );
			pt_so = (void *) ADD_PT_HUGE(pt_so, lng );

			if (pt_carto->contenu_ligne_plus_sens.type_struct != BLOCK_CONTENU_PLUS_SENS
			|| lng != pt_carto->contenu_ligne_plus_sens.longueur_struct)
			{
				print_etat( "Erreur de lecture de block de fin de ligne, contenu plus sens.\n", TYPE_ERREUR );
				return 0;
			}
		}
	}
	return 1;
}

#endif


