#include "..\soniscop\soniscop.aff"
#include "..\carto\aff_crto.cpl"

#if aff_crto_declare_asm
	// voir base_c.c
#endif

#if aff_crto_declare_c
	//voir lib_crto.inc -> "aff_crto.lib" 
	#include "..\carto\aff_crto.icc"
#endif

#if aff_crto_compile_icm

#include "..\lib\conf_pv.h"
#include "..\lib\instantc.h"
#include "..\lib\all_h.h"
                 
#if 0
#include "key.h"
#include "util.h"
#include "fonte.h"

#include "graphic.h"
#include "dialogue.h"
#include "echelles.h"
#include "formules.h"
#endif 

#include "..\lib\lib.lh"

#include "..\soniscop\soniscop.def"
#include "..\soniscop\soniscop.h"

//***************************************************
//***************************************************

#include "..\carto\carto.lh"

//***************************************************
//***************************************************
#if 0
#include "..\carto\mac_crto.h"
#include "..\carto\pal_def.hbx"
#include "..\carto\crto_gen.hbx"
#include "..\carto\crto_edt.hbx"
#include "..\carto\palettes.hbx"
#include "..\carto\pal_glis.hbx"
#include "..\carto\cfg_visu.hbx"
#include "..\carto\cfg_crto.hbx"
#include "..\carto\cfg_ec_c.hbx"

//***************************************************
//***************************************************

#pragma data_seg ("carto_data")

//***************************************************
//***************************************************
#endif
/*
	Ne pas dclarer de variable global ici,
	il faut les dclarer dans INI_CRTO.C (PV:31.07.98)
*/

//***************************************************
//***************************************************

void init_base_funct_carto()
{
	struct s_dialogue_carto * ret = NULL;

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_affiche_info_carto;

		strncpy( ret->nom, "Informations", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Informations", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Informations  propos de la cartographie.";
		ret->help_pays[ANGLAIS] = "Map informations.";
	}

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_config_carto;

		strncpy( ret->nom, "Cfg cartographie", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Map setup", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Paramtres de la cartographie (unites, echelles...).";
		ret->help_pays[ANGLAIS] = "Map units, scales...";
	}

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_config_visu;

		strncpy( ret->nom, "Cfg visualisation", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Display setup", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Options d'affichage de la cartographie.";
		ret->help_pays[ANGLAIS] = "Map setup display.";
	}

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_edit_palette_carto;

		strncpy( ret->nom, "Palette", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Palette color", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Edition de la palette de couleur et des seuils.";
		ret->help_pays[ANGLAIS] = "Tresholds color setup.";
	}

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_edit_palette_defaut;

		strncpy( ret->nom, "Palette dfaut", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Default palette", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Edition de la palette des donnes non valides.";
		ret->help_pays[ANGLAIS] = "Unavalaible values color palette.";
	}

	if (ret = install_funct_carto( ))
	{
		ret->function = dialogue_palette_glissante;

		strncpy( ret->nom, "Palette glissante", TAILLE_NOM_DIAL_CARTO );
		strncpy( ret->nom_pays[ANGLAIS], "Sliding palette", TAILLE_NOM_DIAL_CARTO );

		ret->help = "Palette glissante sur la cartographie.";
		ret->help_pays[ANGLAIS] = "Sliding palette color on cartographie.";
	}
}


/***********************************************************/
#pragma message("affiche_carto")
/*
#COM affiche_carto: Gestion de l'affichage de la cartographie. pour demander un 
#COM 					affichage, mettre affi_carto->flags.demande_trace_carto = 1
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void affiche_carto( struct s_affi_carto *affi_carto )
{
	int mouse;
	char *ligne;
	unsigned int time;
	unsigned int date;
//--------------------------------------------------------
	if ((affi_carto->flags.active) && (! affi_carto->flags.interdit_affichage_carto))
	{
		if (affi_carto->flags.demande_trace_carto)
		{
			if (affi_carto->data_carto)
			{
				if (affi_carto->data_carto->fichier.handle != -1)
				{
					close( affi_carto->data_carto->fichier.handle );
					if ((affi_carto->data_carto->fichier.handle = open( affi_carto->data_carto->fichier.nom, O_RDWR | O_BINARY )) != -1)
					{
						_dos_getftime( affi_carto->data_carto->fichier.handle, &date, &time );
						if (affi_carto->data_carto->fichier.time != time
						|| affi_carto->data_carto->fichier.date != date)
						{
							(*Print)( "Carto modifie: relecture du fichier.\n", PRINT_INFO );
							open_carto( affi_carto->data_carto->fichier.nom, affi_carto->data_carto );
							lecture_ascan_affi_carto( affi_carto );
						}
					}
					else
					{
						(*Print)( "Carto modifie mais relecture du fichier impossible.\n", PRINT_ERREUR );
					}
				}
			}

			//----------------------------------------------
			// Nouvelle demande de trace de cartographie ...

			affi_carto->flags.demande_trace_carto = 0;
			if (affi_carto->data_carto != NULL)
			{
				if (affi_carto->data_carto->fichier.flags.used)
				{
					// Initialisation de l'affichage
					affi_carto->flags.trace_en_cours = 1;
					//	locate( 60,2);
					//	printf( "in init_affiche_carto");
					init_affiche_carto( affi_carto );
					//	locate( 60,2);
					//	printf( "out init_affiche_carto");

					//RVF le 15/10/99
					creation_objet_carto_globale( affi_carto );
					creation_objet_zoom( affi_carto );
				}
			}
		}
		else
		{
			if (affi_carto->flags.trace_en_cours)
			{
				affi_carto->data_carto->num_ligne_data = affi_carto->num_ligne_affi;

				//	locate( 60,2);
				//	printf( "in get_ligne_carto");

				if ((ligne = get_ligne_carto( affi_carto->data_carto )) != NULL)
				{
					//locate( 60,2);
					//	printf( "out get_ligne_carto");

					if (affi_carto->menu.champs != NULL)
						hide_mouse_chp( &affi_carto->menu, &affi_carto->menu.champs[CADRE_CARTO] );

					affiche_ligne_carto( affi_carto, ligne );
					affi_carto->num_ligne_affi++;

					if (! affi_carto->flags.tracee)
					{
						if (affi_carto->num_ligne_affi == affi_carto->data_carto->nb_lignes_total)
						{
							fin_affiche_carto( affi_carto );
						}
					}
				}
				else
				{
					fin_affiche_carto( affi_carto );
				}
			}
		}
	}
	else
		affi_carto->flags.tracee = 0;

}

/***********************************************************/

int bouche_peigne( long longueur_ligne, char *ligne, struct s_data_carto *carto )
{
	int cpt;
	long len;
	long size_of_data;
	long size_of_ligne;
	void *buffer = NULL;
	void * pt_d, *pt_s;

	size_of_data = (long) carto->convert.nb_octets;
	size_of_ligne = size_of_data * longueur_ligne;
	if (longueur_ligne > abs( carto->compensation_peigne ))
	{
		len = ((long) longueur_ligne + VAL_MAX_PEIGNE) * size_of_data + 4L;

		if (len >= 0x10000)
			buffer = D16HugeAlloc( len );
		else
			buffer = (void **) D16MemAlloc( (unsigned int ) len );

		if (buffer)
		{
			D16HugeMemCpy( buffer, ligne, size_of_ligne );
			for (cpt = 0;  cpt < carto->compensation_peigne;  cpt++)
				conv_mesure_to_stockage( (long) carto->convert.erreur_mesure, (void *) (ligne + (cpt * size_of_data)), &carto->convert );

			D16HugeMemCpy( &ligne[cpt * size_of_data], buffer, size_of_ligne - cpt * size_of_data );

/*if(carto->fichier.taille_block_fin_de_ligne)
{
		pt_so = (void *) ADD_PT_HUGE(ligne, offset_block );
		D16HugeMemCpy( &ligne[size_of_ligne], buffer, size_of_ligne );
}
*/
			D16MemFreeClear( &buffer );
		}
	}

}


/***********************************************************/
#pragma message("fin_affiche_carto")
/*
#COM fin_affiche_carto:  Finit l'affichage de la carto. remplis en noir la fin 
#COM 							et libere la mmoire ncessaire pour le trac
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void fin_affiche_carto( struct s_affi_carto *affi_carto )
{
	int pixel;
	static struct s_attributs att = {0, 0, 0, 0, 0xff, 0xFFFF, 1, 0L};
	int mem_mono;
//------------------------------------------------------------
	affi_carto->flags.tracee = 1;
	affi_carto->flags.trace_en_cours = 0;
	reset_malloc_affiche_carto( affi_carto );
//------------------------------------------------------------


	//EB 22/01/02
	mem_mono = Ecran[affi_carto->fenetre.ecran].mode_monochrome;
	set_mode_monochrome( affi_carto->fenetre.ecran, 0 );

	att.couleur = att.fcouleur = affi_carto->config.fcouleur_carto;
	box( affi_carto->fenetre.ecran, affi_carto->asm.pos_x, affi_carto->asm.pos_y + affi_carto->asm.y,
	affi_carto->asm.pos_x + affi_carto->asm.lng_x, affi_carto->asm.pos_y + affi_carto->asm.lng_y,
	&att );

	if ((affi_carto->config.coupe_x) || (affi_carto->config.coupe_y))
	{
		if (affi_carto->coupe.bscan_epaisseur)
		{
			affi_carto->coupe.go_bscan_epaisseur = 1;
			affi_carto->curseur.xc2 = affi_carto->asm.pos_x;
			affi_carto->curseur.xc1 = affi_carto->curseur.xc2 + affi_carto->asm.lng_x;
			affi_carto->curseur.yc2 = affi_carto->asm.pos_y;
			affi_carto->curseur.yc1 = affi_carto->curseur.yc2 + affi_carto->asm.lng_y;
		}

		for (pixel = 0;  pixel < 1280;  pixel++)
			if (affiche_coupes_carto( affi_carto ))
				break;
	}

	dessin_objet_carto( affi_carto );
	set_mode_monochrome( affi_carto->fenetre.ecran, mem_mono );

}

/***********************************************************/
#pragma message("affiche_ligne_carto")
/*
#COM affiche_ligne_carto:  Affichage d'une ligne de la cartographie. est appel
#COM 								 par 'affiche_carto'.
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void affiche_ligne_carto( struct s_affi_carto *affi_carto, char *ligne )
{
	int fin_y;
	int zoom_x;
	unsigned char * buff_aff;
	static struct s_attributs att = {0, 0, 0, 0, 0xff, 0xFFFF, 1, 0L};
	int mem_mono;

//********************************************************************
	// EB le 1/3/2000
	if (affi_carto->flags.force_affichage_y)
	{
		affi_carto->asm.x = 0;
		affi_carto->asm.pos_x = affi_carto->fenetre.carto.x;
		affi_carto->asm.pos_y = affi_carto->fenetre.carto.y;
		affi_carto->asm.comp_y_act = 
		affi_carto->asm.y = affi_carto->num_ligne_affi * affi_carto->ech_pix_y;
		affi_carto->asm.comp_y_act <<= POS_VIRGULE_AFFI_CARTO;
		reset_ligne_carto( affi_carto );
	}

//*********************************************************************

	//	locate( 60,2);
	//	printf( "in affiche_ligne_ligne_carto   ");

	transforme_ligne_carto( affi_carto, ligne );
	//	locate( 60,2);
	//	printf( "out transforme_ligne_carto   ");

	if (affi_carto->asm.nb_pixels_affi > 0)
	{
		if (affi_carto->asm.inc_pix_x >= (1L << POS_VIRGULE_AFFI_CARTO))
		{
		 	// Zoom en X
			zoom_ligne_carto( &affi_carto->asm );
			//			locate( 60,2);
			//			printf( "out zoom_ligne_carto       ");
			zoom_x = 1;
		}
		else
		{
		 	// Compression en X
			compress_ligne_carto_x( &affi_carto->asm );
			//			locate( 60,2);
			//			printf( "out compress_ligne_carto    ");
			zoom_x = 0;
		}
	}

	att.couleur = affi_carto->config.fcouleur_carto;

	affi_carto->asm.comp_y_act += affi_carto->asm.inc_pix_y;
	fin_y = affi_carto->asm.comp_y_act >> POS_VIRGULE_AFFI_CARTO;
	if (affi_carto->asm.inc_pix_y >= (1L << POS_VIRGULE_AFFI_CARTO))
	{
	 	// Zoom en Y
		if (zoom_x)
		{
			buff_aff = (unsigned char *) affi_carto->asm.last_coul_zoom;
		}
		else
		{
			if (affi_carto->asm.mode_compression == MOYENNE)
			{
				calcule_moyenne_ligne_carto( &affi_carto->asm );
			}
			buff_aff = (unsigned char *) affi_carto->asm.last_coul_comp;
		}
		memset( buff_aff, att.couleur, affi_carto->asm.offset_dest );
		do	
		{
			affi_carto->asm.x = 0;
			affi_carto->asm.comp_x_act = 0;

			//	trace_ligne_bitmap_vert( affi_carto->fenetre.ecran, affi_carto->asm.pos_y + affi_carto->asm.y, affi_carto->asm.pos_x, buff_aff, affi_carto->asm.nb_pixels_affi );
			trace_ligne_bitmap( affi_carto->fenetre.ecran, affi_carto->asm.pos_x, affi_carto->asm.pos_y + affi_carto->asm.y, buff_aff, affi_carto->asm.nb_pixels_affi );

			//			locate( 60,2);
			//			printf( "out trace_ligne_bitmap");

//EB 22/01/02
			mem_mono = Ecran[affi_carto->fenetre.ecran].mode_monochrome;
			set_mode_monochrome( affi_carto->fenetre.ecran, 0 );

			line( affi_carto->fenetre.ecran,
			affi_carto->asm.pos_x + affi_carto->asm.nb_pixels_affi, affi_carto->asm.pos_y + affi_carto->asm.y,
			affi_carto->asm.pos_x + affi_carto->asm.lng_x, affi_carto->asm.pos_y + affi_carto->asm.y, &att );
			affi_carto->asm.y++;
			set_mode_monochrome( affi_carto->fenetre.ecran, mem_mono );

			if (affi_carto->asm.y > affi_carto->asm.lng_y)
			{
				fin_affiche_carto( affi_carto );
				break;
			}
		}
		while (affi_carto->asm.y <= fin_y);
		affi_carto->asm.y = fin_y;
		if (! zoom_x)
			reset_ligne_carto( affi_carto );

	}
	else
	{
		// Compression en Y
		if (zoom_x)
		{
			compress_ligne_carto_y( &affi_carto->asm );
		}
		if (fin_y != affi_carto->asm.y || affi_carto->flags.force_affichage_y)
		{
			if (affi_carto->asm.mode_compression == MOYENNE)
				calcule_moyenne_ligne_carto( &affi_carto->asm );

			memset( affi_carto->asm.last_coul_comp, att.couleur, affi_carto->asm.offset_dest );

			trace_ligne_bitmap( affi_carto->fenetre.ecran, affi_carto->asm.pos_x, affi_carto->asm.pos_y + affi_carto->asm.y, (unsigned char *) affi_carto->asm.last_coul_comp, affi_carto->asm.nb_pixels_affi );

//EB 22/01/02
			mem_mono = Ecran[affi_carto->fenetre.ecran].mode_monochrome;
			set_mode_monochrome( affi_carto->fenetre.ecran, 0 );

			line( affi_carto->fenetre.ecran,
			affi_carto->asm.pos_x + affi_carto->asm.nb_pixels_affi, affi_carto->asm.pos_y + affi_carto->asm.y,
			affi_carto->asm.pos_x + affi_carto->asm.lng_x, affi_carto->asm.pos_y + affi_carto->asm.y, &att );
			set_mode_monochrome( affi_carto->fenetre.ecran, mem_mono );

			reset_ligne_carto( affi_carto );
			if (affi_carto->flags.force_affichage_y)
			{
				affi_carto->asm.y++;
				affi_carto->flags.force_affichage_y = 0;
			}
			else
			{
				affi_carto->asm.y = fin_y;
			}
			if (affi_carto->asm.y > affi_carto->asm.lng_y)
			{
				fin_affiche_carto( affi_carto );
			}
		}
	}
	if (affi_carto->flags.force_affichage_y)
		affi_carto->flags.force_affichage_y = 0;

}

void transforme_ligne_carto( struct s_affi_carto *affi_carto, char *ligne )
{
	int offset_ligne;
	double nb_pix_affi;
//------------------------------------------------------------
	offset_ligne = affi_carto->data_carto->offset_ligne;

	// AFFICHE LE FOND EN CAS DE PEIGNE!
	/*
	if (affi_carto->compensation_peigne != 0)
	{
		if (affi_carto->num_ligne_affi & 1)
		{
			if (affi_carto->peigne_pair)
			{
				offset_ligne += affi_carto->compensation_peigne;
			}
		}
		else
		{
			if (! affi_carto->peigne_pair)
			{
				offset_ligne += affi_carto->compensation_peigne;
			}
		}
	}
   */
	affi_carto->asm.buffer_trace = ligne;

	if ((long) (affi_carto->asm.pointeur_affi = affi_carto->offset_carto_x - offset_ligne) < (long) affi_carto->data_carto->longueur_ligne)
	{
		if (affi_carto->asm.pointeur_affi < 0)
		{
			affi_carto->asm.offset_dest = -affi_carto->asm.pointeur_affi * affi_carto->ech_pix_x;
			affi_carto->asm.pointeur_affi = 0;
			if (affi_carto->asm.offset_dest > affi_carto->asm.lng_x)
				affi_carto->asm.offset_dest = affi_carto->asm.lng_x;
		}
		else
			affi_carto->asm.offset_dest = 0;

		affi_carto->asm.nb_acq_affi = affi_carto->data_carto->longueur_ligne - affi_carto->asm.pointeur_affi - 1;

		affi_carto->asm.pointeur_affi *= affi_carto->asm.nb_oct;

		nb_pix_affi = (double) affi_carto->asm.nb_acq_affi * affi_carto->ech_pix_x + affi_carto->asm.offset_dest;
		if (nb_pix_affi >= (double) affi_carto->asm.lng_x)
		{
			affi_carto->asm.nb_acq_affi = (affi_carto->asm.lng_x - affi_carto->asm.offset_dest) / affi_carto->ech_pix_x;
			affi_carto->asm.nb_pixels_affi = affi_carto->asm.lng_x;
		}
		else
		{
			affi_carto->asm.nb_pixels_affi = nb_pix_affi;
		}

		if (affi_carto->asm.nb_acq_affi < 0)
			affi_carto->asm.nb_acq_affi = 0;

		affi_carto->asm.nb_acq_affi++;	// Pour le zoom, faire le dernier pixel ( les prcautions ont t prises lors de la rservation mmoire )

		if (affi_carto->asm.nb_acq_affi > affi_carto->data_carto->longueur_ligne)
			affi_carto->asm.nb_acq_affi = affi_carto->data_carto->longueur_ligne;

		calcul_couleur_ligne_carto( &affi_carto->asm );
	}
	else
	{
		affi_carto->asm.offset_dest = 0;
		affi_carto->asm.pointeur_affi = 0;
		affi_carto->asm.nb_acq_affi = 0;
		affi_carto->asm.nb_pixels_affi = 0;
	}
}

/***********************************************************/
#pragma message("reset_ligne_carto")
/*
#COM reset_ligne_carto: Fait un reset des buffers ncessaires pour le trac.  
#COM 							Surtout en compression ( min, max et moyenne )
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void reset_ligne_carto( struct s_affi_carto *affi_carto)
{
	switch (affi_carto->asm.mode_compression)
	{
	case MINI:
		if (affi_carto->asm.last_coul_comp != NULL)
			memset( affi_carto->asm.last_coul_comp, 0xff, affi_carto->fenetre.carto.lng_x * 4 );
		break;

	case MAXI:
		if (affi_carto->asm.last_coul_comp != NULL)
			memset( affi_carto->asm.last_coul_comp, 0, affi_carto->fenetre.carto.lng_x * 4 );
		break;

	case MOYENNE:
		if (affi_carto->asm.last_coul_comp != NULL)
			memset( affi_carto->asm.last_coul_comp, 0, affi_carto->fenetre.carto.lng_x * 4 );
		if (affi_carto->asm.somme_coul != NULL)
			memset( affi_carto->asm.somme_coul, 0, affi_carto->fenetre.carto.lng_x * 2 );
		break;

	case SAUT:
		break;
	}
}

/***********************************************************/
#pragma message("reset_malloc_affiche_carto")
/*
#COM reset_malloc_affiche_carto: .
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

reset_malloc_affiche_carto( struct s_affi_carto *affi_carto )
{
	if (affi_carto->asm.buffer_travail != NULL)
		D16MemFreeClear( (void **) &affi_carto->asm.buffer_travail );

	if (affi_carto->asm.last_coul_comp != NULL)
		D16MemFreeClear( (void **) &affi_carto->asm.last_coul_comp );

	if (affi_carto->asm.last_coul_zoom != NULL)
		D16MemFreeClear( (void **) &affi_carto->asm.last_coul_zoom );

	if (affi_carto->asm.somme_coul != NULL)
		D16MemFreeClear( (void **) &affi_carto->asm.somme_coul );
}

/***********************************************************/
#pragma message("init_affiche_carto")
/*
#COM init_affiche_carto: Initialise tous les paramtres ncessaires pour l'affichage de la carto.
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void init_affiche_carto( struct s_affi_carto *affi_carto )
{
	int i;
	unsigned long maxi;
	unsigned lng_necessaire;
	static struct s_attributs _FAR_STATIC att = {0, 0, 0, REPLACE, 0xFF, 0xFFFF, 1, 0L};
//-----------------------------------------------------------------
	affi_carto->flags.tracee = 0;
	affi_carto->palette.unite.convert = &affi_carto->data_carto->convert;

	affi_carto->data_carto->peigne_pair = affi_carto->config.peigne_pair;
	affi_carto->data_carto->compensation_peigne = affi_carto->config.compensation_peigne;

	reset_malloc_affiche_carto( affi_carto );

	if ((affi_carto->echelle_x <= 0) || (affi_carto->echelle_x <= 0))
		affi_carto->echelle_y = affi_carto->echelle_x = 0.001;

	if ((affi_carto->ech_pix_y <= 0) || (affi_carto->ech_pix_y <= 0))
		affi_carto->ech_pix_y = affi_carto->ech_pix_x = 1;

	if (affi_carto->offset_carto_x < 0)
		affi_carto->offset_carto_x = 0;

	if (affi_carto->offset_carto_y < 0)
		affi_carto->offset_carto_y = 0;

	affi_carto->num_ligne_affi = affi_carto->offset_carto_y;

	affi_carto->config.mode_compression &= 03;
	affi_carto->asm.mode_compression = affi_carto->config.mode_compression;

	affi_carto->asm.x = affi_carto->asm.y = 0;
	affi_carto->asm.pos_x = affi_carto->fenetre.carto.x;
	affi_carto->asm.pos_y = affi_carto->fenetre.carto.y;
	affi_carto->asm.lng_x = affi_carto->fenetre.carto.lng_x;
	affi_carto->asm.lng_y = affi_carto->fenetre.carto.lng_y;

	affi_carto->asm.active = 1;
	affi_carto->asm.buffer_trace = NULL;
	affi_carto->asm.nb_oct = affi_carto->data_carto->convert.nb_octets;
	affi_carto->asm.mask_stockage = affi_carto->data_carto->convert.mask_stockage;
	affi_carto->asm.erreur_stockage = affi_carto->data_carto->convert.erreur_stockage;
	affi_carto->asm.mask_err_stockage = affi_carto->data_carto->convert.masque_err_stockage;
	affi_carto->asm.offset_palette_err = affi_carto->palette.offset_couleur_err;
	affi_carto->asm.nb_division_par_2 = affi_carto->palette.unite.nb_division_par_2;

	memset( affi_carto->asm.tab_err_couleur, affi_carto->palette.offset_couleur_err, sizeof (affi_carto->asm.tab_err_couleur) );
	for (i = 0;  i < affi_carto->palette.nb_couleurs_err;  i++)
		affi_carto->asm.tab_err_couleur[i] = i + affi_carto->palette.offset_couleur_err;

//------------------------------------------------------ Echelles
	if (affi_carto->config.unite_visu == UNITE_AFF_METRE)
	{
		if ((affi_carto->data_carto->pas_horiz) && (affi_carto->config.taille_ecran_x))
			affi_carto->ech_pix_x = affi_carto->echelle_x * (pixels_ecran_x( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_horiz )) / affi_carto->config.taille_ecran_x * 1000;

		if ((affi_carto->data_carto->pas_vert) && (affi_carto->config.taille_ecran_y))
			affi_carto->ech_pix_y = affi_carto->echelle_y * (pixels_visibles_y( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_vert )) / affi_carto->config.taille_ecran_y * 1000;

		affi_carto->ech_pix_x = min_max_double( affi_carto->ech_pix_x, 1.0 / 255.0, 255.0 );
		affi_carto->ech_pix_y = min_max_double( affi_carto->ech_pix_y, 1.0 / 255.0, 255.0 );
	}
	else if (affi_carto->config.unite_visu == UNITE_AFF_PIXEL)
	{
		if (pixels_ecran_x( affi_carto->fenetre.ecran ) * affi_carto->data_carto->pas_horiz)
			affi_carto->echelle_x = affi_carto->ech_pix_x / (pixels_ecran_x( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_horiz )) * affi_carto->config.taille_ecran_x / 1000;

		if (pixels_visibles_y( affi_carto->fenetre.ecran ) * affi_carto->data_carto->pas_vert)
			affi_carto->echelle_y = affi_carto->ech_pix_y / (pixels_visibles_y( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_vert )) * affi_carto->config.taille_ecran_y / 1000;

		if (pixels_ecran_x( affi_carto->fenetre.ecran ) * affi_carto->data_carto->pas_horiz)
			affi_carto->ech_pap_x = affi_carto->ech_pix_x / (pixels_ecran_x( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_horiz )) * affi_carto->config.taille_papier_x / 1000;

		if (pixels_visibles_y( affi_carto->fenetre.ecran ) * affi_carto->data_carto->pas_vert)
			affi_carto->ech_pap_y = affi_carto->ech_pix_y / (pixels_visibles_y( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_vert )) * affi_carto->config.taille_papier_y / 1000;
	}
	else if (affi_carto->config.unite_visu == UNITE_AFF_IMPRIMANTE)
	{
		if ((affi_carto->data_carto->pas_horiz) && (affi_carto->config.taille_papier_x))
			affi_carto->ech_pix_x = affi_carto->ech_pap_x * (pixels_ecran_x( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_horiz )) / affi_carto->config.taille_papier_x * 1000;

		if ((affi_carto->data_carto->pas_vert) && (affi_carto->config.taille_papier_y))
			affi_carto->ech_pix_y = affi_carto->ech_pap_y * (pixels_visibles_y( affi_carto->fenetre.ecran ) * fabs( affi_carto->data_carto->pas_vert )) / affi_carto->config.taille_papier_y * 1000;

		affi_carto->ech_pix_x = min_max_double( affi_carto->ech_pix_x, 1.0 / 255.0, 255.0 );
		affi_carto->ech_pix_y = min_max_double( affi_carto->ech_pix_y, 1.0 / 255.0, 255.0 );
	}

	affi_carto->asm.inc_pix_x = affi_carto->ech_pix_x * (1L << POS_VIRGULE_AFFI_CARTO);
	affi_carto->asm.inc_pix_y = affi_carto->ech_pix_y * (1L << POS_VIRGULE_AFFI_CARTO);

	affi_carto->asm.comp_y_act = 0;
	affi_carto->asm.avance_buffer = affi_carto->data_carto->convert.nb_octets;

//------------------------------------------------------ menu
	if (! affi_carto->flags.interdit_re_affichage_menu)
		if (affi_carto->menu.champs != NULL)
		{
			affi_carto->menu.champs[STATUS_CARTO].type.relief = 1;

			att.couleur = att.fcouleur = affi_carto->menu.couleur_fond_menu;
			box( affi_carto->menu.ecran, affi_carto->menu.x + EPAISSEUR_RELIEF, affi_carto->menu.y + EPAISSEUR_RELIEF, affi_carto->fenetre.carto.x, affi_carto->fenetre.carto.y, &att );
			box( affi_carto->menu.ecran, affi_carto->fenetre.carto.x + affi_carto->fenetre.carto.lng_x, affi_carto->menu.y + EPAISSEUR_RELIEF, affi_carto->menu.x + affi_carto->menu.lng_x - EPAISSEUR_RELIEF, affi_carto->fenetre.carto.y, &att );

			att.couleur = affi_carto->menu.couleur_ombre;
			att.fcouleur = affi_carto->menu.couleur_eclairee;
			relief( affi_carto->menu.ecran, affi_carto->fenetre.carto.x, affi_carto->fenetre.carto.y, affi_carto->fenetre.carto.x + affi_carto->fenetre.carto.lng_x, affi_carto->fenetre.carto.y + affi_carto->fenetre.carto.lng_y, RELIEF_OUT, &att );

			att.couleur = affi_carto->menu.couleur_ombre;
			att.fcouleur = affi_carto->menu.couleur_eclairee;
			relief( affi_carto->menu.ecran, affi_carto->menu.x, affi_carto->menu.y, affi_carto->menu.x + affi_carto->menu.lng_x, affi_carto->menu.y + affi_carto->menu.lng_y, RELIEF_IN, &att );
		}

	set_champs_affi_carto( affi_carto );

//---------------------------------------------------------- gestion mmoire

	if ((affi_carto->asm.buffer_travail = (char *) D16MemAlloc( (unsigned int) (affi_carto->data_carto->largeur_maxi_ligne + 1) )) == NULL)
	{
		fin_affiche_carto( affi_carto );
		close_carto( affi_carto->data_carto );
		(*Print)( "Erreur: pas assez de mmoire pour afficher la carto.\n", PRINT_ERREUR );
		return;
	}

	if ((affi_carto->asm.last_coul_comp = D16MemAlloc( (affi_carto->fenetre.carto.lng_x + 1) * 4 )) == NULL)
	{
		fin_affiche_carto( affi_carto );
		close_carto( affi_carto->data_carto );
		(*Print)( "Erreur: pas assez de mmoire pour afficher la carto.\n", PRINT_ERREUR );
		return;
	}

	// En zoom laisser la place de l'expantion du dernier pixel
	lng_necessaire = affi_carto->fenetre.carto.lng_x + affi_carto->ech_pix_x + 1;

	if ((affi_carto->asm.last_coul_zoom = D16MemAlloc( lng_necessaire )) == NULL)
	{
		fin_affiche_carto( affi_carto );
		close_carto( affi_carto->data_carto );
		(*Print)( "Erreur: pas assez de mmoire pour afficher la carto.\n", PRINT_ERREUR );
		return;
	}

	if ((affi_carto->asm.somme_coul = D16MemAlloc( (affi_carto->fenetre.carto.lng_x + 1) * 2 )) == NULL)
	{
		fin_affiche_carto( affi_carto );
		close_carto( affi_carto->data_carto );
		(*Print)( "Erreur: pas assez de mmoire pour afficher la carto.\n", PRINT_ERREUR );
		return;
	}

	reset_ligne_carto( affi_carto );

//------------------------------------------------------ coupe
	affi_carto->coupe.bscan_epaisseur = affi_carto->config.bscan_epaisseur;

//------------------------------------------------------ curseur
	affi_carto->curseur.autorise_x = affi_carto->config.curseur_x;
	affi_carto->curseur.autorise_y = affi_carto->config.curseur_y;

	if (affi_carto->curseur.autorise_x)
	{
		affi_carto->curseur.pos_x = affi_carto->fenetre.carto.x;
		if (affi_carto->config.echelle_y)
			affi_carto->curseur.lng_x = affi_carto->fenetre.ech_y.x - affi_carto->curseur.pos_x + affi_carto->fenetre.ech_y.lng_x;
		else
			affi_carto->curseur.lng_x = affi_carto->fenetre.carto.lng_x;
	}
	else
	{
		affi_carto->curseur.pos_x = 0;
		affi_carto->curseur.lng_x = 0;
	}

	if (affi_carto->curseur.autorise_y)
	{
		if (affi_carto->config.echelle_x)
		{
			affi_carto->curseur.pos_y = affi_carto->fenetre.ech_x.y;
			affi_carto->curseur.lng_y = affi_carto->fenetre.carto.y - affi_carto->fenetre.ech_x.y + affi_carto->fenetre.carto.lng_y;
		}
		else
		{
			affi_carto->curseur.pos_y = affi_carto->fenetre.carto.y;
			affi_carto->curseur.lng_y = affi_carto->fenetre.carto.lng_y;
		}
	}
	else
	{
		affi_carto->curseur.pos_y = 0;
		affi_carto->curseur.lng_y = 0;
	}
	affi_carto->curseur.ecran = affi_carto->fenetre.ecran;
	affi_carto->curseur.couleur = affi_carto->config.couleur_curseur;
  	//affi_carto->curseur.offset_x = affi_carto->curseur.offset_y = 0;

//------------------------------------------------------ unite
	if ((affi_carto->palette.unite.numero_unite_us < 0)
	|| (affi_carto->palette.unite.numero_unite_us > 3))
		affi_carto->palette.unite.numero_unite_us = 0;

	if (affi_carto->palette.unite.toutes_unites_us != NULL)
		affi_carto->palette.unite.unites_us = affi_carto->palette.unite.toutes_unites_us[affi_carto->palette.unite.numero_unite_us];
	else
		affi_carto->palette.unite.unites_us = 0L;

//------------------------------------------------------ palette
	if (! affi_carto->flags.interdit_re_calcule_palette)
		calcule_palette_carto( affi_carto );

// a sup VP 26/08/96 
//	set_palette_carto( affi_carto );

	if (! affi_carto->flags.interdit_re_affichage_menu)
		if ((affi_carto->menu.champs != NULL) && (affi_carto->config.palette))
			gere_petite_palette( affi_carto );

	if (affi_carto->curseur.autorise_x || affi_carto->curseur.autorise_y)
		affiche_curseur_carto( INIT_CURSEUR_CARTO, &affi_carto->curseur );
	else
		affiche_curseur_carto( FIN_CURSEUR_CARTO, &affi_carto->curseur );
}


/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void init_carto_champ( struct s_affi_carto *carto, struct s_dialogue *menu, struct s_champ *champ )
{

	carto->fenetre.ecran = menu->ecran;
	carto->fenetre.carto.x = menu->x + champ->pos_x;
	carto->fenetre.carto.y = menu->y + champ->pos_y;

	carto->fenetre.carto.lng_x = champ->lng_x - EPAISSEUR_RELIEF;
	carto->fenetre.carto.lng_y = champ->lng_y - EPAISSEUR_RELIEF;

}

/***********************************************************/
#pragma message("affiche_echelles_carto")
/*
#COM affiche_echelles_carto: Si echelles == 1 dans flags 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void affiche_echelles_carto( struct s_affi_carto *affi_carto )
{
	double pos1, pos2;
	struct s_echelle ech;

	if (affi_carto->config.echelle_x || affi_carto->config.echelle_y)
	{
		memset( &ech, 0, sizeof (ech) );

		ech.ecran = affi_carto->fenetre.ecran;

		ech.att_ech.fcouleur = affi_carto->config.fcouleur_echelles;
		ech.att_ech.couleur = affi_carto->config.couleur_echelles;
		ech.att_ech.mode = REPLACE;
		ech.att_ech.plan = 0xff;
		ech.att_ech.style = 0xffff;
		ech.att_ech.epaisseur = 1;

		ech.pos_x = affi_carto->fenetre.ech_x.x;
		ech.pos_y = affi_carto->fenetre.ech_x.y;
		ech.lng_x = affi_carto->fenetre.ech_x.lng_x;
		ech.lng_y = affi_carto->fenetre.ech_x.lng_y;

		clear_mouse( ech.ecran );

		//------------------------------------------------------------------------
      // calcul du dpart et de la largeur en mm acquisition

		strcpy( ech.type_unite, affi_carto->data_carto->lettre_unite_meca_horiz );

//	ech.depart = affi_carto->offset_carto_x * pas - affi_carto->offset_origine_x;
//	ech.largeur = affi_carto->fenetre.carto.lng_x / affi_carto->ech_pix_x * pas;
		pos1 = affi_carto->fenetre.carto.x;
		pos2 = pos1 + affi_carto->fenetre.carto.lng_x;
		pos1 = m_x_to_rm( pixel_x_to_m( ftoi( pos1 ), affi_carto ), affi_carto );
		pos2 = m_x_to_rm( pixel_x_to_m( ftoi( pos2 ), affi_carto ), affi_carto );
		ech.depart = pos1;
		ech.largeur = pos2 - pos1;

		ech.interieur = 1;
		ech.verticale = 0;
		if (affi_carto->config.echelle_x)
			affiche_echelle( &ech );

		ech.pos_x = affi_carto->fenetre.ech_y.x;
		ech.pos_y = affi_carto->fenetre.ech_y.y;
		ech.lng_x = affi_carto->fenetre.ech_y.lng_x;
		ech.lng_y = affi_carto->fenetre.ech_y.lng_y;

		//------------------------------------------------------------------------
      // calcul du dpart et de la largeur en mm acquisition

		strcpy( ech.type_unite, affi_carto->data_carto->lettre_unite_meca_vert );

//	ech.depart = affi_carto->offset_carto_y * pas - affi_carto->offset_origine_y;
//	ech.largeur = affi_carto->fenetre.carto.lng_y / affi_carto->ech_pix_y * pas;

		pos1 = affi_carto->fenetre.carto.y;
		pos2 = pos1 + affi_carto->fenetre.carto.lng_y;
		pos1 = m_y_to_rm( pixel_y_to_m( ftoi( pos1 ), affi_carto ), affi_carto );
		pos2 = m_y_to_rm( pixel_y_to_m( ftoi( pos2 ), affi_carto ), affi_carto );
		ech.depart = pos1;
		ech.largeur = pos2 - pos1;

		ech.interieur = 0;
		ech.verticale = 1;
		if (affi_carto->config.echelle_y)
			affiche_echelle( &ech );
	}
}

/***********************************************************/
#pragma message("affiche_coupes_carto")
/*
#COM affiche_coupe_carto:
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:	(!= 0) si trace des coupe fini.
#COM  
*/

int affiche_coupes_carto( struct s_affi_carto * affi_carto )
{
	int old_x;
	int old_y;
	int ligne;
	int inverse;
	int remplir;
	int maxpix, dessine_x, dessine_y;
	int pos_x, pos_y, y2, x2, ccls, fini;
	int x, y, i, j, ecran, nb_coul, off_coul, lng_x, lng_y;
	char * buf_strat = NULL;
	unsigned char *buffer = NULL;
	static struct s_attributs att = {GRIS, GRIS_FONCE, 0, REPLACE, 0xff, 0xFFFF, 1, 0L};
//-----------------------------------------------------
	ecran = affi_carto->fenetre.ecran;
	att.couleur = affi_carto->config.couleur_curseur;
	att.fcouleur = affi_carto->config.fcouleur_carto;
//-----------------------------------------------------
	fini = 1;
	dessine_x = dessine_y = 1;
	ligne = affi_carto->config.ligne_coupe;
	inverse = affi_carto->config.inverse_coupe;
	remplir = affi_carto->config.remplir_coupe;
//-----------------------------------------------------
//	if (! affi_carto->fenetre.active)
	//	return 0;

	if (! affi_carto->coupe.bscan_epaisseur)
	{
		ccls = 1;
		pos_x = affi_carto->pos_curseur_x;
		pos_y = affi_carto->pos_curseur_y;
	}
	else
	{
		remplir = 0;
		ccls = affi_carto->coupe.go_bscan_epaisseur;
		affi_carto->coupe.go_bscan_epaisseur = 0;

		if (ccls)
		{
			fini = 0;
			affi_carto->coupe.xc_bscan = affi_carto->curseur.xc2;
			affi_carto->coupe.yc_bscan = affi_carto->curseur.yc2;
		}
		else
		{
			if (affi_carto->coupe.xc_bscan <= affi_carto->curseur.xc1)
			{
				fini = 0;
				affi_carto->coupe.xc_bscan++;
			}
			else
				dessine_x = 0;

			if (affi_carto->coupe.yc_bscan <= affi_carto->curseur.yc1)
			{
				fini = 0;
				affi_carto->coupe.yc_bscan++;
			}
			else
				dessine_y = 0;
		}
		pos_x = affi_carto->coupe.xc_bscan;
		pos_y = affi_carto->coupe.yc_bscan;
	}
//-----------------------------------------------------
	if (ccls)
	{
		if (affi_carto->config.coupe_x)
			box( ecran, affi_carto->fenetre.mrg_x.x,
			affi_carto->fenetre.mrg_x.y,
			affi_carto->fenetre.mrg_x.x + 
			affi_carto->fenetre.mrg_x.lng_x,
			affi_carto->fenetre.mrg_x.y + 
			affi_carto->fenetre.mrg_x.lng_y, &att );

		if (affi_carto->config.coupe_y)
			box( ecran, affi_carto->fenetre.mrg_y.x,
			affi_carto->fenetre.mrg_y.y,
			affi_carto->fenetre.mrg_y.x + 
			affi_carto->fenetre.mrg_y.lng_x,
			affi_carto->fenetre.mrg_y.y + 
			affi_carto->fenetre.mrg_y.lng_y, &att );
	}
//--------------------------------------------------------
	if (affi_carto->fenetre.carto.lng_x > affi_carto->fenetre.carto.lng_y)
		maxpix = affi_carto->fenetre.carto.lng_x;
	else
		maxpix = affi_carto->fenetre.carto.lng_y;

	if (remplir)
		buf_strat = D16MemAlloc( affi_carto->fenetre.mrg_x.lng_y );

	if ((remplir) && (! buf_strat))
		return (1);

	if ((buffer = D16MemAlloc( maxpix )) != NULL)
	{
		if (remplir)
			cree_buffer_stratif( affi_carto, buf_strat );

		nb_coul = affi_carto->palette.nb_couleurs_val;
		off_coul = affi_carto->palette.offset_couleur_val;

		if (affi_carto->config.coupe_y)
			if (dessine_x)
			{
			//-------------------------------
			// AFFICHAGE DE LA COUPE EN Y

				x = old_x = affi_carto->fenetre.mrg_y.x + EPAISSEUR_RELIEF;
				y = affi_carto->fenetre.mrg_y.y + EPAISSEUR_RELIEF;
				lng_x = affi_carto->fenetre.mrg_y.lng_x - EPAISSEUR_RELIEF * 2;
				lng_y = affi_carto->fenetre.carto.lng_y;

				if (lng_y <= 0)
					lng_y = 1;

				get_ligne_bitmap_vert( ecran, pos_x, y, buffer, lng_y );

				for (i = EPAISSEUR_RELIEF;  i < lng_y;  i++)
				{
					att.couleur = buffer[i];
					if (att.couleur != att.fcouleur)
						if (att.couleur != off_coul)
						{
							x2 = min_max_int( (int) ((long) (att.couleur - off_coul) * (long) lng_x / (long) nb_coul), 0, lng_x );
							if (! inverse)
							{
								if (remplir)
									trace_ligne_bitmap( ecran, x, y, (unsigned char *) buf_strat, x2 );
								else
								{
									if (ligne)
									{
										att.couleur = affi_carto->config.couleur_curseur;
										line( ecran, old_x, y, x + x2, y, &att );
										old_x = x + x2;
									}
									else
										line( ecran, x + x2, y, x + x2, y, &att );

								}
							}
							else
							{
								if (remplir)
									trace_ligne_bitmap( ecran, x + lng_x - x2, y, (unsigned char *) buf_strat, x2 );
								else
								{
									if (ligne)
									{
										att.couleur = affi_carto->config.couleur_curseur;
										line( ecran, old_x, y, x + lng_x - x2, y, &att );
										old_x = x + lng_x - x2;
									}
									else
										line( ecran, x + lng_x - x2, y, x + lng_x - x2, y, &att );

								}
							}
						}
					y++;
				}
			}

		if (affi_carto->config.coupe_x)
			if (dessine_y)
			{
			//-------------------------------
			// AFFICHAGE DE LA COUPE EN X

				x = affi_carto->fenetre.mrg_x.x + EPAISSEUR_RELIEF;
				y = old_y = affi_carto->fenetre.mrg_x.y + EPAISSEUR_RELIEF;
				lng_x = affi_carto->fenetre.carto.lng_x;
				lng_y = affi_carto->fenetre.mrg_x.lng_y - EPAISSEUR_RELIEF * 2;
				old_y += lng_y;

				if (remplir)
					invert_mem( buf_strat, affi_carto->fenetre.mrg_x.lng_y - EPAISSEUR_RELIEF * 2 );

				get_ligne_bitmap( ecran, x, pos_y, buffer, lng_x );

				for (i = EPAISSEUR_RELIEF;  i < lng_x;  i++)
				{
					att.couleur = buffer[i];
					if (att.couleur != att.fcouleur)
						if (att.couleur != off_coul)
						{
							y2 = min_max_int( (int) ((long) (att.couleur - off_coul) * (long) lng_y / (long) nb_coul), 0, lng_y );
							if (! inverse)
							{
								if (remplir)
									trace_ligne_bitmap_vert( ecran, x, y + lng_y - y2, (unsigned char *) buf_strat + lng_y - y2, y2 );
								else
								{
									if (ligne)
									{
										att.couleur = affi_carto->config.couleur_curseur;
										line( ecran, x, old_y, x, y + lng_y - y2, &att );
										old_y = y + lng_y - y2;
									}
									else
										line( ecran, x, y + lng_y - y2, x, y + lng_y - y2, &att );

								}
							}
							else
							{
								if (remplir)
									trace_ligne_bitmap_vert( ecran, x, y, (unsigned char *) buf_strat, y2 );
								else
								{
									if (ligne)
									{
										att.couleur = affi_carto->config.couleur_curseur;
										line( ecran, x, old_y, x, y + y2, &att );
										old_y = y + y2;
									}
									else
										line( ecran, x, y + y2, x, y + y2, &att );

								}
							}
						}
					x++;
				}
			}
		D16MemFree( buffer );
	}

	if (remplir)
		D16MemFree( buf_strat );

	return (fini);
}

/***********************************************************/
#pragma message("cree_buffer_stratif")
/*
#COM cree_buffer_stratif:
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void cree_buffer_stratif( struct s_affi_carto *affi_carto, char *buf_strat )
{
	double c;
	long l, m;
	int i, h, offc;
//---------------------------------------------------------------
	h = (affi_carto->fenetre.mrg_x.lng_y - EPAISSEUR_RELIEF * 2);
	offc = affi_carto->palette.offset_couleur_val;
	m = affi_carto->palette.nb_couleurs_val;

	if (affi_carto->asm.tab_val_couleur != NULL)
	{
		if (affi_carto->palette.unite.convert->nb_octets == 1 && affi_carto->data_carto->convert.type == TYPE_AMPLITUDE_US)
		{
#if 0
				c = (double) 127.0 / (double) h;
				for (i = 0;  i < h;  i++)
				{
					l = (int) (i * c);
					buf_strat[i] = buf_tmp[l + 127];
				}
#else
//			offc += m / 2;
			c = (double) m / (double) h;	// / 2.0;
			for (i = 0;  i < h;  i++)
			{
				buf_strat[i] = i * c + offc;
			}
#endif
		}
		else
		{
#if 0
			m = affi_carto->data_carto->valeur_maxi;
			c = (double) m / (double) h;
			for (i = 0;  i < h;  i++)
			{
				l = (int) (i * c);
				buf_strat[i] = buf_tmp[l];
			}
#else
			c = (double) m / (double) h;
			for (i = 0;  i < h;  i++)
			{
				buf_strat[i] = i * c + offc;
			}
#endif
		}
	}
	else
	{
		offc = affi_carto->config.couleur_curseur;
		for (i = 0;  i < h;  i++)
		{
			buf_strat[i] = offc;
		}
	}
}




/***********************************************************/
#pragma message("")
/*
#COM Init_mouse: 
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void cls_carto( struct s_affi_carto *carto )
{
}


/***********************************************************/
#pragma message("set_palette_carto")
/*
#COM set_palette_carto:  positionne le RVB de la carto 
#COM							
#COM         IN: 
#COM
#COM
#COM        OUT:
#COM
*/

void set_palette_carto(  struct s_affi_carto *carto )
{
	int i;

//-------------------------------------------------------------------
// Changer le RVB
//-------------------------------------------------------------------

	for (i = 0;  i < carto->palette.nb_couleurs_err;  i++)
		set_palette( carto->fenetre.ecran, i + carto->palette.offset_couleur_err, carto->palette.rouge_erreur[i], carto->palette.vert_erreur[i], carto->palette.bleu_erreur[i] );

	for (i = 0;  i < carto->palette.nb_couleurs_val;  i++)
		set_palette( carto->fenetre.ecran, i + carto->palette.offset_couleur_val, carto->palette.rouge[i], carto->palette.vert[i], carto->palette.bleu[i] );
}

/***********************************************************/
#pragma message("calcule_palette_carto")
/*
#COM calcule_palette_carto:  Calcule les tableaux de correspondance 
#COM									valeur / couleur en fct des seuils
#COM         IN: 
#COM
#COM
#COM        OUT:
#COM
*/

void calcule_palette_carto( struct s_affi_carto *affi_carto )
{
	long maxi, mini;

	struct s_asm_carto *asm=NULL;
	struct s_convert_data *convert=NULL;
	struct s_palette_carto *palette=NULL;
//-------------------------------------------------------
	asm = &affi_carto->asm;
	palette = &affi_carto->palette;
	convert = &affi_carto->data_carto->convert;
//-------------------------------------------------------
// Rservation mmoire du tab de correspondance valeur -> couleur

	affi_carto->palette.offset_couleur_err = affi_carto->palette.offset_couleur_local;
	affi_carto->palette.offset_couleur_val = affi_carto->palette.offset_couleur_err + affi_carto->palette.nb_couleurs_err;
	affi_carto->palette.nb_couleurs_val = affi_carto->palette.nb_couleurs_local - affi_carto->palette.nb_couleurs_err;

	if (asm->tab_val_couleur != NULL)
		D16MemFreeClear( (void **) &asm->tab_val_couleur );

	if (convert->taille_table_affichage < 300L)
		convert->taille_table_affichage = 300L;

	if ((asm->tab_val_couleur = D16MemAllocClear( (unsigned) convert->taille_table_affichage + 8, palette->offset_couleur_val + palette->nb_couleurs_val - 1 )) == NULL)
	{
		affi_carto->asm.offset_data = 0;
		affi_carto->asm.fin_tab_coul = 0;
		convert->taille_table_affichage = 0;
		palette->unite.nb_division_par_2 = 0;
	}
	else
	{
		affi_carto->asm.fin_tab_coul = convert->taille_table_affichage;

		teste_coherence_min_max( palette );
		calcule_couleur_carto( palette, asm->tab_val_couleur, convert );
		calcul_RVB_carto( palette, convert );

		if (affi_carto->palette.unite.convert)
		{
			mini = (affi_carto->palette.unite.mini_mesure / affi_carto->palette.unite.convert->coef) - affi_carto->palette.unite.convert->offset_stockage;
			maxi = (affi_carto->palette.unite.maxi_mesure / affi_carto->palette.unite.convert->coef) - affi_carto->palette.unite.convert->offset_stockage;
			if (palette->unite.abs)
				mini = 0;
		}
		affi_carto->asm.offset_data = (-mini) >> palette->unite.nb_division_par_2;

		affi_carto->asm.fin_tab_coul = convert->taille_table_affichage;

		set_palette_carto( affi_carto );
	}
}



calcul_RVB_carto( struct s_palette_carto *palette, struct s_convert_data * convert)
{
	long i, s;
	long ofr, ofv, ofb, ideb, ifin;

	double cr, cv, cb;
	double nb_coul_par_seuil;

//-------------------------------------------------------------------
// En mode normal -> les couleurs des seuils sont ==

	nb_coul_par_seuil = (double) palette->nb_couleurs_val / palette->nb_seuils;

	for (i = 0;  i < palette->nb_couleurs_val;  i++)
	{
		s = i / nb_coul_par_seuil;
		palette->rouge[i] = palette->rouge_seuil[s];
		palette->vert[i] = palette->vert_seuil[s];
		palette->bleu[i] = palette->bleu_seuil[s];
	}

//------------------------------------------------------
// Calcul des tables de correspondance couleur -> RVB )

	if (palette->degrade)
	{
		//-------------------------------------------------------------------
		// En mode dgrad -> faire un dgrad entre les couleurs des seuils

		for (s = 0;  s < palette->nb_seuils;  s++)
		{
			ideb = (s + .5) * nb_coul_par_seuil;
			ifin = (s + 1.5) * nb_coul_par_seuil;

			if (ifin > palette->nb_couleurs_val)
			{
				ifin = palette->nb_couleurs_val;	// palette->nb_seuils;
			}

			ofr = palette->rouge_seuil[s];
			ofv = palette->vert_seuil[s];
			ofb = palette->bleu_seuil[s];

			if (s == palette->nb_seuils - 1)
			{
				cb = cr = cv = 0;
			}
			else
			{
				if (ifin != ideb)
					cr = (double) (palette->rouge_seuil[s + 1] - palette->rouge_seuil[s]) / (double) (ifin - ideb);
				else
					cr = 0;
				if (ifin != ideb)
					cv = (double) (palette->vert_seuil[s + 1] - palette->vert_seuil[s]) / (double) (ifin - ideb);
				else
					cv = 0;
				if (ifin != ideb)
					cb = (double) (palette->bleu_seuil[s + 1] - palette->bleu_seuil[s]) / (double) (ifin - ideb);
				else
					cb = 0;
			}

			for (i = ideb;  i < ifin;  i++)
			{
				palette->rouge[i] = ofr + cr * (i - ideb);
				palette->vert[i] = ofv + cv * (i - ideb);
				palette->bleu[i] = ofb + cb * (i - ideb);
			}
		}
	}
}



/***********************************************************/
#pragma message("calcule_couleur_carto")
/*
#COM calcule_couleur_carto:  Calcule les tableaux de correspondance 
#COM									valeur / couleur en fct des seuils
#COM         IN: 
#COM
#COM
#COM        OUT:
#COM
*/

calcule_couleur_carto( struct s_palette_carto * palette, char * tab_val_couleur, struct s_convert_data * convert )
{
	int s, off;
	unsigned int max_coul, coul;
	double maxi, mini, coef, nb_coul_par_seuil, coeff_valeur;

	long offset;
	unsigned long i, deb, fin, last_deb;
//-----------------------------------------------------------
	maxi = (palette->unite.maxi_mesure / convert->coef) - convert->offset_stockage;
	mini = (palette->unite.mini_mesure / convert->coef) - convert->offset_stockage;

	maxi = (double) (ftol( maxi ) >> (palette->unite.nb_division_par_2));
	mini = (double) (ftol( mini ) >> (palette->unite.nb_division_par_2));

	coeff_valeur = maxi - mini;

	if (palette->unite.abs)
	{
		mini = 0;
	}

	offset = -convert->offset_stockage;
	offset -= mini;

	max_coul = palette->offset_couleur_val + palette->nb_couleurs_val - 1;
	nb_coul_par_seuil = (double) palette->nb_couleurs_val / palette->nb_seuils;

	memset( tab_val_couleur, max_coul, (unsigned) convert->taille_table_affichage );
//-----------------------------------------------------------
	deb = 0;
	for (s = 0;  s <= palette->nb_seuils;  s++)
	{
		deb = palette->seuils[s] * coeff_valeur;
		if (s != 0)
			if (deb > fin)
				for (i = fin;  i <= deb;  i++)
					if ((offset + i) < convert->taille_table_affichage)
						tab_val_couleur[offset + i] = coul;

		off = palette->offset_couleur_val + s * nb_coul_par_seuil;

		if (s >= (palette->nb_seuils))
			fin = 1.0 * coeff_valeur;
		else
			fin = palette->seuils[s + 1] * coeff_valeur;

		if (deb >= fin)
			coef = 0;
		else
			coef = nb_coul_par_seuil / (fin - deb);

		if (palette->unite.abs)
		{
			for (i = deb;  i <= fin;  i++)
			{
				coul = off + (i - deb) * coef;
				if (coul > max_coul)
					coul = max_coul;

				if ((offset + i) < convert->taille_table_affichage)
					tab_val_couleur[offset + i] = coul;

				if ((offset - i) < convert->taille_table_affichage)
					tab_val_couleur[offset - i] = coul;
			}
		}
		else
		{
			for (i = deb;  i <= fin;  i++)
			{
				coul = off + (i - deb) * coef;
				if (coul > max_coul)
					coul = max_coul;

				if ((i + 0) < convert->taille_table_affichage)
					tab_val_couleur[i + 0] = coul;
			}
		}
		last_deb = fin + 1;
	}
	tab_val_couleur[0] = palette->offset_couleur_val;
}

/***********************************************************/
#pragma message("defaut_seuils_palette")
/*
#COM defaut_seuils_carto:  Calcule les valeurs de seuils par dfaut 
#COM
#COM         IN: 
#COM
#COM
#COM        OUT:
#COM
*/

void defaut_seuils_carto(  struct s_palette_carto *palette )
{
	int s;

	for (s = 0;  s <= palette->nb_seuils;  s++)
		palette->seuils[s] = (double) s / palette->nb_seuils;

	for (;s < NB_SEUILS_MAX;  s++)
		palette->seuils[s] = 1;
}

/***********************************************************/
#pragma message("init_struct_carto")
/*
#COM init_struct_carto: Initialise la structure s_affi_carto avec les paramtres
#COM							par dfaut et charge le menu d'dition carto
#COM         IN: 
#COM
#COM
#COM        OUT:
#COM
*/

void init_struct_carto( int ecran, struct s_affi_carto *affi_carto )
{
	int i;
//---------------------------------------------------------
	affi_carto->config.valeur = ON;

	affi_carto->config.taille_ecran_x = 237;	// Taille du moniteur en mm en x
	affi_carto->config.taille_ecran_y = 179;	// Taille du moniteur en mm en y
	affi_carto->config.taille_papier_x = 210;	// Taille du moniteur en mm en x
	affi_carto->config.taille_papier_y = 297;	// Taille du moniteur en mm en y

	affi_carto->echelle_x = 1;	// echelle en x en flottant ( echelle 1 -> 1 mm ecran = 1 mm rel  2 -> 2 mm ecran = 2 mm rel )
	affi_carto->echelle_y = 1;	// echelle en y en flottant ( echelle 1 -> 1 mm ecran = 1 mm rel  2 -> 2 mm ecran = 2 mm rel )
	affi_carto->ech_pix_x = 1;	// echelle en x en flottant ( echelle 1 -> 1 pix ecran = 1 acq  2 -> 2 pix ecran = 1 acq  )
	affi_carto->ech_pix_y = 1;	// echelle en y en flottant ( echelle 1 -> 1 pix ecran = 1 acq  2 -> 2 pix ecran = 1 acq  )

	affi_carto->config.curseur_x = ON;
	affi_carto->config.curseur_y = ON;
	affi_carto->config.couleur_curseur = JAUNE;

	affi_carto->config.marge_coupes = 32;
	affi_carto->config.marge_palette = 32;
	affi_carto->config.marge_echelles = 32;
	affi_carto->config.couleur_echelles = JAUNE;
	affi_carto->config.fcouleur_echelles = BLEU_FONCE;

	affi_carto->palette.nb_seuils = 16;
	affi_carto->palette.nb_couleurs_max = NB_MAX_COULEUR;

	affi_carto->palette.offset_couleur_local = NB_COULEUR_DOS;
	affi_carto->palette.offset_couleur_err = NB_COULEUR_DOS;
	affi_carto->palette.offset_couleur_val = NB_COULEUR_DOS + NB_SEUILS_ERREUR;

	init_couleurs_config_carto( affi_carto );

	strcpy( affi_carto->palette.nom, "Defaut" );
	for (i = 0;  i < affi_carto->palette.nb_couleurs_val;  i++)
	{
		affi_carto->palette.vert[i] = 
		affi_carto->palette.bleu[i] = 
		affi_carto->palette.rouge[i] = i * affi_carto->palette.nb_couleurs_max / affi_carto->palette.nb_couleurs_val;
	}

	affi_carto->menu.champs = (struct s_champ *) charge_menu( "..\\carto\\CRTO_EDT.BOX", &affi_carto->menu );
	affi_carto->menu.ecran = ecran;

	for (i = 0;  i < NB_SEUILS_MAX;  i++)
	{
		affi_carto->palette.rouge_seuil[i] = 
		affi_carto->palette.vert_seuil[i] = 
		affi_carto->palette.bleu_seuil[i] = i * affi_carto->palette.nb_couleurs_max / (NB_SEUILS_MAX - 1);
	}

	defaut_seuils_carto( &affi_carto->palette );
	if (affi_carto->data_carto)
	{
		affi_carto->data_carto->fichier.handle = -1;
		affi_carto->palette.unite.convert = &affi_carto->data_carto->convert;
	}
}

init_couleurs_config_carto( struct s_affi_carto *affi_carto )
{
	affi_carto->palette.nb_couleurs_local = NB_MAX_COULEUR - NB_COULEUR_DOS;
	affi_carto->palette.nb_couleurs_err = NB_SEUILS_ERREUR;
	affi_carto->palette.nb_couleurs_val = NB_MAX_COULEUR - NB_COULEUR_DOS - NB_SEUILS_ERREUR;
}

/***********************************************************/
#pragma message("fin_struct_carto")
/*
#COM fin_struct_carto: Ferme le menu d'dition de la cartographie
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void fin_struct_carto( struct s_affi_carto *affi_carto )
{
//-----------------------------------------------------------
	if (affi_carto->signal_carto)
	{
		close_carto( affi_carto->signal_carto );
		D16MemFreeClear( &affi_carto->signal_carto );
	}
//-----------------------------------------------------------
	close_multi_objet( affi_carto );
	reset_malloc_affiche_carto( affi_carto );

	if (affi_carto->asm.tab_val_couleur != NULL)
	{
		D16MemFree( affi_carto->asm.tab_val_couleur );
		affi_carto->asm.tab_val_couleur = 0;
	}

	fin_menu( &affi_carto->menu, affi_carto->menu.champs );
	affi_carto->menu.champs = NULL;

	affi_carto->curseur.dessine = 0;
	affiche_curseur_carto( FIN_CURSEUR_CARTO, &affi_carto->curseur );
}

/***********************************************************/
#pragma message("calcule_zones_carto")
/*
#COM calcule_zones_carto: Suivant la place disponible, calcule  l'intrieur 
#COM 							de la zne carto la position des diffrents lments
#COM             			( barres ascenseur, carto, titres etc ... )
#COM         IN:     
#COM 
#COM        OUT:
#COM  
*/

void calcule_zones_carto( struct s_affi_carto *affi_carto )
{
	int lng_y;
	int nb_car_x;

	if (affi_carto)
	{
		if (affi_carto->menu.champs != NULL)
		{
			affi_carto->menu.champs[BOX_PALETTE].lng_y = affi_carto->config.marge_palette;
			affi_carto->menu.champs[STATUS_CARTO].type.relief = 1;

			nb_car_x = (affi_carto->menu.lng_x - 8) / 8;
			if (nb_car_x > 80)
				nb_car_x = 80;

			lng_y = 0;
			if ((affi_carto->config.palette) || (affi_carto->config.signal))
			{
				affi_carto->menu.champs[BOX_PALETTE].type.invisible = 0;
				affi_carto->menu.champs[L_UNITEES_PPL].type.invisible = 0;

				affi_carto->menu.champs[BOX_PALETTE].pos_x = EPAISSEUR_RELIEF * 2;
				affi_carto->menu.champs[BOX_PALETTE].lng_x = affi_carto->menu.lng_x - 4 * EPAISSEUR_RELIEF;
				lng_y = affi_carto->menu.champs[BOX_PALETTE].lng_y;

				affi_carto->menu.champs[BOX_PALETTE].pos_y = affi_carto->menu.lng_y - lng_y - EPAISSEUR_RELIEF * 2;
				affi_carto->menu.champs[L_UNITEES_PPL].pos_x = affi_carto->menu.champs[BOX_PALETTE].lng_x - affi_carto->menu.champs[L_UNITEES_PPL].lng_x - EPAISSEUR_RELIEF;
				affi_carto->menu.champs[L_UNITEES_PPL].pos_y = affi_carto->menu.champs[BOX_PALETTE].pos_y + (lng_y - affi_carto->menu.champs[L_UNITEES_PPL].lng_y) / 2;
				lng_y += 5;
			}
			else
			{
				affi_carto->menu.champs[BOX_PALETTE].type.invisible = 1;
				affi_carto->menu.champs[L_UNITEES_PPL].type.invisible = 1;
			}

			affi_carto->menu.champs[STATUS_CARTO].car_x = nb_car_x;
			affi_carto->menu.champs[STATUS_CARTO].lng_x = nb_car_x * 8;
			affi_carto->menu.champs[STATUS_CARTO].pos_x = (affi_carto->menu.lng_x - affi_carto->menu.champs[STATUS_CARTO].lng_x) / 2;

			affi_carto->menu.champs[DEPL_HORIZ_CARTO].pos_y = affi_carto->menu.lng_y - affi_carto->menu.champs[DEPL_HORIZ_CARTO].lng_y - EPAISSEUR_RELIEF * 2 - lng_y;

			affi_carto->menu.champs[CADRE_CARTO].pos_x = affi_carto->menu.champs[DEPL_VERT_CARTO].pos_x + affi_carto->menu.champs[DEPL_VERT_CARTO].lng_x + EPAISSEUR_RELIEF * 2;
			affi_carto->menu.champs[CADRE_CARTO].pos_y = affi_carto->menu.champs[STATUS_CARTO].pos_y + affi_carto->menu.champs[STATUS_CARTO].lng_y + EPAISSEUR_RELIEF * 2;
			affi_carto->menu.champs[CADRE_CARTO].lng_y = affi_carto->menu.champs[DEPL_HORIZ_CARTO].pos_y - affi_carto->menu.champs[CADRE_CARTO].pos_y - EPAISSEUR_RELIEF * 2;
			affi_carto->menu.champs[CADRE_CARTO].lng_x = affi_carto->menu.lng_x - affi_carto->menu.champs[CADRE_CARTO].pos_x - EPAISSEUR_RELIEF * 2;

			affi_carto->menu.champs[DEPL_HORIZ_CARTO].pos_x = affi_carto->menu.champs[CADRE_CARTO].pos_x;

			if (affi_carto->config.echelle_x)
			{
				affi_carto->menu.champs[CADRE_CARTO].lng_y -= affi_carto->config.marge_echelles + EPAISSEUR_RELIEF;
				affi_carto->fenetre.ech_x.x = affi_carto->menu.x + affi_carto->menu.champs[CADRE_CARTO].pos_x;
				affi_carto->fenetre.ech_x.y = affi_carto->menu.y + affi_carto->menu.champs[CADRE_CARTO].pos_y - EPAISSEUR_RELIEF;
				affi_carto->fenetre.ech_x.lng_x = affi_carto->menu.champs[CADRE_CARTO].lng_x - EPAISSEUR_RELIEF;
				affi_carto->fenetre.ech_x.lng_y = affi_carto->config.marge_echelles;
				affi_carto->menu.champs[CADRE_CARTO].pos_y += affi_carto->config.marge_echelles + EPAISSEUR_RELIEF;
				if (affi_carto->config.echelle_y)
					affi_carto->fenetre.ech_x.lng_x -= affi_carto->config.marge_echelles + EPAISSEUR_RELIEF;

			}
			if (affi_carto->config.echelle_y)
			{
				affi_carto->menu.champs[CADRE_CARTO].lng_x -= affi_carto->config.marge_echelles + EPAISSEUR_RELIEF;
				affi_carto->fenetre.ech_y.x = affi_carto->menu.x + affi_carto->menu.champs[CADRE_CARTO].pos_x + affi_carto->menu.champs[CADRE_CARTO].lng_x + EPAISSEUR_RELIEF;
				affi_carto->fenetre.ech_y.y = affi_carto->menu.y + affi_carto->menu.champs[CADRE_CARTO].pos_y;
				affi_carto->fenetre.ech_y.lng_x = affi_carto->config.marge_echelles;
				affi_carto->fenetre.ech_y.lng_y = affi_carto->menu.champs[CADRE_CARTO].lng_y - EPAISSEUR_RELIEF;
			}
			if (affi_carto->config.coupe_x)
			{
				affi_carto->menu.champs[CADRE_CARTO].lng_y -= affi_carto->config.marge_coupes + EPAISSEUR_RELIEF;

				affi_carto->fenetre.mrg_x.x = affi_carto->menu.x + affi_carto->menu.champs[CADRE_CARTO].pos_x;
				affi_carto->fenetre.mrg_x.y = affi_carto->menu.y + affi_carto->menu.champs[CADRE_CARTO].pos_y - EPAISSEUR_RELIEF;
				affi_carto->fenetre.mrg_x.lng_x = affi_carto->menu.champs[CADRE_CARTO].lng_x - EPAISSEUR_RELIEF;
				affi_carto->fenetre.mrg_x.lng_y = affi_carto->config.marge_coupes;

				affi_carto->menu.champs[CADRE_CARTO].pos_y += affi_carto->config.marge_coupes;

				if (affi_carto->config.echelle_y)
				{
					affi_carto->fenetre.ech_y.y += affi_carto->config.marge_coupes;
					affi_carto->fenetre.ech_y.lng_y -= affi_carto->config.marge_coupes;
				}
			}

			if (affi_carto->config.coupe_y)
			{
				affi_carto->menu.champs[CADRE_CARTO].lng_x -= affi_carto->config.marge_coupes + EPAISSEUR_RELIEF;

				affi_carto->fenetre.mrg_y.x = affi_carto->menu.x + affi_carto->menu.champs[CADRE_CARTO].pos_x + affi_carto->menu.champs[CADRE_CARTO].lng_x + EPAISSEUR_RELIEF;
				affi_carto->fenetre.mrg_y.y = affi_carto->menu.y + affi_carto->menu.champs[CADRE_CARTO].pos_y;
				affi_carto->fenetre.mrg_y.lng_x = affi_carto->config.marge_coupes;
				affi_carto->fenetre.mrg_y.lng_y = affi_carto->menu.champs[CADRE_CARTO].lng_y;
				if (affi_carto->config.coupe_x)
					affi_carto->fenetre.mrg_x.lng_x -= affi_carto->config.marge_coupes;

				if (affi_carto->config.echelle_x)
					affi_carto->fenetre.ech_x.lng_x -= affi_carto->config.marge_coupes;

			}
			init_carto_champ( affi_carto, &affi_carto->menu, &affi_carto->menu.champs[CADRE_CARTO] );

			affi_carto->menu.champs[DEPL_VERT_CARTO].pos_y = affi_carto->menu.champs[CADRE_CARTO].pos_y;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].car_x = affi_carto->menu.champs[CADRE_CARTO].lng_x;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].etat.dessine = 0;
			affi_carto->menu.champs[DEPL_VERT_CARTO].car_y = affi_carto->menu.champs[CADRE_CARTO].lng_y;
			affi_carto->menu.champs[DEPL_VERT_CARTO].etat.dessine = 0;

			affi_carto->menu.champs[PLEIN_ECRAN_CARTO].pos_y = affi_carto->menu.champs[DEPL_HORIZ_CARTO].pos_y + EPAISSEUR_RELIEF;
			if (affi_carto->flags.active)
				init_menu( &affi_carto->menu, affi_carto->menu.champs );

		}
		affi_carto->curseur.dessine = 0;
	}
}

/***********************************************************/
#pragma message("calcule_zoom_carto")
/*
#COM calcule_zoom_carto: Calcule les offsets de la carto en fonction du zoom 
#COM 						et le nouveau zoom
#COM             		
#COM         IN:     dans centre_zoom_x/y -> l'endroit point en pixels
#COM 						et echelles  la bonne valeur
#COM        OUT:     Calcul des nouvelles echelles et des offsets
#COM  
*/

void calcule_zoom_carto( struct s_affi_carto *affi_carto , double coeff)
{
	long posx, posy;

	posx = affi_carto->offset_carto_x + affi_carto->centre_zoom_x / affi_carto->ech_pix_x;
	posy = affi_carto->offset_carto_y + affi_carto->centre_zoom_y / affi_carto->ech_pix_y;

	affi_carto->centre_zoom_x = ltoi( posx );
	affi_carto->centre_zoom_y = ltoi( posy );

	affi_carto->echelle_x *= coeff;
	affi_carto->echelle_y *= coeff;

	affi_carto->ech_pix_x *= coeff;
	affi_carto->ech_pix_y *= coeff;

	affi_carto->ech_pap_x *= coeff;
	affi_carto->ech_pap_y *= coeff;

	affi_carto->offset_carto_x = ftoi( posx - (double) affi_carto->fenetre.carto.lng_x / 2. / affi_carto->ech_pix_x );
	affi_carto->offset_carto_y = ftoi( posy - (double) affi_carto->fenetre.carto.lng_y / 2. / affi_carto->ech_pix_y );

	affi_carto->flags.demande_trace_carto = 1;
}

/***********************************************************/
#pragma message("calcule_zoom_zone_carto")
/*
#COM calcule_zoom_carto: Calcule les offsets de la carto en fonction d'une zone
#COM 						et le nouveau zoom
#COM             		
#COM         IN:     dans X&,y1,x2,y2 -> l'endroit point en pixels
#COM 						et echelles  la bonne valeur
#COM        OUT:     Calcul des nouvelles echelles et des offsets
#COM  
*/

void calcule_zoom_zone_carto( struct s_affi_carto *affi_carto , int x1, int y1, int x2, int y2)
{
	long lngx1;
	long lngy1;
	double coeffx;
	double coeffy;

	if (x2 != x1)
	{
		if (y2 != y1)
		{
			if (x2 < x1)
				swap_int( &x1, &x2 );

			if (y2 < y1)
				swap_int( &y1, &y2 );

			affi_carto->offset_carto_x += x1 / affi_carto->ech_pix_x;
			affi_carto->offset_carto_y += y1 / affi_carto->ech_pix_y;
			coeffx = (double) affi_carto->fenetre.carto.lng_x / (double) (x2 - x1);
			coeffy = (double) affi_carto->fenetre.carto.lng_y / (double) (y2 - y1);

			if (affi_carto->config.isometrique)
			{
				//modif eb 21/3/99
				if (coeffy > coeffx)
					coeffy = coeffx;
				else
					coeffx = coeffy;
			}

			affi_carto->echelle_x *= coeffx;
			affi_carto->echelle_y *= coeffy;
			affi_carto->ech_pix_x *= coeffx;
			affi_carto->ech_pix_y *= coeffy;
//EB 09/02/2000
			affi_carto->ech_pap_x *= coeffx;
			affi_carto->ech_pap_y *= coeffy;

			affi_carto->flags.demande_trace_carto = 1;
		}
	}
}

/***********************************************************/
#pragma message("calcule_plein_ecran_carto")
/*
#COM calcule_plein_ecran_carto: Calcule les offsets de la carto 
#COM 						et le nouveau zoom pour un plein ecran
#COM             		
#COM         IN:     
#COM 
#COM        OUT:     Calcul des nouvelles echelles et des offsets
#COM  
*/

void calcule_plein_ecran_carto( struct s_affi_carto *affi_carto)
{
	double coeff;

	affi_carto->offset_carto_x = 0;
	affi_carto->offset_carto_y = 0;
	if (affi_carto->config.unite_visu == UNITE_AFF_METRE)
	{
		if (affi_carto->data_carto->pas_vert != 0 && affi_carto->data_carto->pas_horiz != 0
		&& affi_carto->data_carto->largeur_carto != 0 && affi_carto->data_carto->nb_lignes_total != 0)
		{
			affi_carto->echelle_x = (double) affi_carto->config.taille_ecran_x / 1000 * 
			(double) affi_carto->fenetre.carto.lng_x / 
			(double) affi_carto->data_carto->largeur_carto / 
			((double) pixels_ecran_x( affi_carto->fenetre.ecran ) * 
			fabs( (double) affi_carto->data_carto->pas_horiz ));

			affi_carto->echelle_y = (double) affi_carto->config.taille_ecran_y / 1000 * 
			(double) affi_carto->fenetre.carto.lng_y / 
			(double) affi_carto->data_carto->nb_lignes_total / 
			((double) pixels_ecran_y( affi_carto->fenetre.ecran ) * 
			fabs( (double) affi_carto->data_carto->pas_vert ));
		}
		else
		{
			affi_carto->echelle_x = affi_carto->echelle_y = 0.001;
		}
		if (affi_carto->config.isometrique)
		{
			if (affi_carto->echelle_x > affi_carto->echelle_y)
				affi_carto->echelle_x = affi_carto->echelle_y;
			else
				affi_carto->echelle_y = affi_carto->echelle_x;
		}
	}
	else if (affi_carto->config.unite_visu == UNITE_AFF_PIXEL)
	{
		if (affi_carto->data_carto->largeur_carto != 0 && affi_carto->data_carto->nb_lignes_total != 0)
		{
			affi_carto->ech_pix_x = (double) affi_carto->fenetre.carto.lng_x / (double) affi_carto->data_carto->largeur_carto;
			affi_carto->ech_pix_y = (double) affi_carto->fenetre.carto.lng_y / (double) affi_carto->data_carto->nb_lignes_total;
		}
		else
		{
			affi_carto->ech_pix_x = affi_carto->ech_pix_y = 1;
		}
		if (affi_carto->config.isometrique)
		{
			if (affi_carto->ech_pix_x > affi_carto->ech_pix_y)
				affi_carto->ech_pix_x = affi_carto->ech_pix_y;
			else
				affi_carto->ech_pix_y = affi_carto->ech_pix_x;

		}
	}
	else if (affi_carto->config.unite_visu == UNITE_AFF_IMPRIMANTE)
	{
		if (affi_carto->data_carto->pas_vert != 0 && affi_carto->data_carto->pas_horiz != 0
		&& affi_carto->data_carto->largeur_carto != 0 && affi_carto->data_carto->nb_lignes_total != 0)
		{
			affi_carto->ech_pap_x = (double) affi_carto->config.taille_papier_x / 1000 * 
			(double) affi_carto->fenetre.carto.lng_x / 
			(double) affi_carto->data_carto->largeur_carto / 
			((double) pixels_ecran_x( affi_carto->fenetre.ecran ) * 
			fabs( (double) affi_carto->data_carto->pas_horiz ));

			affi_carto->ech_pap_y = (double) affi_carto->config.taille_papier_y / 1000 * 
			(double) affi_carto->fenetre.carto.lng_y / 
			(double) affi_carto->data_carto->nb_lignes_total / 
			((double) pixels_ecran_y( affi_carto->fenetre.ecran ) * 
			fabs( (double) affi_carto->data_carto->pas_vert ));
		}
		else
		{
			affi_carto->ech_pap_x = affi_carto->ech_pap_y = 0.001;
		}
		if (affi_carto->config.isometrique)
		{
			if (affi_carto->ech_pap_x > affi_carto->ech_pap_y)
				affi_carto->ech_pap_x = affi_carto->ech_pap_y;
			else
				affi_carto->ech_pap_y = affi_carto->ech_pap_x;

		}
	}
	affi_carto->flags.demande_trace_carto++;
}


/***********************************************************/
#pragma message("set_champs_affi_carto")
/*
#COM set_champs_affi_carto: Initialise les champs d'dition carto en fct de 
#COM 								l'affichage ( ascenseur, titre etc ... )
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void set_champs_affi_carto( struct s_affi_carto *affi_carto )
{
	char buffer[80];

	if (! affi_carto->flags.interdit_re_affichage_menu)
		if (affi_carto->menu.champs)
			if (affi_carto->asm.active)
			{
				set_nom_fichier_chaine(
				affi_carto->menu.champs[STATUS_CARTO].contenu,
				affi_carto->data_carto->fichier.nom,
				affi_carto->menu.champs[STATUS_CARTO].car_x - 12 );

				affi_carto->menu.champs[STATUS_CARTO].etat.modifie = 1;
				affi_carto->menu.champs[STATUS_CARTO].etat.dessine = 0;
				strcat( affi_carto->menu.champs[STATUS_CARTO].contenu, ", " );
				sprintf( buffer, "Ech: %3.3lf.", affi_carto->ech_pix_x );
				strcat( affi_carto->menu.champs[STATUS_CARTO].contenu, buffer );

				affiche_champs_modifie( &affi_carto->menu, affi_carto->menu.champs );
			}

	if (affi_carto->menu.champs)
		if (affi_carto->asm.active)
		{
			affi_carto->menu.champs[DEPL_VERT_CARTO].mini = affi_carto->asm.lng_y / affi_carto->ech_pix_y;
			affi_carto->menu.champs[DEPL_VERT_CARTO].maxi = affi_carto->data_carto->nb_lignes_total;
			affi_carto->menu.champs[DEPL_VERT_CARTO].valeur = affi_carto->offset_carto_y;
			affi_carto->menu.champs[DEPL_VERT_CARTO].etat.modifie = 1;
			affi_carto->menu.champs[DEPL_VERT_CARTO].etat.dessine = 0;

			affi_carto->menu.champs[DEPL_HORIZ_CARTO].mini = affi_carto->asm.lng_x / affi_carto->ech_pix_x;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].maxi = affi_carto->data_carto->largeur_maxi_ligne;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].valeur = affi_carto->offset_carto_x;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].etat.modifie = 1;
			affi_carto->menu.champs[DEPL_HORIZ_CARTO].etat.dessine = 0;

			affiche_champs_modifie( &affi_carto->menu, affi_carto->menu.champs );
			affiche_echelles_carto( affi_carto );
			affiche_champs_modifie( &affi_carto->menu, affi_carto->menu.champs );
		}

}


int affi_info_carto(int niveau, char * status, struct s_affi_carto *affi_carto )
{
	int nb;
	static char _FAR_STATIC info[1024];

//--------------------------------------------------------
	info[0] = 0;

	if (affi_carto->menu.champs)
	{
		if (niveau > 0)
		{
			nb = strlen( status ) + 1;

			set_nom_fichier_chaine( info,
			affi_carto->data_carto->fichier.nom,
			affi_carto->menu.champs[STATUS_CARTO].car_x - nb );
		}

		sprintf( info, "%s %s", (char _FAR_DATA *) info, (char _FAR_DATA *) status );

		affi_carto->menu.champs[STATUS_CARTO].etat.dessine = 0;
		_move_chp_lettre( SENS_STRUCT_TO_CHAMPS, &affi_carto->menu.champs[STATUS_CARTO], info );
		affiche_champ( &affi_carto->menu, &affi_carto->menu.champs[STATUS_CARTO] );

		affi_carto->menu.champs[STATUS_CARTO].type.relief = 0;
	}
}

/************************************************************
#COM xy_sur_carto: la souris est sur la carto
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int xy_sur_carto(int x, int y, struct s_affi_carto *affi_carto )
{
	int ret = 0;

	if (affi_carto->flags.active)
		if (x > affi_carto->menu.x)
			if (x < (affi_carto->menu.x + affi_carto->menu.lng_x))
				if (y > affi_carto->menu.y)
					if (y < (affi_carto->menu.y + affi_carto->menu.lng_y))
						ret = 1;

	return (ret);
}

/***********************************************************/
#pragma message("write_affi_carto")
/*
#COM write_affi_carto : Ecrit data de la carto dans le fichier
#COM
#COM         IN: carto->ligne_data_act
#COM             
#COM 
#COM        OUT:
#COM  
*/

void write_affi_carto(struct s_affi_carto * affi_carto, char * data)
{
//-----------------------------------------------------------
	if (affi_carto->config.compensation_peigne)
	{
		if ((affi_carto->data_carto->num_ligne_data & 1) == (affi_carto->config.peigne_pair))
			data += affi_carto->config.compensation_peigne;
	}

	write_data_carto( affi_carto->data_carto, data );
}

/************************************************************/

int edit_multi_carto(	int touche, 
								int nb_carto,
								struct s_commande *com,
								struct s_affi_carto **affi_carto )
{
	int cpt = 0;
	int multi = 0;
	int num_carto = -1;
	int num_carto_tmp = -1;
	struct s_affi_carto *carto = NULL;

	if (! affi_carto || ! com)
		return (ESC);

	for (cpt = 0;  cpt < nb_carto;  cpt++)
		if (xy_sur_carto( com->x, com->y, affi_carto[cpt] ))
			num_carto_tmp = num_carto = cpt;

	if (num_carto < 0)
		return (ESC);

	for (cpt = 0;  cpt < nb_carto;  cpt++)
	{
		if (
		affi_carto[num_carto_tmp]->flags.active
		&& affi_carto[num_carto_tmp]->data_carto
		&& affi_carto[num_carto_tmp]->data_carto->fichier.nom[0]
		)
		{
			affi_carto[num_carto_tmp]->next_affi_carto = NULL;
			if (carto)
				carto = carto->next_affi_carto = affi_carto[num_carto_tmp];
			else
				carto = affi_carto[num_carto_tmp];

			multi++;
		}
		if (++num_carto_tmp >= nb_carto)
			num_carto_tmp = 0;

	}

	if (multi > 1)
		affi_carto[num_carto]->config.multi_edition = 1;

	touche = edit_carto( touche, affi_carto[num_carto] );
	affi_carto[num_carto]->config.multi_edition = 0;
	return (touche);
}

/************************************************************/

int edit_multi_carto_non_bloquant(	int touche, 
												int nb_carto,
												struct s_commande *com,
												struct s_affi_carto **affi_carto )
{
	int cpt = 0;
	int multi = 0;
	int num_carto = -1;
	int num_carto_tmp = -1;
	struct s_affi_carto *carto = NULL;
	static int _FAR_STATIC init_fait = 0;
	static int _FAR_STATIC old_num_carto = -1;

	if (! affi_carto || ! com)
		return (ESC);

	for (cpt = 0;  cpt < nb_carto;  cpt++)
		if (xy_sur_carto( com->x, com->y, affi_carto[cpt] ))
			num_carto_tmp = num_carto = cpt;

	if (num_carto < 0)
	{
		if (init_fait)
			edit_carto_non_bloquant( EC_FIN, touche, com, affi_carto[old_num_carto] );

		init_fait = OFF;
		return (ESC);
	}

	for (cpt = 0;  cpt < nb_carto;  cpt++)
	{
		if (
		affi_carto[num_carto_tmp]->flags.active
		&& affi_carto[num_carto_tmp]->data_carto
		&& affi_carto[num_carto_tmp]->data_carto->fichier.nom[0]
		)
		{
			affi_carto[num_carto_tmp]->next_affi_carto = NULL;
			if (carto)
				carto = carto->next_affi_carto = affi_carto[num_carto_tmp];
			else
				carto = affi_carto[num_carto_tmp];

			multi++;
		}
		if (++num_carto_tmp >= nb_carto)
			num_carto_tmp = 0;

	}

	if (multi > 1)
		affi_carto[num_carto]->config.multi_edition = 1;

	if (! init_fait)
	{
		init_fait = ON;
		edit_carto_non_bloquant( EC_INIT, touche, com, affi_carto[num_carto] );
	}

	old_num_carto = num_carto;
	touche = edit_carto_non_bloquant( EC_CARTO, touche, com, affi_carto[num_carto] );

	affi_carto[num_carto]->config.multi_edition = 0;
	return (touche);
}

/************************************************************/

int edit_mono_carto(	int touche, 
							int nb_carto,
							struct s_commande *com,
							struct s_affi_carto **affi_carto )
{
	int cpt;
	struct s_affi_carto *carto = NULL;

	if (! affi_carto || ! com)
		return (ESC);

	for (cpt = 0;  cpt < nb_carto;  cpt++)
	{
		carto = affi_carto[cpt];
		carto->next_affi_carto = NULL;
		carto->config.multi_edition = 0;
		if (xy_sur_carto( com->x, com->y, carto ))
			touche = edit_carto( touche, carto );
	}
	return (touche);
}

/************************************************************/

int edit_mono_carto_non_bloquant(	int touche, 
												int nb_carto,
												struct s_commande *com,
												struct s_affi_carto **affi_carto )
{
	int cpt = 0;
	int num_carto = -1;
	struct s_affi_carto *carto = NULL;
	static int _FAR_STATIC init_fait = 0;
	static int _FAR_STATIC old_num_carto = -1;

	if (! affi_carto || ! com)
		return (ESC);

	for (cpt = 0;  cpt < nb_carto;  cpt++)
	{
		carto = affi_carto[cpt];
		carto->next_affi_carto = NULL;
		carto->config.multi_edition = 0;
		if (xy_sur_carto( com->x, com->y, carto ))
			num_carto = cpt;

	}

	if (num_carto < 0)
	{
		if (init_fait)
			edit_carto_non_bloquant( EC_FIN, touche, com, affi_carto[old_num_carto] );

		init_fait = OFF;
		return (ESC);
	}

	if (! init_fait)
	{
		init_fait = ON;
		edit_carto_non_bloquant( EC_INIT, touche, com, affi_carto[num_carto] );
	}

	old_num_carto = num_carto;
	touche = edit_carto_non_bloquant( EC_CARTO, touche, com, affi_carto[num_carto] );

	return (touche);
}

/************************************************************
#COM Edit_carto: Edition d'une carto avec le menu spcialis
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int edit_carto( int touche_boutonD, struct s_affi_carto *affi_carto )
{
	int x1_c;
	int y1_c;
	int x2_c;
	int y2_c;
	struct s_edit_carto edit;

	if (! affi_carto->data_carto)
		return (ESC);

	if (affi_carto->flags.interdit_affichage_carto)
		return (ESC);

	if (! affi_carto->data_carto->fichier.flags.used)
		return (ESC);

	memset( &edit, 0, sizeof (edit) );
	affi_carto->config.first_carto = 1;
	x1_c = affi_carto->fenetre.carto.x;
	y1_c = affi_carto->fenetre.carto.y;
	x2_c = x1_c + affi_carto->fenetre.carto.lng_x;
	y2_c = y1_c + affi_carto->fenetre.carto.lng_y;

	edit.mouse_out = 1;
	edit.touche = touche_boutonD;
	edit.multi = affi_carto->config.multi_edition;
	edit_carto_commande( EC_DEMANDE_INFO, &edit, &edit.com, affi_carto );
	edit_carto_commande( EC_DEMANDE_COUPE, &edit, &edit.com, affi_carto );

	clear_mouse( affi_carto->curseur.ecran );
	edit_carto_commande( EC_INIT_CURSEUR, &edit, &edit.com, affi_carto );

	affiche_carto( affi_carto );
	show_mouse( affi_carto->curseur.ecran );

	do	
	{
		gere_commande( &edit.com );
		edit.pos_x = pixel_x_to_m( edit.com.x, affi_carto );
		edit.pos_y = pixel_y_to_m( edit.com.y, affi_carto );

		if (edit.com.change)
		{
			edit_carto_commande( EC_DEMANDE_INFO, &edit, &edit.com, affi_carto );

			if (edit.com.x > x1_c && edit.com.x < x2_c
			&& edit.com.y > y1_c && edit.com.y < y2_c)
			{
				edit_carto_commande( EC_INIT, &edit, &edit.com, affi_carto );
				edit_carto_commande( EC_CARTO, &edit, &edit.com, affi_carto );
			}
			else
			{
				edit_carto_commande( EC_MENU, &edit, &edit.com, affi_carto );
			}
			edit.com.change = 0;
		}
		else
			edit_carto_commande( EC_TACHE_FOND, &edit, &edit.com, affi_carto );

	}
	while (! edit.sortir);

	if (edit.mouse_out)
		edit_carto_commande( EC_EFFACE_INFO, &edit, &edit.com, affi_carto );

	if (edit.com.touche == ESC)
	{
		set_mouse( 0, 0 );
		show_mouse( affi_carto->curseur.ecran );
	}
	else
		edit_carto_commande( EC_EFFACE_CURSEUR, &edit, &edit.com, affi_carto );

	affi_carto->config.first_carto = 0;
	return (edit.com.touche);
}

/************************************************************/

int edit_carto_non_bloquant(	int ordre,
										int touche_boutonD, 
										struct s_commande *com,
										struct s_affi_carto *affi_carto )
{
	int x1_c;
	int y1_c;
	int x2_c;
	int y2_c;
	static struct s_edit_carto _FAR_STATIC edit = {0};

	if (! affi_carto->data_carto)
		return (ESC);

	if (affi_carto->flags.interdit_affichage_carto)
		return (ESC);

	if (! affi_carto->data_carto->fichier.flags.used)
		return (ESC);

	//--------------------------------------------------------------------------.
	affi_carto->config.first_carto = 1;
	x1_c = affi_carto->fenetre.carto.x;
	y1_c = affi_carto->fenetre.carto.y;
	x2_c = x1_c + affi_carto->fenetre.carto.lng_x;
	y2_c = y1_c + affi_carto->fenetre.carto.lng_y;

	//--------------------------------------------------------------------------.
	switch (ordre)
	{
	case EC_INIT:
		edit.mouse_out = 1;
		edit.touche = touche_boutonD;
		edit.multi = affi_carto->config.multi_edition;
		edit_carto_commande( EC_DEMANDE_INFO, &edit, com, affi_carto );
		edit_carto_commande( EC_DEMANDE_COUPE, &edit, com, affi_carto );

		clear_mouse( affi_carto->curseur.ecran );
		edit_carto_commande( EC_INIT_CURSEUR, &edit, com, affi_carto );

		affiche_carto( affi_carto );
		show_mouse( affi_carto->curseur.ecran );

		break;

	case EC_CARTO:
		edit.pos_x = pixel_x_to_m( com->x, affi_carto );
		edit.pos_y = pixel_y_to_m( com->y, affi_carto );

		if (com->change)
		{
			edit_carto_commande( EC_DEMANDE_INFO, &edit, com, affi_carto );

			if (com->x > x1_c && com->x < x2_c
			&& com->y > y1_c && com->y < y2_c)
			{
				clear_mouse( affi_carto->curseur.ecran );
				edit_carto_commande( EC_INIT, &edit, com, affi_carto );
				edit_carto_commande( EC_CARTO, &edit, com, affi_carto );
			}
			else
				edit_carto_commande( EC_MENU, &edit, com, affi_carto );

			com->change = 0;
		}
		else
			edit_carto_commande( EC_TACHE_FOND, &edit, com, affi_carto );

		break;

	case EC_FIN:
		if (edit.mouse_out)
			edit_carto_commande( EC_EFFACE_INFO, &edit, com, affi_carto );

		if (com->touche == ESC)
		{
			set_mouse( 0, 0 );
			show_mouse( affi_carto->curseur.ecran );
		}
		else
			edit_carto_commande( EC_EFFACE_CURSEUR, &edit, com, affi_carto );

		break;

	default:
		break;
	}

	//--------------------------------------------------------------------------.
	affi_carto->config.first_carto = 0;
	return (com->touche);
}

//*****************************************************************************.

edit_carto_commande( 	enum e_ordre_edit_carto ordre,
								struct s_edit_carto *edit,
								struct s_commande *com,
								struct s_affi_carto *affi_carto )
{
	int x;
	int y;
	struct s_affi_carto *carto = NULL;

	if (! (carto = affi_carto))
		return (-1);
/*	locate( 1, 1 );
	printf( "click %lf", affi_carto->echelle_x );*/


	x = com->x;
	y = com->y;
	edit->num = 0;
	switch (ordre)
	{
	case EC_INIT:
		if (edit->mouse_out)
		{
			edit->mouse_out = 0;
			hide_mouse( carto->curseur.ecran );
			do	
			{
				affiche_curseur_carto( AUTORISE_CURSEUR_CARTO, &carto->curseur );
				carto = carto->next_affi_carto;
			}
			while (carto && edit->multi);
		}
		break;

	case EC_CARTO:
		edit_carto_commande( EC_DEMANDE_COUPE, edit, com, carto );
		do	
		{
			com->x = m_to_pixel_x( edit->pos_x, carto );
			com->y = m_to_pixel_y( edit->pos_y, carto );
			if ((com->x > carto->fenetre.carto.x)
			&& (com->x < (carto->fenetre.carto.x + carto->fenetre.carto.lng_x))
			&& (com->y > carto->fenetre.carto.y)
			&& (com->y < (carto->fenetre.carto.y + carto->fenetre.carto.lng_y)))
			{
				carto->curseur.xc1 = carto->pos_curseur_x = com->x;
				carto->curseur.yc1 = carto->pos_curseur_y = com->y;
				affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &carto->curseur );
				if (carto->function_edit_carto)
					(carto->function_edit_carto)( com, carto );

			}
			edit_carto_touche( edit, com, carto );
			edit_carto_mouse( edit, com, carto );
			carto = carto->next_affi_carto;
			edit->num++;
		}
		while (carto && edit->multi);
		break;

	case EC_MENU:
		if (! edit->mouse_out)
		{
			edit->mouse_out++;
			edit_carto_commande( EC_EFFACE_CURSEUR, edit, com, carto );
		}
		do	
		{
			com->x = m_to_pixel_x( edit->pos_x, carto );
			com->y = m_to_pixel_y( edit->pos_y, carto );
			edit_carto_touche( edit, com, carto );
			edit_carto_menu( edit, com, carto );
			carto = carto->next_affi_carto;
			edit->num++;
		}
		while (carto && edit->multi);
		break;

	case EC_TACHE_FOND:
		do	
		{
			com->x = m_to_pixel_x( edit->pos_x, carto );
			com->y = m_to_pixel_y( edit->pos_y, carto );
			edit_carto_taches_de_fond( edit, com, carto );
			carto = carto->next_affi_carto;
			edit->num++;
		}
		while (carto && edit->multi);
		break;

	case EC_DEMANDE_INFO:
		do	
		{
			if (carto->menu.champs)
				carto->menu.champs[STATUS_CARTO].type.relief = 0;

			edit->dessine_info[edit->num] = 1;
			carto = carto->next_affi_carto;
			edit->num++;
		}
		while (carto && edit->multi);
		break;

	case EC_DEMANDE_COUPE:
		do	
		{
			edit->dessine_coupe[edit->num] = 1;
			carto = carto->next_affi_carto;
			edit->num++;
		}
		while (carto && edit->multi);
		break;

	case EC_EFFACE_INFO:
		do	
		{
			affi_info_carto( 1, "", carto );
			carto = carto->next_affi_carto;
		}
		while (carto && edit->multi);
		break;

	case EC_INIT_CURSEUR:
		do	
		{
			affiche_curseur_carto( INTERDIT_CURSEUR_CARTO, &carto->curseur );
			affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &carto->curseur );
			carto = carto->next_affi_carto;
		}
		while (carto && edit->multi);
		break;

	case EC_EFFACE_CURSEUR:
		do	
		{
			affiche_curseur_carto( INTERDIT_CURSEUR_CARTO, &carto->curseur );
			carto = carto->next_affi_carto;
		}
		while (carto && edit->multi);
		show_mouse( affi_carto->curseur.ecran );
		break;

	default:
		break;
	}
	com->x = x;
	com->y = y;
	edit->num = 0;

	return (0);
}

/***********************************************************/

int edit_carto_mouse(	struct s_edit_carto *edit,
								struct s_commande *com,
								struct s_affi_carto *affi_carto )
{
	if (com->front_neg_mouse & BOUTONG)
	{
		if (com->shift & CTRL)
		{
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 2.0 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else if (com->shift & SHIFT)
		{
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 1.0 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else if (edit->etape[edit->num])
		{
			edit->etape[edit->num] = 0;
			affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &affi_carto->curseur );

			calcule_zoom_zone_carto( affi_carto,
			affi_carto->curseur.xc1 - affi_carto->fenetre.carto.x,
			affi_carto->curseur.yc1 - affi_carto->fenetre.carto.y,
			affi_carto->curseur.xc2 - affi_carto->fenetre.carto.x,
			affi_carto->curseur.yc2 - affi_carto->fenetre.carto.y );

			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			affiche_carto( affi_carto );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else
		{
			edit->etape[edit->num]++;
			edit->dessine_info[edit->num] = 0;
			affiche_curseur_carto( MODE_CARRE_CURSEUR_CARTO, &affi_carto->curseur );
			affi_info_carto( 0, "Alt = ISO.", affi_carto );
		}
	}

	if (com->front_neg_mouse & BOUTOND)
	{
		if (com->shift & CTRL)
		{
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 0.5 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else if (com->shift & SHIFT)
		{
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 1.0 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else if (edit->etape[edit->num])
		{
			edit->etape[edit->num] = 0;
			affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &affi_carto->curseur );
		}
		else
		{
			edit->sortir++;
			com->touche = edit->touche;
		}
	}
}

/***********************************************************/

int edit_carto_touche(	struct s_edit_carto *edit,
								struct s_commande *com,
								struct s_affi_carto *affi_carto )
{
	int px, py, ox, oy;
	long posx, posy;
	double x_cur;
	double y_cur;
	double rap_ecr;
//------------------------------------------------------
	if (! edit->mouse_out)
	{
		//
		// Souris sur la carto
		//

		if (com->fronts_shift)
		{
			edit->dessine_info[edit->num] = 0;
			if (com->shift & CTRL)
			{
				affi_info_carto( 0, "Zoom +/-.", affi_carto );
			}
			else if (com->shift & SHIFT)
			{
				affi_info_carto( 0, "Pan.", affi_carto );
			}
			else if (com->shift & ALT && edit->etape[edit->num])
			{
				affi_info_carto( 0, "ISO.", affi_carto );
			}
		}

		switch (com->touche)
		{
		case 0:
			break;

		case ALT:
			if (edit->etape[edit->num])
				if (com->shift & ALT)
				{
					rap_ecr = (double) affi_carto->fenetre.carto.lng_y / (double) affi_carto->fenetre.carto.lng_x;
					com->y = affi_carto->curseur.yc2 + (double) (com->x - affi_carto->curseur.xc2) * rap_ecr;
					set_mouse( com->x, com->y );
				}
			break;

		case ESC:
			if (edit->etape[edit->num])
			{
				edit->etape[edit->num] = 0;
				affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &affi_carto->curseur );
			}
			else
				edit->sortir++;

			break;

		case PLUS:
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 2.0 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
			break;

		case MOINS:
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			zoom_change( &edit->com, affi_carto, 0.5 );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
			break;

		case ENTER:
			if (edit->etape[edit->num])
			{
				edit->etape[edit->num] = 0;
				affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &affi_carto->curseur );
				calcule_zoom_zone_carto( affi_carto,
				affi_carto->curseur.xc1 - affi_carto->fenetre.carto.x, affi_carto->curseur.yc1 - affi_carto->fenetre.carto.y,
				affi_carto->curseur.xc2 - affi_carto->fenetre.carto.x, affi_carto->curseur.yc2 - affi_carto->fenetre.carto.y );
				affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
				affiche_carto( affi_carto );
				affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
			}
			else
			{
				edit->etape[edit->num]++;
				edit->dessine_info[edit->num] = 0;
				affiche_curseur_carto( MODE_CARRE_CURSEUR_CARTO, &affi_carto->curseur );
				affi_info_carto( 0, "Alt = ISO.", affi_carto );
			}
			break;

		case SPACE:
			affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
			affi_carto->centre_zoom_x = com->x - affi_carto->fenetre.carto.x;
			affi_carto->centre_zoom_y = com->y - affi_carto->fenetre.carto.y;

			if (com->shift & CTRL)
			{
				affi_carto->offset_origine_x = 0;
				affi_carto->offset_origine_y = 0;
			}
			else
			{
				affi_carto->offset_origine_x = -pixel_x_to_m( com->x, affi_carto );
				affi_carto->offset_origine_y = -pixel_y_to_m( com->y, affi_carto );
			}

			affi_carto->flags.demande_trace_carto = 1;
			affiche_carto( affi_carto );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
			break;

		case TOUCHE_HELP:
			edit->dessine_info[edit->num] = 0;
			affi_info_carto( 2, "[ALT]/[CTRL]/[SHIFT] avec [+/-], [*] Echelle 1, [SPACE] Zero Curseur", affi_carto );
			if (affi_carto->menu.champs)
				edit_help( &affi_carto->menu, affi_carto->menu.champs, VISU_HELP );

			hide_mouse( Screen_Out );
			break;

		case 0x372A:		// ETOILE
			affi_carto->centre_zoom_x = com->x - affi_carto->fenetre.carto.x;
			affi_carto->centre_zoom_y = com->y - affi_carto->fenetre.carto.y;

			posx = affi_carto->offset_carto_x + affi_carto->centre_zoom_x / affi_carto->ech_pix_x;
			posy = affi_carto->offset_carto_y + affi_carto->centre_zoom_y / affi_carto->ech_pix_y;
			affi_carto->centre_zoom_x = ltoi( posx );
			affi_carto->centre_zoom_y = ltoi( posy );

			if (affi_carto->config.unite_visu == UNITE_AFF_METRE)
			{
				affi_carto->echelle_x = 1.0;
				affi_carto->echelle_y = 1.0;
			}
			else if (affi_carto->config.unite_visu == UNITE_AFF_PIXEL)
			{
				affi_carto->ech_pix_x = 1.0;
				affi_carto->ech_pix_y = 1.0;
			}
			else
			{
				affi_carto->ech_pap_x = 1.0;
				affi_carto->ech_pap_y = 1.0;
			}

			affi_carto->flags.demande_trace_carto++;
			affiche_carto( affi_carto );

			affi_carto->offset_carto_x = ftoi( posx - (double) affi_carto->fenetre.carto.lng_x / 2. / affi_carto->ech_pix_x );
			affi_carto->offset_carto_y = ftoi( posy - (double) affi_carto->fenetre.carto.lng_y / 2. / affi_carto->ech_pix_y );

			affi_carto->flags.demande_trace_carto++;
			affiche_carto( affi_carto );

			break;

		default:
			if (! edit->etape[edit->num])
				edit->sortir++;

			break;
		}
	}
	else
	{
		//
		// Souris autour de la carto (sur le menu)
		//

		if (com->touche == ESC)
		{
			if (edit->etape[edit->num])
			{
				edit->etape[edit->num] = 0;
				affiche_curseur_carto( MODE_NORMAL_CURSEUR_CARTO, &affi_carto->curseur );
			}
			else
			{
				edit->sortir++;
			}
		}
	}
}

/***********************************************************/

int edit_carto_menu(	struct s_edit_carto *edit,
							struct s_commande *com,
							struct s_affi_carto *affi_carto )
{
	if (affi_carto->menu.champs)
		switch (gere_menu( com, &affi_carto->menu, affi_carto->menu.champs ))
		{
		case  -1:
			break;

		case DEPL_HORIZ_CARTO:
			affi_carto->offset_carto_x = affi_carto->menu.champs[DEPL_HORIZ_CARTO].valeur;
			affi_carto->flags.demande_trace_carto++;
			affiche_carto( affi_carto );
			break;

		case DEPL_VERT_CARTO:
			affi_carto->offset_carto_y = affi_carto->menu.champs[DEPL_VERT_CARTO].valeur;
			affi_carto->flags.demande_trace_carto++;
			affiche_carto( affi_carto );
			break;

		case PLEIN_ECRAN_CARTO:
			calcule_plein_ecran_carto( affi_carto );
			affiche_carto( affi_carto );
			break;
		}
}

/***********************************************************/

int edit_carto_taches_de_fond(	struct s_edit_carto *edit,
											struct s_commande *com,
											struct s_affi_carto *affi_carto )
{
	int changer = 0;
	long valeur;
	double x;
	double y;
	double xy;
	double x_cur;
	double y_cur;
	char info[256] = {0};
	char status[256] = {0};

	static int _FAR_STATIC init = 0;
	static int _FAR_STATIC xacq[10] = {0};
	static int _FAR_STATIC yacq[10] = {0};
	static int _FAR_STATIC old_xacq[10] = {0};
	static int _FAR_STATIC old_yacq[10] = {0};
	static int _FAR_STATIC affiche_curseur[10] = {0};

	if (! init)
	{
		init++;
		memset( &xacq, -1, sizeof (xacq) );
		memset( &yacq, -1, sizeof (yacq) );
		memset( &old_xacq, -1, sizeof (old_xacq) );
		memset( &old_yacq, -1, sizeof (old_yacq) );
		memset( &affiche_curseur, 0, sizeof (affiche_curseur) );
	}

	if (! (edit->etape[edit->num]))
		if (((com->x - 1) < affi_carto->menu.x) || ((com->x + 1) > (affi_carto->menu.x + affi_carto->menu.lng_x))
		|| ((com->y - 1) < affi_carto->menu.y) || ((com->y + 1) > (affi_carto->menu.y + affi_carto->menu.lng_y)))
			if (affi_carto->config.first_carto)
				edit->sortir++;

	if (edit->dessine_info[edit->num])
	{
		//
		// Pas de changement en cours (ni touche, ni souris)
		//
		pixel_xy_to_acqui( affi_carto->pos_curseur_x, affi_carto->pos_curseur_y, &x_cur, &y_cur, affi_carto );

		xacq[edit->num] = _ftoi( x_cur );
		yacq[edit->num] = _ftoi( y_cur );
		if ((xacq[edit->num] != old_xacq[edit->num]) || (yacq[edit->num] != old_yacq[edit->num]))
			changer = ON;

		switch (edit->dessine_info[edit->num])
		{
		case 1:
			edit->dessine_info[edit->num]++;

			x = m_x_to_rm( pixel_x_to_m( affi_carto->pos_curseur_x, affi_carto ), affi_carto );
			y = m_y_to_rm( pixel_y_to_m( affi_carto->pos_curseur_y, affi_carto ), affi_carto );

			xy = sqrt( x * x + y * y );

			status[0] = 0;
			sprintf( status, "%s[%.4lf](%.4lf,%.4lf) ", (char _FAR_DATA *) status, xy * 1.0, x * 1.0, y * 1.0 );


			if (affi_carto->data_carto->fichier.flags.contenu_ligne_plus_sens)
			{
				get_block_fin_de_ligne( affi_carto->data_carto, affi_carto->data_carto->num_ligne_data );
				strcat( status, affi_carto->data_carto->contenu_ligne_plus_sens.contenu_ligne );
				strcat( status, " " );
			}
			//RVF le 07/06/99 
			if (affi_carto->valeur_carto)
				valeur_carto_to_variable( xacq[edit->num], yacq[edit->num], affi_carto->valeur_carto, affi_carto->data_carto );

			//PV:25.06.99
			valeur = get_valeur_carto( ON, xacq[edit->num], yacq[edit->num], affi_carto->data_carto );

			if (affi_carto->config.valeur)
			{
				str_chp_valeur_carto( valeur, info, sizeof (info) - 10, &affi_carto->palette.unite );

				remplace_all( info, "  ", " " );
				sprintf( status, "%s%s ", (char _FAR_DATA *) status, info );
			}
			affi_info_carto( 1, status, affi_carto );
			break;

		case 2:
			edit->dessine_info[edit->num]++;
			if (affi_carto->config.coupe_x || affi_carto->config.coupe_y)
				if (! affi_carto->coupe.bscan_epaisseur)
					if (edit->dessine_coupe[edit->num])
						if (changer)
						{
							edit->dessine_coupe[edit->num] = 0;
							affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );
							affiche_coupes_carto( affi_carto );
							affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
						}

			break;

		case 3:
			edit->dessine_info[edit->num]++;
			if (affi_carto->config.signal)
				if (changer)
				{
					affiche_ascan_carto( xacq[edit->num], yacq[edit->num], affi_carto );
				}
			break;

		default:
			edit->dessine_info[edit->num] = 0;
			if (xacq[edit->num] != -1)
			{
				old_xacq[edit->num] = xacq[edit->num];
				old_yacq[edit->num] = yacq[edit->num];
			}
			break;
		}
	}
	else
	{
		if (affi_carto->flags.trace_en_cours)
		{
			if (! edit->mouse_out)
				affiche_curseur_carto( EFFACE_CURSEUR_CARTO, &affi_carto->curseur );

			affiche_carto( affi_carto );
			affiche_curseur[edit->num] = 0;
		}

		if ((affi_carto->flags.tracee) && (! affiche_curseur[edit->num]))
		{
			affiche_curseur_carto( AUTORISE_CURSEUR_CARTO, &affi_carto->curseur );
			affiche_curseur_carto( DESSINE_CURSEUR_CARTO, &affi_carto->curseur );
			affiche_curseur[edit->num]++;
		}
	}
}

/***********************************************************/

void dialogue_edit_palette_carto(struct s_dialogue_carto *dial_carto )
{
	if (dial_carto->affi_carto)
		edit_palette_carto( &dial_carto->pmenu, dial_carto->affi_carto, 1 );
}

/***********************************************************/

void dialogue_edit_palette_defaut(struct s_dialogue_carto *dial_carto )
{
	if (dial_carto->affi_carto)
		edit_palette_defaut( &dial_carto->pmenu, dial_carto->affi_carto, 1 );
}

/***********************************************************/
/*
#COM Edit_palette: Affichage d'une palette ( seuils )
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

int affi_palette_carto( struct s_affi_carto *affi_carto, int gere_affiche_carto)
{
	int sortir = 0, select;
	int i, sens = SENS_STRUCT_TO_CHAMPS;

	struct s_dialogue menu;
//-----------------------------------------------------
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\palettes.BOX", &menu )) != NULL)
	{
		if (affi_carto->data_carto != NULL)
			affi_carto->palette.unite.convert = &affi_carto->data_carto->convert;
		else
			affi_carto->palette.unite.convert = NULL;
//--------------------------------------------------------------
		_move_chp_int( sens, &CChamps[NB_SEUILS_ACTIFS], &affi_carto->palette.nb_seuils, 2, NB_SEUILS_MAX, 1, -1 );

		menu.x = 3;
		menu.y = 26;
		menu.flags.push_demande = 0;
		menu.ecran = affi_carto->fenetre.ecran;

		init_menu( &menu, menu.champs );

		calcule_chps_palette_carto( &menu, &affi_carto->palette );
		affiche_champs_modifie( &menu, menu.champs );
//--------------------------------------------------------------
		fin_menu( &menu, menu.champs );
		return (ON);
	}
	return (OFF);
}

/***********************************************************/
/*
#COM Edit_palette: Edition d'une palette ( seuils )
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void edit_palette_carto(struct s_dial_menu * pmenu, struct s_affi_carto *affi_carto, int gere_affiche_carto)
{
	long val = 0;
	int i, sens = SENS_STRUCT_TO_CHAMPS;
	double maxi, mini, dynamique;
	int sortir = 0, select;
	int couleur, num_seuil, redessine = 0;

	char * debut_nom = NULL;
	char nom_palette[MAX_LEN_PATH];
	char nom_f_cfg[MAX_LEN_PATH] = {0};

	static int first = ON;
	struct s_commande com;
	struct s_dialogue menu;
	static struct s_fselect fs;
//-----------------------------------------------------
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\palettes.BOX", &menu )) != NULL)
	{
		memset( &com, 0, sizeof (com) );
		if (pmenu)
		{
			menu.ecran = pmenu->ecran;
			menu.x = pmenu->pos.x1;
			menu.y = pmenu->pos.y1;
			if (menu.lng_x < pmenu->pos.x2)
				menu.lng_x = pmenu->pos.x2;
			if (menu.lng_y < pmenu->pos.y2)
				menu.lng_y = pmenu->pos.y2;
		}
		else
		{
			menu.ecran = affi_carto->fenetre.ecran;
			menu.x = 0;
			menu.y = 0;
		}
		menu.ecran = affi_carto->fenetre.ecran;
		menu.flags.push_demande = 1;

		if (first)
		{
			first = OFF;
			fs.mode = FSELECT_INIT_ET_RETURN | FSELECT_COPY_OUT_TO_INIT;
			file_select( &fs );
			strcpy( fs.filtre, "*.PAL" );
			strcpy( fs.path_init, Path_Stockage );
		}

		if (affi_carto->data_carto != NULL)
			affi_carto->palette.unite.convert = &affi_carto->data_carto->convert;
		else
			affi_carto->palette.unite.convert = NULL;

		set_nom_fichier_chaine( menu.champs[NOM_PALETTE].contenu, affi_carto->palette.nom, menu.champs[NOM_PALETTE].car_x );
		_move_chp_int( sens, &CChamps[NB_SEUILS_ACTIFS], &affi_carto->palette.nb_seuils, 2, NB_SEUILS_MAX, 1, -1 );
		init_menu( &menu, menu.champs );

		calcule_chps_palette_carto( &menu, &affi_carto->palette );
		affiche_champs_modifie( &menu, menu.champs );
		nom_palette[0] = 0;
//--------------------------------------------------------------
		do	
		{
			gere_commande( &com );

			select = gere_menu( &com, &menu, menu.champs );
			if (select != -1)
			{
				switch (select)
				{
				case SORTIR_PALETTE:
					sortir = 1;
					break;

				case SEUIL_PALETTE_ABS:
					redessine++;
					affi_carto->palette.unite.abs = CChamps[SEUIL_PALETTE_ABS].valeur;
					teste_coherence_min_max( &affi_carto->palette );
					calcule_chps_palette_carto( &menu, &affi_carto->palette );
					break;

				case SEUIL_PALETTE_DIRECT:
					affi_carto->palette.unite.affi_relatif = CChamps[SEUIL_PALETTE_DIRECT].valeur;
					calcule_chps_palette_carto( &menu, &affi_carto->palette );
					break;

				case SEUIL_PALETTE_MAXI:
				case SEUIL_PALETTE_MINI:
					if (affi_carto->palette.unite.convert)
					{
						redessine++;
						gere_chp_valeur_carto_direct( &affi_carto->palette.unite.maxi_mesure, &CChamps[SEUIL_PALETTE_MAXI], &affi_carto->palette.unite );
						gere_chp_valeur_carto_direct( &affi_carto->palette.unite.mini_mesure, &CChamps[SEUIL_PALETTE_MINI], &affi_carto->palette.unite );
						teste_coherence_min_max( &affi_carto->palette );
						calcule_chps_palette_carto( &menu, &affi_carto->palette );
					}
					break;

				case SEUIL_CENTRAL:
					redessine++;
					gere_chp_valeur_carto( &affi_carto->palette.seuil_central, &menu.champs[select], &affi_carto->palette.unite );
					calcule_seuils_lineaires( &affi_carto->palette );
					calcule_chps_palette_carto( &menu, &affi_carto->palette );
					break;

				case ECART_ENTRE_SEUILS:
					redessine++;
					val = 0;
					dynamique = (double) affi_carto->palette.unite.maxi_mesure - (double) affi_carto->palette.unite.mini_mesure;
					gere_chp_valeur_carto_direct( &val, &menu.champs[select], &affi_carto->palette.unite );
					affi_carto->palette.ecart_seuils = val / dynamique;
					calcule_seuils_lineaires( &affi_carto->palette );
					calcule_chps_palette_carto( &menu, &affi_carto->palette );
					break;

				case NB_SEUILS_ACTIFS:
					redessine++;
					_move_chp_int( SENS_CHAMPS_TO_STRUCT, &menu.champs[NB_SEUILS_ACTIFS], &affi_carto->palette.nb_seuils, 2, NB_SEUILS_MAX, 1, -1 );
					defaut_seuils_carto( &affi_carto->palette );
					calcule_chps_palette_carto( &menu, &affi_carto->palette );
					break;

				case DEGRADE_COULEURS:
					redessine++;
					_move_chp_flag( SENS_CHAMPS_TO_STRUCT, &menu.champs[DEGRADE_COULEURS], &affi_carto->palette.degrade, -1, 0 );
					break;

				case READ_PALETTE_DISK:
					fs.entete = "Choisir le fichier de la palette  lire.";
					if (file_select( &fs ) != NULL)
					{
						set_ext_fichier( fs.path_total, ".PAL" );
						if (lire_palette_carto( fs.path_total, &affi_carto->palette ))
						{
							message( menu.ecran, "Lecture de la palette Echoue", NULL, 0, MESSAGE_PRINT | ICONE_WARNING, 0 );
						}
						else
						{
							if (affi_carto->data_carto->fichier.nom[0])
							{
								strcpy( affi_carto->config.fichier_palette, fs.path_total );
								strcpy( nom_f_cfg, affi_carto->data_carto->fichier.nom );
//								impose_ext( nom_f_cfg, ".CFC" );
								impose_extention_cfc( nom_f_cfg );	//EB 10/02/2000


								ecrire_cfg_carto( nom_f_cfg, &affi_carto->config );
							}

							set_nom_fichier_chaine( CChamps[NOM_PALETTE].contenu, affi_carto->palette.nom, CChamps[NOM_PALETTE].car_x );
							CChamps[NOM_PALETTE].etat.modifie = 1;
							CChamps[NOM_PALETTE].etat.dessine = 0;

							redessine++;
							strcpy( affi_carto->palette.nom, fs.path_total );
							calcule_chps_palette_carto( &menu, &affi_carto->palette );
						}
					}
					break;

				case WRITE_PALETTE_DISK:
					if ((debut_nom = strrchr( affi_carto->data_carto->fichier.nom, '\\' )) == NULL)
						debut_nom = " ? ";

					strcpy( nom_palette, "Proposition de nom: " );
					strcat( nom_palette, ++debut_nom );
					impose_ext( nom_palette, ".PAL" );

					if (message( menu.ecran, nom_palette, " Accepter@Refuser", 0, MESSAGE_SELECT, 0L ))
					{
						nom_palette[0] = 0;
						fs.entete = "Choisir le fichier de la palette  sauver.";
						if (file_select( &fs ) != NULL)
							strcpy( nom_palette, fs.path_total );

					}
					else
						strcpy( nom_palette, affi_carto->data_carto->fichier.nom );

					if (nom_palette[0])
					{
						impose_ext( nom_palette, ".PAL" );
						if (test_exist( nom_palette ) == 0)
							if (ecrire_palette_carto( nom_palette, &affi_carto->palette ))
								message( menu.ecran, "Ecriture de la palette Echoue", NULL, 0, MESSAGE_PRINT | ICONE_WARNING, 0 );

					}
					break;

				default:
					if ((select >= REGLAGE_COUL_SEUIL_DEB && (select < (REGLAGE_COUL_SEUIL_DEB + affi_carto->palette.nb_seuils))))
					{
						redessine++;
						couleur = affi_carto->palette.nb_seuils - select + REGLAGE_COUL_SEUIL_DEB - 1;
						edit_rvb( &affi_carto->palette.rouge_seuil[couleur], &affi_carto->palette.vert_seuil[couleur], &affi_carto->palette.bleu_seuil[couleur] );
					}
					else if ((select >= SEUIL_PALETTE_DEB && (select < (SEUIL_PALETTE_DEB + affi_carto->palette.nb_seuils))))
					{
						redessine++;
						num_seuil = affi_carto->palette.nb_seuils - select + SEUIL_PALETTE_DEB;
						gere_chp_valeur_carto( &affi_carto->palette.seuils[num_seuil], &menu.champs[select], &affi_carto->palette.unite );

						if (teste_coherence_palette( &affi_carto->palette, num_seuil ))
						{
							for (i = 0;  i <= affi_carto->palette.nb_seuils;  i++)
							{
								init_chp_valeur_carto( affi_carto->palette.seuils[i], &menu.champs[SEUIL_PALETTE_DEB + affi_carto->palette.nb_seuils - i], &affi_carto->palette.unite );
							}
						}
						affiche_palette_lineaire( menu.ecran, menu.x + menu.champs[PALETTE_ECART_VARIABLE].pos_x,
						menu.y + menu.champs[PALETTE_ECART_VARIABLE].pos_y,
						menu.champs[PALETTE_ECART_VARIABLE].lng_x,
						menu.champs[PALETTE_ECART_VARIABLE].lng_y,
						&affi_carto->palette );
					}
				}
				affiche_champs_modifie( &menu, menu.champs );
			}

			if (! com.change)
				if (gere_affiche_carto)
				{
					if (redessine)
						affi_carto->flags.demande_trace_carto = 1;

					affiche_carto( affi_carto );
					if (xy_sur_carto( com.x, com.y, affi_carto ))
						edit_carto( ESC, affi_carto );

					redessine = 0;
				}
		}
		while (sortir == 0 && com.touche != ESC);
		fin_menu( &menu, menu.champs );
	}
}


void edit_palette_defaut(struct s_dial_menu * pmenu, struct s_affi_carto *affi_carto, int gere_affiche_carto)
{
	long valeur;
	int x, y, x1, y1;
	int i, ecran;

	int source = 0;
	int destination = 0;
	int sortir = 0;
	int select = -1;
	int redessine = 0;

	int old_pal_ref = -1;
	int ref_r = 0, ref_v = 0, ref_b = 0;

	char * debut_nom = NULL;
	char nom_palette[MAX_LEN_PATH];

	struct s_commande com;
	struct s_dialogue menu;
	struct s_palette_carto * palette;

	static int first = 0;
	static struct s_fselect fs;
	static struct s_attributs att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};
//--------------------------------------------------------------------------
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\pal_def.BOX", &menu )) != NULL)
	{
		memset( &com, 0, sizeof (com) );
		palette = &affi_carto->palette;
		menu.ecran = ecran = affi_carto->fenetre.ecran;

		if (first++ == 0)
		{
			fs.mode = FSELECT_INIT_ET_RETURN | FSELECT_COPY_OUT_TO_INIT;
			file_select( &fs );
			strcpy( fs.filtre, "*.PAL" );
			strcpy( fs.path_init, Path_Local_Data );
		}

		if (pmenu)
		{
			menu.ecran = pmenu->ecran;
			menu.x = pmenu->pos.x1;
			menu.y = pmenu->pos.y1;
			if (menu.lng_x < pmenu->pos.x2)
				menu.lng_x = pmenu->pos.x2;
			if (menu.lng_y < pmenu->pos.y2)
				menu.lng_y = pmenu->pos.y2;
		}
		else
		{
			menu.x = 0;
			menu.y = 0;
		}

		for (i = 0;  i < palette->nb_couleurs_err;  i++)
		{
			valeur = affi_carto->data_carto->convert.erreur_mesure | i;
			menu.champs[i + PAL_DEF_COULEUR].couleur = 
			menu.champs[i + PAL_DEF_COULEUR].fcouleur = i + palette->offset_couleur_err;

			str_chp_valeur_carto(
			valeur,
			menu.champs[i + PAL_DEF_NOM].contenu,
			menu.champs[i + PAL_DEF_NOM].car_x,
			&palette->unite );
		}

		menu.flags.push_demande = 1;
		init_menu( &menu, menu.champs );
		menu.flags.push_demande = 0;

		do	
		{
			gere_commande( &com );
         /*
			if (com.touche == Tab_Ctrl['c' - 'a'])

			if (com.touche == Tab_Ctrl['v' - 'a'])
         */
			select = gere_menu( &com, &menu, menu.champs );
			if (select != -1)
			{
				switch (select)
				{
				case PAL_DEF_SORTIR:
					sortir = 1;
					break;

				case PAL_DEF_LIRE:
					fs.entete = "Choisir le fichier de la palette  lire.";
					if (file_select( &fs ) != NULL)
					{
						set_ext_fichier( fs.path_total, ".PAL" );
						if (lire_palette_carto( fs.path_total, &affi_carto->palette ))
						{
							message( menu.ecran, "Lecture de la palette Echoue", NULL, 0, MESSAGE_PRINT | ICONE_WARNING, 0 );
						}
						else
						{
							redessine++;
						}
					}
					break;

				case PAL_DEF_ECRIRE:
					if ((debut_nom = strrchr( affi_carto->data_carto->fichier.nom, '\\' )) == NULL)
						debut_nom = " ? ";

					strcpy( nom_palette, "Proposition de nom: " );
					strcat( nom_palette, ++debut_nom );
					impose_ext( nom_palette, ".PAL" );

					if (message( menu.ecran, nom_palette, " Accepter@Refuser", 0, MESSAGE_SELECT, 0L ))
					{
						nom_palette[0] = 0;
						fs.entete = "Choisir le fichier de la palette  sauver.";
						if (file_select( &fs ) != NULL)
							strcpy( nom_palette, fs.path_total );
					}
					else
						strcpy( nom_palette, affi_carto->data_carto->fichier.nom );

					if (nom_palette[0])
					{
						impose_ext( nom_palette, ".PAL" );
						if (test_exist( nom_palette ) == 0)
							if (ecrire_palette_carto( nom_palette, &affi_carto->palette ))
								message( menu.ecran, "Ecriture de la palette Echoue", NULL, 0, MESSAGE_PRINT | ICONE_WARNING, 0 );
					}
					break;

				default:
					if (select == L_SOURCE_COULEUR_PAL_DEF)
					{
						source = ~source & 1;
						destination = 0;
					}

					if (select == L_DESTINATION_COULEUR_PAL_DEF)
						destination++;

					if ((select >= PAL_DEF_NOM)
					&& (select < PAL_DEF_NOM + palette->nb_couleurs_err))
					{
						select = select - PAL_DEF_NOM + PAL_DEF_COULEUR;
					}

					if ((select >= PAL_DEF_COULEUR)
					&& (select < PAL_DEF_COULEUR + palette->nb_couleurs_err))
					{
						redessine = 1;
						i = select - PAL_DEF_COULEUR;
						old_pal_ref = i;

						if (! source)
							edit_rvb(
							&affi_carto->palette.rouge_erreur[i],
							&affi_carto->palette.vert_erreur[i],
							&affi_carto->palette.bleu_erreur[i] );
						else if ((old_pal_ref != -1) && (! destination))
						{
							ref_r = affi_carto->palette.rouge_erreur[old_pal_ref];
							ref_v = affi_carto->palette.vert_erreur[old_pal_ref];
							ref_b = affi_carto->palette.bleu_erreur[old_pal_ref];
						}
						if (destination)
						{
							//source = 0;
							destination = 0;
							if (old_pal_ref != -1)
							{
								affi_carto->palette.rouge_erreur[old_pal_ref] = ref_r;
								affi_carto->palette.vert_erreur[old_pal_ref] = ref_v;
								affi_carto->palette.bleu_erreur[old_pal_ref] = ref_b;
							}
						}
					}
					break;
				}
				affiche_champs_modifie( &menu, menu.champs );
			}

			if (! com.change)
				if (gere_affiche_carto)
				{
					if (redessine)
					{
						redessine = 0;
						affi_carto->flags.demande_trace_carto = 1;
					}

					affiche_carto( affi_carto );
					if (xy_sur_carto( com.x, com.y, affi_carto ))
						edit_carto( ESC, affi_carto );
				}
		}
		while (sortir == 0 && com.touche != ESC);
		fin_menu( &menu, menu.champs );
	}
}


/***********************************************************/
#pragma message("Calcule_seuils_lineaire")
/*
#COM calcule_seuils_lineaire: calcul des seuils en fonction d'un seuil central d'une palette ( seuils )
#COM 									 Et d'un cart entre seuils
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void calcule_seuils_lineaires(struct s_palette_carto *palette)
{
	double s;
	int i, num_seuil_central;
//-----------------------------------------------------------
	num_seuil_central = palette->nb_seuils / 2;
	s = palette->seuils[num_seuil_central] = 
	palette->seuil_central = min_max_double( palette->seuil_central, 0, 1 );
	palette->ecart_seuils = min_max_double( palette->ecart_seuils, 0.000001, 0.5 );

	for (i = num_seuil_central - 1;  i > 0;  i--)
	{
		s -= palette->ecart_seuils;
		palette->seuils[i] = s;
	}

	s = palette->seuil_central;
	for (i = num_seuil_central + 1;  i < palette->nb_seuils;  i++)
	{
		s += palette->ecart_seuils;
		palette->seuils[i] = s;
	}

	for (;i < NB_SEUILS_MAX;  i++)
		palette->seuils[i] = 1;

	teste_coherence_palette( palette, num_seuil_central );
}

/***********************************************************/
#pragma message("calcul_chp_palette_carto")
/*
#COM calcul_chp_palette_carto: calcul des positions des champs d'une palette
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void calcule_chps_palette_carto(struct s_dialogue *menu, struct s_palette_carto *palette)
{
	int sens = SENS_STRUCT_TO_CHAMPS;
	int i, x, y, xd, yd, ofy1, ofy2, lngy;
	int 				autorise_abs = 0;
	long val;
	double dynamique = 100.0, mini = 0;
//-----------------------------------------------------------------
	mini = (double) palette->unite.mini_mesure;
	dynamique = (double) palette->unite.maxi_mesure - mini;
//-------------------------------------------
	if (palette->nb_seuils)
	{
		for (i = 0;  i <= NB_SEUILS_MAX;  i++)
		{
			if (menu->champs[SEUIL_PALETTE_DEB + i].etat.dessine)
			{
				efface_champ( menu, &menu->champs[SEUIL_PALETTE_DEB + i] );
				efface_champ( menu, &menu->champs[UNITE_SEUIL_PALETTE_DEB + i] );
				if (i < NB_SEUILS_MAX)
					efface_champ( menu, &menu->champs[REGLAGE_COUL_SEUIL_DEB + i] );
			}
		}

		yd = menu->champs[PALETTE_ECART_FIXE].pos_y;
		lngy = menu->champs[PALETTE_ECART_FIXE].lng_y;

		ofy1 = Tableau_fontes[menu->champs[UNITE_SEUIL_PALETTE_DEB].fonte].hauteur_fonte / 2;
		ofy2 = menu->champs[REGLAGE_COUL_SEUIL_DEB].lng_y / 2;

		for (i = 0;  i <= palette->nb_seuils;  i++)
		{
			menu->champs[SEUIL_PALETTE_DEB + i].pos_y = 
			menu->champs[UNITE_SEUIL_PALETTE_DEB + i].pos_y = yd - ofy1 + i * lngy / palette->nb_seuils;
			if (i < palette->nb_seuils)
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].pos_y = yd - ofy2 + ((double) i + 0.5) * lngy / palette->nb_seuils;

			menu->champs[SEUIL_PALETTE_DEB + i].type.invisible = 
			menu->champs[UNITE_SEUIL_PALETTE_DEB + i].type.invisible = 0;

			if (i <= palette->nb_seuils && i >= 0)
			{
				menu->champs[SEUIL_PALETTE_DEB + i].type.selectable = 1;
				menu->champs[SEUIL_PALETTE_DEB + i].type.relief = 1;
			}
			else
			{
				menu->champs[SEUIL_PALETTE_DEB + i].type.selectable = 0;
				menu->champs[SEUIL_PALETTE_DEB + i].type.relief = 0;
			}

			if (i < palette->nb_seuils)
			{
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.invisible = 0;
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.selectable = 1;
			}
			else
			{
				if (i < NB_SEUILS_MAX)
				{
					menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.invisible = 1;
					menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.selectable = 0;
				}
			}
		}

		for (;i <= NB_SEUILS_MAX;  i++)
		{
			menu->champs[SEUIL_PALETTE_DEB + i].type.invisible = 
			menu->champs[UNITE_SEUIL_PALETTE_DEB + i].type.invisible = 1;
			if (i < NB_SEUILS_MAX)
			{
				menu->champs[SEUIL_PALETTE_DEB + i].type.selectable = 0;
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.invisible = 1;
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].type.selectable = 0;
			}
		}

		for (i = 0;  i <= NB_SEUILS_MAX;  i++)
		{
			menu->champs[SEUIL_PALETTE_DEB + i].etat.modifie = 
			menu->champs[UNITE_SEUIL_PALETTE_DEB + i].etat.modifie = 1;
			if (i < NB_SEUILS_MAX)
				menu->champs[REGLAGE_COUL_SEUIL_DEB + i].etat.modifie = 1;
		}

		for (i = 0;  i <= palette->nb_seuils;  i++)
		{
			init_chp_unite_carto( &menu->champs[UNITE_SEUIL_PALETTE_DEB + palette->nb_seuils - i], &palette->unite );
			init_chp_valeur_carto( palette->seuils[i], &menu->champs[SEUIL_PALETTE_DEB + palette->nb_seuils - i], &palette->unite );
		}
	}
//------------------------------------------------------------
	affiche_champ( menu, &menu->champs[PALETTE_ECART_FIXE] );
	affiche_champ( menu, &menu->champs[PALETTE_ECART_VARIABLE] );

	affiche_palette_lineaire( menu->ecran, menu->x + menu->champs[PALETTE_ECART_VARIABLE].pos_x,
	menu->y + menu->champs[PALETTE_ECART_VARIABLE].pos_y,
	menu->champs[PALETTE_ECART_VARIABLE].lng_x,
	menu->champs[PALETTE_ECART_VARIABLE].lng_y,
	palette );

	affiche_palette_seuil( menu->ecran, menu->x + menu->champs[PALETTE_ECART_FIXE].pos_x,
	menu->y + menu->champs[PALETTE_ECART_FIXE].pos_y,
	menu->champs[PALETTE_ECART_FIXE].lng_x,
	menu->champs[PALETTE_ECART_FIXE].lng_y,
	palette );
//-------------------------------------------------------------
	set_nom_fichier_chaine( menu->champs[NOM_PALETTE].contenu, palette->nom, menu->champs[NOM_PALETTE].car_x );

	if (palette->unite.convert)
	{
		//if (palette->unite.convert->nb_octets == 1)
		if (palette->unite.convert->offset_stockage != 0)
		{
			autorise_abs = 1;
		}
	}
	if (! autorise_abs)
	{
		palette->unite.abs = 0;
		menu->champs[SEUIL_PALETTE_ABS].type.selectable = 0;
	}
	else
	{
		menu->champs[SEUIL_PALETTE_ABS].type.selectable = 1;
	}
	_move_chp_flag( sens, &menu->champs[SEUIL_PALETTE_ABS], &palette->unite.abs, 0, -1 );


	_move_chp_flag( sens, &menu->champs[SEUIL_PALETTE_DIRECT], &palette->unite.affi_relatif, 0, -1 );
	_move_chp_flag( sens, &menu->champs[DEGRADE_COULEURS], &palette->degrade, 0, -1 );
	_move_chp_int( sens, &menu->champs[NB_SEUILS_ACTIFS], &palette->nb_seuils, 2, NB_SEUILS_MAX, 1, -1 );

	init_chp_valeur_carto( palette->seuil_central, &menu->champs[SEUIL_CENTRAL], &palette->unite );

	val = palette->ecart_seuils * dynamique;
	init_chp_valeur_carto_direct( val, &menu->champs[ECART_ENTRE_SEUILS], &palette->unite );

	init_chp_valeur_carto_direct( palette->unite.maxi_mesure, &menu->champs[SEUIL_PALETTE_MAXI], &palette->unite );
	init_chp_valeur_carto_direct( palette->unite.mini_mesure, &menu->champs[SEUIL_PALETTE_MINI], &palette->unite );
}

/***********************************************************/
#pragma message("affiche_palette_lineaire")
/*
#COM affiche_palette_lineaire: affichage d'une palette en linaire (non seuill)
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void affiche_palette_lineaire(int ecran, int pos_x, int pos_y, int lng_x, int lng_y , struct s_palette_carto *palette)
{
	int i,  y1, y2, s;
	unsigned long maxi;
	static struct s_attributs att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};
	int mem_mono;
//-----------------------------------------------------------------
	clear_mouse( ecran );
//	pos_x += EPAISSEUR_RELIEF;
//	pos_y += EPAISSEUR_RELIEF;
	lng_x -= EPAISSEUR_RELIEF;
	lng_y -= EPAISSEUR_RELIEF;
	mem_mono = Ecran[ecran].mode_monochrome;
	set_mode_monochrome( ecran, 0 );


	for (s = 0;  s < palette->nb_seuils;  s++)
	{
		att.couleur = att.fcouleur = (double ) (s + .5) * 
		(double ) palette->nb_couleurs_val / palette->nb_seuils + palette->offset_couleur_val;

		y1 = (1.0 - palette->seuils[s]) * lng_y;
		y2 = (1.0 - palette->seuils[s + 1]) * lng_y;

		box( ecran, pos_x, pos_y + y1, pos_x + lng_x, pos_y + y2, &att );
	}
	set_mode_monochrome( ecran, mem_mono );

}

/***********************************************************/
#pragma message("affiche_palette_fixe")
/*
#COM affiche_palette_fixe: affichage d'une palette en fixe (seuill)
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void affiche_palette_seuil(int ecran, int pos_x, int pos_y, int lng_x, int lng_y , struct s_palette_carto *palette)
{
	int i,  y;
	static struct s_attributs att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};
	int mem_mono;

//----------------------------------------------------------------------
	clear_mouse( ecran );
//	pos_x += EPAISSEUR_RELIEF;
//	pos_y += EPAISSEUR_RELIEF;
	lng_x -= EPAISSEUR_RELIEF;
	lng_y -= EPAISSEUR_RELIEF;
	mem_mono = Ecran[ecran].mode_monochrome;
	set_mode_monochrome( ecran, 0 );


	for (y = 0;  y <= lng_y;  y++)
	{
		att.couleur = att.fcouleur = ((long) palette->nb_couleurs_val * y / lng_y) + palette->offset_couleur_val;
		line( ecran, pos_x, pos_y + lng_y - y, pos_x + lng_x, pos_y + lng_y - y, &att );
	}
	set_mode_monochrome( ecran, mem_mono );

}

/***********************************************************/
#pragma message("teste_coherence_min_max")
/*
#COM teste_coherence_min_max: teste la cohrence des valeurs de la palette
#COM 
#COM         IN: struct palette *, numro du dernier seuil modifi
#COM             
#COM 
#COM        OUT:
#COM  
*/

int teste_coherence_min_max( struct s_palette_carto *palette)
{
	#define ERR_FTOL 0.5

	long unsigned taille;
	double mini, maxi, dynamique;
//--------------------------------------------------
	if (palette->unite.convert)
	{
		palette->unite.nb_division_par_2 = min_max_int( palette->unite.nb_division_par_2, 0, 20 );
		if (palette->unite.convert->coef == 0)
			palette->unite.convert->coef = 1;

		if (palette->unite.convert->taille_table_affichage > 0)
		{
			taille = 
			palette->unite.convert->taille_table_affichage = 
			min_max_long( palette->unite.convert->taille_table_affichage, 200L, 0xFFF0L );

			palette->unite.nb_division_par_2 = 0;

			if (palette->unite.abs)
				palette->unite.mini_mesure = 0;

			maxi = (palette->unite.maxi_mesure / palette->unite.convert->coef) - palette->unite.convert->offset_stockage;
			mini = (palette->unite.mini_mesure / palette->unite.convert->coef) - palette->unite.convert->offset_stockage;

			if (palette->unite.abs)
			{
				maxi *= 2;
				mini *= 2;
			}

			dynamique = maxi - mini;
			while (dynamique > taille)
			{
				dynamique /= 2;
				palette->unite.nb_division_par_2++;
			}
			palette->unite.nb_division_par_2 = min_max_int( palette->unite.nb_division_par_2, 0, 20 );
			taille <<= palette->unite.nb_division_par_2;

			if (maxi <= mini)
				maxi = mini + 1;

			if ((maxi - mini + 1) > taille)
				maxi = mini + taille - 1;

			if (palette->unite.abs)
			{
				maxi /= 2;
				mini /= 2;
			}

			maxi = palette->unite.convert->coef * (maxi + palette->unite.convert->offset_stockage);
			mini = palette->unite.convert->coef * (mini + palette->unite.convert->offset_stockage);

			if (maxi > 0)
				maxi += ERR_FTOL;
			if (mini > 0)
				mini += ERR_FTOL;

			palette->unite.maxi_mesure = maxi;
			palette->unite.mini_mesure = mini;
		}
	}
}

/***********************************************************/
#pragma message("teste_coherence_palette")
/*
#COM teste_coherence_palette: teste la cohrence des valeurs de la palette
#COM 
#COM         IN: struct palette *, numro du dernier seuil modifi
#COM             
#COM 
#COM        OUT:
#COM  
*/

int teste_coherence_palette( struct s_palette_carto *palette, int numero_depart)
{
	int i, num;
	int ok = 1;
	int sens = 0;
	int retour = 0;

	double mini = 0.0001;
//----------------------------------------------------------------
	palette->nb_seuils = min_max_int( palette->nb_seuils, 2, NB_SEUILS_MAX );
	mini = 1.0 / (palette->unite.maxi_mesure - palette->unite.mini_mesure + 1);

	//----------------------------------------------------
	// Si le seuil a dpass par le haut -> sens positif sinon sens ngatif

	if ((numero_depart > 0) && (numero_depart < NB_SEUILS_MAX))
	{
		num = numero_depart;
		if (palette->seuils[num] >= palette->seuils[num + 1])
			sens = 1;

		do	
		{						// Tant qu'il y a des seuils inverss
			ok = 1;
			for (i = 0;  i < palette->nb_seuils;  i++)
			{
			// Pour tous les seuils
				if (palette->seuils[i] >= palette->seuils[i + 1])
				{
				// Si deux seuils sont inverss
					retour = 1;	// Retour = 1 -> rafficher les seuils
					if (sens)
					{
					// Si le seuil a dpass par le haut
						while (i < (palette->nb_seuils - 1) && palette->seuils[i] >= palette->seuils[i + 1])
						{
							i++;	// Dcaler les seuils vers le haut
							palette->seuils[i] = palette->seuils[i - 1] + mini;
						}
					// si le dernier seuil est >  1
						if (palette->seuils[palette->nb_seuils - 1] >= 1.0)
						{
							sens = 0;	// Dcaler dans l'autre sens
							ok = 0;
							i = -1;
						}
						else
						{
							ok = 1;
						}
					}
					else
					{
					// Si le seuil a dpass par le bas
						while (i > 0 && palette->seuils[i] >= palette->seuils[i + 1])
						{
							palette->seuils[i] = palette->seuils[i + 1] - mini;
							i--;	// Dcaler les seuils vers le bas
						}
						if (palette->seuils[1] <= 0)
						{
							sens = 1;	// Dcaler dans l'autre sens
							ok = 0;
							i = -1;
						}
						else
						{
							ok = 1;
						}
					}
				}
			}
		}
		while (ok == 0);
	}
//---------------------------------------------------- controle en sus !
	// Le premier doit tre  0
	palette->seuils[0] = 0;

	// Le dernier doit tre  1.0
	palette->seuils[palette->nb_seuils] = 1.0;

	palette->seuil_central = min_max_double( palette->seuil_central, mini, 1 - mini );
	palette->ecart_seuils = min_max_double( palette->ecart_seuils, mini, 1.0 / palette->nb_seuils );

	for (i = 1;  i < palette->nb_seuils;  i++)
		palette->seuils[i] = min_max_double( palette->seuils[i], palette->seuils[i - 1] + mini, palette->seuils[i + 1] - mini );

	for (;i < NB_SEUILS_MAX;  i++)
		palette->seuils[i] = 1;
//----------------------------------------------------
	return (retour);
}

/***********************************************************/

int zoom_change(struct s_commande *com, struct s_affi_carto *affi_carto, double coeff)
{
	affi_carto->centre_zoom_x = com->x - affi_carto->fenetre.carto.x;
	affi_carto->centre_zoom_y = com->y - affi_carto->fenetre.carto.y;

	calcule_zoom_carto( affi_carto, coeff );
	affiche_carto( affi_carto );
}

/***********************************************************/
#pragma message("read_write_palette_carto")
/*
#COM read_write_palette_carto: Lit et crit le descriptif de la palette ( seuils + couleurs )
#COM 
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void read_write_palette_carto(  int ordre , char *buffer , struct s_palette_carto *palette )
{
	int i;
	char buf[80];

	fich_tableau_int( ordre, buffer, "ROUGE: ", palette->rouge_seuil, NB_SEUILS_MAX );
	fich_tableau_int( ordre, buffer, "VERT: ", palette->vert_seuil, NB_SEUILS_MAX );
	fich_tableau_int( ordre, buffer, "BLEU: ", palette->bleu_seuil, NB_SEUILS_MAX );

	fich_tableau_int( ordre, buffer, "ROUGE DEFAUT: ", palette->rouge_erreur, NB_SEUILS_ERREUR );
	fich_tableau_int( ordre, buffer, "VERT DEFAUT: ", palette->vert_erreur, NB_SEUILS_ERREUR );
	fich_tableau_int( ordre, buffer, "BLEU DEFAUT: ", palette->bleu_erreur, NB_SEUILS_ERREUR );

	fich( ordre | D_INT, buffer, "NB SEUILS: ", &palette->nb_seuils );

	fich_tableau_double( ordre, buffer, "VAL SEUILS: ", palette->seuils, NB_SEUILS_MAX + 1 );

	fich( ordre | D_FLAG, buffer, "DEGRADE: ", &palette->degrade );
	fich( ordre | D_DOUBLE, buffer, "SEUIL CENTRAL: ", &palette->seuil_central );
	fich( ordre | D_DOUBLE, buffer, "ECART SEUILS: ", &palette->ecart_seuils );

	fich( ordre | D_FLAG, buffer, "ABSOLU: ", &palette->unite.abs );
	fich( ordre | D_LONG, buffer, "MAXI: ", &palette->unite.maxi_mesure );
	fich( ordre | D_LONG, buffer, "MINI: ", &palette->unite.mini_mesure );
}

/* Lecture et initialisation de tous les paramtres de palette depuis un 
	fichier Disque ( couleurs, seuils, ... ) */

int lire_palette_carto(char *nom_fichier, struct s_palette_carto *palette)
{
	char * buffer;
//-------------------------------------------------------
	set_ext_fichier( nom_fichier, ".PAL" );

	if ((buffer = lire_ascii( nom_fichier )) != NULL)
	{
		read_write_palette_carto( D_READ, buffer, palette );
		D16MemFree( buffer );

		set_nom_fichier_chaine( palette->nom, nom_fichier, LNG_MAX_PATH );
		teste_coherence_min_max( palette );
		teste_coherence_palette( palette, -1 );
		return (0);
	}
	return (-1);
}

/***********************************************************/
/* Ecriture  de tous les paramtres de la palette sur un	fichier Disque 
	palette */

int ecrire_palette_carto(char *nom_fichier, struct s_palette_carto *palette)
{
	char * buffer;
	int echoue;
//-------------------------------------------------------
	set_ext_fichier( nom_fichier, ".PAL" );

	if ((buffer = D16MemAlloc( TAILLE_BUFFER )) != NULL)
	{
		*buffer = 0;
		read_write_palette_carto( D_WRITE, buffer, palette );
		remove( nom_fichier );
		echoue = ecrire_ascii( nom_fichier, buffer );
		D16MemFree( buffer );
	}
	else
		echoue = -1;

	return (echoue);
}

/***********************************************************/

void read_write_cfg_ecran_carto(int ordre, char *buffer, struct s_config_generale_carto *cfg_generale )
{
	int old_ver = 0;
	int version = 99;

	if (ordre == D_WRITE)
		strcpy( buffer, "[ Configuration du module de cartographie ]\n\n" );

	if (ordre == D_WRITE)
	{
		old_ver = version;
		fich( ordre | D_INT, buffer, "Version.............:", &version );
	}
	else
		fich( ordre | D_INT, buffer, "Version.............:", &old_ver );

	if (old_ver != version)
	{
		fich( ordre | D_INT, buffer, "NB_CARTO:", &cfg_generale->nb_cartos );
		fich( ordre | D_INT, buffer, "NB_CARTO_HORIZONTALES:", &cfg_generale->nb_cartos_horizontales );
		fich( ordre | FLAG, buffer, "MULTI_PALETTE:", &cfg_generale->multi_palette );
		fich( ordre | D_DOUBLE, buffer, "TAILLE_ECRAN_X:", &cfg_generale->config.taille_ecran_x );
		fich( ordre | D_DOUBLE, buffer, "TAILLE_ECRAN_Y:", &cfg_generale->config.taille_ecran_y );
		fich( ordre | D_DOUBLE, buffer, "TAILLE_PAPIER_X:", &cfg_generale->config.taille_papier_x );
		fich( ordre | D_DOUBLE, buffer, "TAILLE_PAPIER_Y:", &cfg_generale->config.taille_papier_y );
	}
	else
	{
		fich( ordre | D_INT, buffer, "NB CARTO............:", &cfg_generale->nb_cartos );
		fich( ordre | D_FLAG, buffer, "MULTI EDITION (O/N).:", &cfg_generale->multi_edition );
		fich( ordre | D_FLAG, buffer, "MULTI PALETTE (O/N).:", &cfg_generale->multi_palette );
		fich( ordre | D_DOUBLE, buffer, "TAILLE ECRAN X (mm).:", &cfg_generale->config.taille_ecran_x );
		fich( ordre | D_DOUBLE, buffer, "TAILLE ECRAN Y (mm).:", &cfg_generale->config.taille_ecran_y );
		fich( ordre | D_DOUBLE, buffer, "TAILLE PAPIER X (mm):", &cfg_generale->config.taille_papier_x );
		fich( ordre | D_DOUBLE, buffer, "TAILLE PAPIER Y (mm):", &cfg_generale->config.taille_papier_y );
	}
}

/***********************************************************/

int lire_cfg_ecran_carto( char *nom_fichier, struct s_config_generale_carto *cfg_generale )
{
	char * buffer;

	set_ext_fichier( nom_fichier, ".CRT" );
	if ((buffer = lire_ascii( nom_fichier )) != NULL)
	{
		read_write_cfg_ecran_carto( D_READ, buffer, cfg_generale );
		D16MemFree( buffer );
		return (0);
	}
	return (-1);

}

/***********************************************************/

int ecrire_cfg_ecran_carto(char *nom_fichier, struct s_config_generale_carto *cfg_generale )
{
	int echoue;
	char * buffer;

	set_ext_fichier( nom_fichier, ".CRT" );
	if ((buffer = D16MemAlloc( TAILLE_BUFFER )) != NULL)
	{
		*buffer = 0;
		read_write_cfg_ecran_carto( D_WRITE, buffer, cfg_generale );
		remove( nom_fichier );
		echoue = ecrire_ascii( nom_fichier, buffer );
		D16MemFree( buffer );
	}
	else
		echoue = -1;

	return (echoue);

}

/***********************************************************/

void read_write_cfg_carto(int ordre, char *buffer, struct s_config_carto * cfg_carto )
{                   
	fich( ordre | D_INT, buffer, "UNITE_AFFICHAGE:", &cfg_carto->unite_visu );

	//RVF le 11/06/04
	//Le D_FAST a t mis en com car pb lors de l'execution de macro_config_carto.

	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "ISO:", &cfg_carto->isometrique );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "MIRROIR_X:", &cfg_carto->mirroir_x );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "MIRROIR_Y:", &cfg_carto->mirroir_y );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "MIRROIR:", &cfg_carto->inversion_x_y );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "PEIGNE:", &cfg_carto->compensation_peigne );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "SENS_PEIGNE:", &cfg_carto->peigne_pair );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "MODE_COMPRESSION:", &cfg_carto->mode_compression );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "EN_MEMOIRE:", &cfg_carto->en_memoire );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "AFF_VALEUR:", &cfg_carto->valeur );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "BSCAN_EPAISSEUR:", &cfg_carto->bscan_epaisseur );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "AFFICHE_ECHELLE_X:", &cfg_carto->echelle_x );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "AFFICHE_ECHELLE_Y:", &cfg_carto->echelle_y );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "AFFICHE_PALETTE:", &cfg_carto->palette );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "AFFICHE_SIGNAL:", &cfg_carto->signal );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "COUPE_X:", &cfg_carto->coupe_x );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "COUPE_Y:", &cfg_carto->coupe_y );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "COUPE_LIGNE:", &cfg_carto->ligne_coupe );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "COUPE_PLEIN:", &cfg_carto->remplir_coupe );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "COUPE_INVERSE:", &cfg_carto->inverse_coupe );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "CURSEUR_X:", &cfg_carto->curseur_x );
	fich( ordre | D_FLAG	/*| D_FAST*/, buffer, "CURSEUR_Y:", &cfg_carto->curseur_y );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "TAILLE_COUPE:", &cfg_carto->marge_coupes );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "TAILLE_ECHELLE:", &cfg_carto->marge_echelles );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "TAILLE_PALETTE:", &cfg_carto->marge_palette );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "COULEUR_CURSEUR:", &cfg_carto->couleur_curseur );
	fich( ordre | D_INT	/*| D_FAST*/, buffer, "COULEUR_FOND_CARTO:", &cfg_carto->fcouleur_carto );

//	fich( ordre | D_INT /*| D_FAST*/, buffer, "COULEUR_FOND_CARTO:", &cfg_carto->fcouleur_carto );

	fich( ordre | D_CHAR	/*| D_FAST*/, buffer, "NOM_FICHIER_ASCAN:", &cfg_carto->fichier_ascan[0] );

	fich( ordre | D_INT	/*| D_FAST*/, buffer, "MEMO PALETTE:", &cfg_carto->conserve_derniere_palette );
	fich( ordre | D_CHAR	/*| D_FAST*/, buffer, "NOM FICHIER PALETTE:", cfg_carto->fichier_palette );
}

/***********************************************************/

int lire_cfg_carto( char *nom_fichier, struct s_config_carto * cfg_carto )
{
	char * buffer;

	impose_extention_cfc( nom_fichier );	//EB 10/02/2000
//	set_ext_fichier( nom_fichier, ".CFC" );

	if ((buffer = lire_ascii( nom_fichier )) != NULL)
	{
		read_write_cfg_carto( D_READ, buffer, cfg_carto );
		D16MemFree( buffer );
		return (0);
	}
	return (-1);

}

/***********************************************************/

int ecrire_cfg_carto(char *nom_fichier, struct s_config_carto * cfg_carto )
{
	int echoue;
	char * buffer;

//	set_ext_fichier( nom_fichier, ".CFC" );
	impose_extention_cfc( nom_fichier );	//EB 10/02/2000

	if ((buffer = D16MemAlloc( TAILLE_BUFFER )) != NULL)
	{
		*buffer = 0;
		read_write_cfg_carto( D_WRITE, buffer, cfg_carto );
		remove( nom_fichier );
		echoue = ecrire_ascii( nom_fichier, buffer );
		D16MemFree( buffer );
	}
	else
		echoue = -1;

	return (echoue);

}

/***********************************************************/

void edit_config_ecran_carto( int select_affi_carto, 
										struct s_carre *carre,
										struct s_affi_carto **affi_carto , 
										struct s_config_generale_carto *cfg_carto)
{
	int i;
	int tmp;
	int cpt = 0;
	int sortir = 0;
	int select = -1;
	int redessine = 0;
	struct s_commande com;
	struct s_dialogue menu;
	struct s_config_generale_carto cfg_carto2;

	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\cfg_ec_c.box", &menu )) != NULL)
	{
		memset( &com, 0, sizeof (com) );
		menu.flags.push_demande = 1;
		menu.x = 0;
		menu.y = 0;

		cfg_carto2 = *cfg_carto;
		mov_chps_config_ecran( SENS_STRUCT_TO_CHAMPS, menu.champs, &cfg_carto2 );

		init_menu( &menu, menu.champs );
		do	
		{
			gere_commande( &com );
			if (com.touche == ESC)
				sortir = 1;

			if ((select = gere_menu( &com, &menu, menu.champs )) != -1)
			{
				switch (select)
				{
				case L_SORTIR_ECR:
					*cfg_carto = cfg_carto2;
				case L_ANNULER_ECR:
					sortir = 1;
					break;

				default:
					redessine++;
					mov_chps_config_ecran( SENS_CHAMPS_TO_STRUCT, menu.champs, &cfg_carto2 );
					break;
				}
			}
			if (affi_carto[cpt])
			{
				if (redessine)
				{
					redessine = 0;
					for (i = 0;  i < cfg_carto2.nb_affi_cartos_max;  i++)
					{
						affi_carto[i]->flags.demande_trace_carto++;
						set_config_ecran_carto( affi_carto[i], &cfg_carto2 );
					}
					change_configuration_carto( select_affi_carto, carre, &cfg_carto2, affi_carto );
				}
				affiche_carto( affi_carto[cpt] );
				if (com.change)
					if (xy_sur_carto( com.x, com.y, affi_carto[cpt] ))
						edit_carto( ESC, affi_carto[cpt] );

			}
			if (++cpt >= cfg_carto2.nb_affi_cartos_max)
				cpt = 0;

		}
		while (! sortir);
		fin_menu( &menu, menu.champs );
	}
}

/***********************************************************/

void edit_config_visu( struct s_dial_menu * pmenu, struct s_affi_carto * affi_carto, struct s_config_carto *cfg_carto)
{
	int tmp;
	int sortir = 0;
	int select = -1;
	char nom_f_cfg[MAX_LEN_PATH] = {0};

	struct s_commande com;
	struct s_dialogue menu;
	struct s_config_carto cfg_carto2;
//-----------------------------------------------------------
	nom_f_cfg[0] = 0;
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\cfg_visu.box", &menu )) != NULL)
	{
		memset( &com, 0, sizeof (com) );
		menu.ecran = pmenu->ecran;
		menu.x = pmenu->pos.x1;
		menu.y = pmenu->pos.y1;
		if (menu.lng_x < pmenu->pos.x2)
			menu.lng_x = pmenu->pos.x2;
		if (menu.lng_y < pmenu->pos.y2)
			menu.lng_y = pmenu->pos.y2;

		if (affi_carto->data_carto->fichier.nom[0])
		{
			strcpy( nom_f_cfg, affi_carto->data_carto->fichier.nom );
//			impose_ext( nom_f_cfg, ".CFC" );
			impose_extention_cfc( nom_f_cfg );	//EB 10/02/2000

			if (access( nom_f_cfg, 0 ) != -1)
				lire_cfg_carto( nom_f_cfg, &affi_carto->config );
			set_config_ecran_carto( affi_carto, &Carto_Cfg_Carto );	//EB 10/02/2000

		}

		cfg_carto2 = *cfg_carto;
		mov_chps_config_visu( SENS_STRUCT_TO_CHAMPS, menu.champs, cfg_carto, affi_carto );
		set_nom_fichier_chaine( menu.champs[L_NOM_CFG_VISU].contenu, affi_carto->data_carto->fichier.nom, menu.champs[L_NOM_CFG_VISU].car_x );

		menu.flags.push_demande = 1;
		init_menu( &menu, menu.champs );

		do	
		{
			gere_commande( &com );
			if (com.touche == ESC)
				sortir = 1;

			if ((select = gere_menu( &com, &menu, menu.champs )) != -1)
			{
				switch (select)
				{
				case F_ISO:
					mov_chps_config_visu( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					calcule_plein_ecran_carto( affi_carto );
					mov_chps_config_visu( SENS_STRUCT_TO_CHAMPS, menu.champs, cfg_carto, affi_carto );
					break;

				case F_MEMOIRE_CFG_VISU:
					_move_chp_flag( SENS_CHAMPS_TO_STRUCT, &menu.champs[F_MEMOIRE_CFG_VISU], &affi_carto->data_carto->fichier.flags.demande_data_en_memoire, 0, -1 );
					if (affi_carto->data_carto->fichier.flags.demande_data_en_memoire)
						affi_carto->data_carto->fichier.flags.demande_index_en_memoire = ON;

					open_carto( affi_carto->data_carto->fichier.nom, affi_carto->data_carto );
					affi_carto->flags.demande_trace_carto++;
					break;

				case F_ECH_X_CFG_VISU:
				case F_ECH_Y_CFG_VISU:
				case F_SIGNAL_CFG_VISU:
				case F_PALETTE_CFG_VISU:
				case F_COUPE_X_CFG_VISU:
				case F_COUPE_Y_CFG_VISU:
				case C_DIM_ECH_CFG_VISU:
				case C_DIM_COUPE_CFG_VISU:
				case C_DIM_PALETTE_CFG_VISU:
				case F_MEMO_PALETTE_CFG_VISU:
					mov_chps_config_visu( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					affi_carto->flags.demande_trace_carto++;
					calcule_zones_carto( affi_carto );
					break;

				case F_BSCAN_EP_CFG_VISU:
				case F_CURSEUR_X_CFG_VISU:
				case F_CURSEUR_Y_CFG_VISU:
					mov_chps_config_visu( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					affi_carto->flags.demande_trace_carto++;
					break;

				case F_VALEUR_CFG_VISU:
				case F_COUPE_LIGNE_CFG_VISU:
				case F_COUPE_PLEINE_CFG_VISU:
				case F_COUPE_INVERSE_CFG_VISU:
					mov_chps_config_visu( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					break;

				case L_COUL_CUR_CFG_VISU:
					if ((tmp = choix_couleur_dos( )) != -1)
					{
						cfg_carto->couleur_curseur = tmp;
						affi_carto->flags.demande_trace_carto++;
					}
					break;

				case L_COUL_FOND_CFG_VISU:
					if ((tmp = choix_couleur_dos( )) != -1)
					{
						cfg_carto->fcouleur_carto = tmp;
						affi_carto->flags.demande_trace_carto++;
					}
					break;

				case L_ANNULER_CFG_VISU:
					*cfg_carto = cfg_carto2;
				case L_SORTIR_CFG_VISU:
					sortir = 1;
					break;

				default:
					break;
				}
				affiche_champs_modifie( &menu, menu.champs );
			}
			affiche_carto( affi_carto );
			if (! com.change)
				if (xy_sur_carto( com.x, com.y, affi_carto ))
					edit_carto( ESC, affi_carto );

		}
		while (! sortir);
		fin_menu( &menu, menu.champs );

		if (nom_f_cfg[0])
			ecrire_cfg_carto( nom_f_cfg, &affi_carto->config );
	}

}

/***********************************************************/

void edit_config_carto( struct s_dial_menu * pmenu, struct s_affi_carto * affi_carto, struct s_config_carto *cfg_carto)
{
	int sortir = 0;
	int select = -1;
	char *extension;
	char nom_f_cfg[MAX_LEN_PATH];

	struct s_commande com;
	struct s_dialogue menu;
	struct s_config_carto cfg_carto2;
//---------------------------------------------------
	nom_f_cfg[0] = 0;
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\cfg_crto.box", &menu )) != NULL)
	{
		memset( &com, 0, sizeof (com) );
		menu.flags.push_demande = 1;
		menu.ecran = pmenu->ecran;
		menu.x = pmenu->pos.x1;
		menu.y = pmenu->pos.y1;
		if (menu.lng_x < pmenu->pos.x2)
			menu.lng_x = pmenu->pos.x2;
		if (menu.lng_y < pmenu->pos.y2)
			menu.lng_y = pmenu->pos.y2;

		if (affi_carto->data_carto->fichier.nom[0])
		{
			strcpy( nom_f_cfg, affi_carto->data_carto->fichier.nom );
//			impose_ext( nom_f_cfg, ".CFC" );
			impose_extention_cfc( nom_f_cfg );	//EB 10/02/2000

			if (access( nom_f_cfg, 0 ) != -1)
				lire_cfg_carto( nom_f_cfg, &affi_carto->config );
			set_config_ecran_carto( affi_carto, &Carto_Cfg_Carto );	//EB 10/02/2000

		}

		cfg_carto2 = *cfg_carto;
		mov_chps_config_carto( SENS_STRUCT_TO_CHAMPS, menu.champs, cfg_carto, affi_carto );
		set_nom_fichier_chaine( menu.champs[L_NOM_CFG_CRTO].contenu, affi_carto->data_carto->fichier.nom, menu.champs[L_NOM_CFG_CRTO].car_x );

		init_menu( &menu, menu.champs );
		do	
		{
			gere_commande( &com );
			if (com.touche == ESC)
				sortir = 1;

			if ((select = gere_menu( &com, &menu, menu.champs )) != -1)
			{
				switch (select)
				{
				case F_ISO_CFG_CRTO:
					mov_chps_config_carto( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					calcule_plein_ecran_carto( affi_carto );
					mov_chps_config_carto( SENS_STRUCT_TO_CHAMPS, menu.champs, cfg_carto, affi_carto );
					break;

				case BL_UNIT_AFF_CFG_CRTO:
					_move_chp_bt_liste( SENS_CHAMPS_TO_STRUCT, &menu.champs[BL_UNIT_AFF_CFG_CRTO], &affi_carto->config.unite_visu, Carto_Type_Unite_Carto );
					if (affi_carto->config.unite_visu == UNITE_AFF_METRE)
					{
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_X_CFG_CRTO], &affi_carto->echelle_x, 0.001, 255.0, 1, 0 );
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_Y_CFG_CRTO], &affi_carto->echelle_y, 0.001, 255.0, 1, 0 );
					}
					else if (affi_carto->config.unite_visu == UNITE_AFF_PIXEL)
					{
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_X_CFG_CRTO], &affi_carto->ech_pix_x, 0.001, 255.0, 1, 0 );
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_Y_CFG_CRTO], &affi_carto->ech_pix_y, 0.001, 255.0, 1, 0 );
					}
					else
					{
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_X_CFG_CRTO], &affi_carto->ech_pap_x, 0.001, 255.0, 1, 0 );
						_move_chp_double( SENS_STRUCT_TO_CHAMPS, &menu.champs[C_ECH_Y_CFG_CRTO], &affi_carto->ech_pap_y, 0.001, 255.0, 1, 0 );
					}
					affi_carto->flags.demande_trace_carto++;
					break;

				case C_ECH_X_CFG_CRTO:
				case C_ECH_Y_CFG_CRTO:
				case BL_MODE_COMPRESSION_CFG_CRTO:
					affi_carto->flags.demande_trace_carto++;
				case BL_UNIT_CARTO_CFG_CRTO:
					mov_chps_config_carto( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					break;

				case C_PEIGNE_CFG_CRTO:
					mov_chps_config_carto( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					if (affi_carto->data_carto->fichier.flags.data_en_memoire)
						open_carto( affi_carto->data_carto->fichier.nom, affi_carto->data_carto );

					affi_carto->flags.demande_trace_carto++;
					break;

				case F_UTILISE_FORMULE_CFG_CRTO:
					mov_chps_config_carto( SENS_CHAMPS_TO_STRUCT, menu.champs, cfg_carto, affi_carto );
					init_convert_data( &affi_carto->data_carto->convert );
					break;

				case L_ANNULER_CFG_CRTO:
					*cfg_carto = cfg_carto2;
				case L_SORTIR_CFG_CRTO:
					sortir = 1;
					break;

				default:
					break;
				}
				affiche_champs_modifie( &menu, menu.champs );
			}
			affiche_carto( affi_carto );
			if (! com.change)
				if (xy_sur_carto( com.x, com.y, affi_carto ))
				{
					edit_carto( ESC, affi_carto );
					mov_chps_config_carto( SENS_STRUCT_TO_CHAMPS, menu.champs, cfg_carto, affi_carto );
					affiche_champs_modifie( &menu, menu.champs );
				}

		}
		while (! sortir);
		fin_menu( &menu, menu.champs );

		if (nom_f_cfg[0])
			ecrire_cfg_carto( nom_f_cfg, &affi_carto->config );
	}
}

/***********************************************************/

mov_chps_config_ecran( int sens, struct s_champ *champs, struct s_config_generale_carto *cfg_carto )
{
	_move_chp_flag( sens, &champs[F_MULTI_PAL_ECR], &cfg_carto->multi_palette, 0, 1 );
	_move_chp_flag( sens, &champs[F_MULTI_EDITION_ECR], &cfg_carto->multi_edition, 0, 1 );
	_move_chp_double( sens, &champs[C_L_ECRAN_ECR], &cfg_carto->config.taille_ecran_x, 100, 10000, 1, 0 );
	_move_chp_double( sens, &champs[C_H_ECRAN_ECR], &cfg_carto->config.taille_ecran_y, 100, 10000, 1, 0 );
	_move_chp_int( sens, &champs[C_NB_CARTO_ECR], (int *) &cfg_carto->nb_cartos, 1, NB_AFFI_CARTOS, 1, 0 );
	_move_chp_int( sens, &champs[C_NB_CARTOS_HORIZ], (int *) &cfg_carto->nb_cartos_horizontales, 1, NB_AFFI_CARTOS, 1, 0 );
	_move_chp_double( sens, &champs[C_L_PAPIER_ECR], &cfg_carto->config.taille_papier_x, 100, 10000, 1, 0 );
	_move_chp_double( sens, &champs[C_H_PAPIER_ECR], &cfg_carto->config.taille_papier_y, 100, 10000, 1, 0 );
}

/***********************************************************/

void mov_chps_config_visu( int sens, struct s_champ *champs, struct s_config_carto * cfg_carto, struct s_affi_carto * affi_carto)
{
	if ((affi_carto->signal_carto == NULL)
	&& (affi_carto->data_carto->convert.type != TYPE_SIGNAL_US)
	&& (affi_carto->data_carto->convert.type != TYPE_SIGNAL_US_AMP)
	&& (affi_carto->data_carto->convert.type != TYPE_SIGNAL_US_TPS))
	{
		cfg_carto->signal = OFF;
		champs[F_SIGNAL_CFG_VISU].type.selectable = OFF;
	}

	_move_chp_flag( sens, &champs[F_ISO], &cfg_carto->isometrique, 0, -1 );
	_move_chp_flag( sens, &champs[F_MEMOIRE_CFG_VISU], &cfg_carto->en_memoire, 0, -1 );
	_move_chp_flag( sens, &champs[F_VALEUR_CFG_VISU], &cfg_carto->valeur, 0, -1 );
	_move_chp_flag( sens, &champs[F_BSCAN_EP_CFG_VISU], &cfg_carto->bscan_epaisseur, 0, -1 );
	_move_chp_flag( sens, &champs[F_ECH_X_CFG_VISU], &cfg_carto->echelle_x, 0, -1 );
	_move_chp_flag( sens, &champs[F_ECH_Y_CFG_VISU], &cfg_carto->echelle_y, 0, -1 );
	_move_chp_flag( sens, &champs[F_CURSEUR_X_CFG_VISU], &affi_carto->config.curseur_x, 0, -1 );
	_move_chp_flag( sens, &champs[F_CURSEUR_Y_CFG_VISU], &affi_carto->config.curseur_y, 0, -1 );
	_move_chp_flag( sens, &champs[F_COUPE_X_CFG_VISU], &cfg_carto->coupe_x, 0, -1 );
	_move_chp_flag( sens, &champs[F_COUPE_Y_CFG_VISU], &cfg_carto->coupe_y, 0, -1 );
	_move_chp_flag( sens, &champs[F_COUPE_LIGNE_CFG_VISU], &cfg_carto->ligne_coupe, 0, -1 );
	_move_chp_flag( sens, &champs[F_COUPE_PLEINE_CFG_VISU], &cfg_carto->remplir_coupe, 0, -1 );
	_move_chp_flag( sens, &champs[F_COUPE_INVERSE_CFG_VISU], &cfg_carto->inverse_coupe, 0, -1 );
	_move_chp_flag( sens, &champs[F_PALETTE_CFG_VISU], &cfg_carto->palette, 0, -1 );
	_move_chp_flag( sens, &champs[F_SIGNAL_CFG_VISU], &cfg_carto->signal, 0, -1 );
	_move_chp_flag( sens, &champs[F_MEMO_PALETTE_CFG_VISU], &cfg_carto->conserve_derniere_palette, 0, -1 );

	_move_chp_int( sens, &champs[C_DIM_PALETTE_CFG_VISU], (int *) &cfg_carto->marge_palette, 16, 200, 1, 0 );
	_move_chp_int( sens, &champs[C_DIM_ECH_CFG_VISU], (int *) &cfg_carto->marge_echelles, 16, 100, 1, 0 );
	_move_chp_int( sens, &champs[C_DIM_COUPE_CFG_VISU], (int *) &cfg_carto->marge_coupes, 16, 500, 1, 0 );
}

/***********************************************************/

void mov_chps_config_carto( int sens, struct s_champ *champs, struct s_config_carto * cfg_carto, struct s_affi_carto * affi_carto)
{
	int val;

	_move_chp_bt_liste( sens, &champs[BL_UNIT_AFF_CFG_CRTO], &affi_carto->config.unite_visu, Carto_Type_Unite_Carto );
	if (affi_carto->config.unite_visu == UNITE_AFF_METRE)
	{
		_move_chp_double( sens, &champs[C_ECH_X_CFG_CRTO], &affi_carto->echelle_x, 0.001, 255.0, 1, 0 );
		_move_chp_double( sens, &champs[C_ECH_Y_CFG_CRTO], &affi_carto->echelle_y, 0.001, 255.0, 1, 0 );
	}
	else if (affi_carto->config.unite_visu == UNITE_AFF_PIXEL)
	{
		_move_chp_double( sens, &champs[C_ECH_X_CFG_CRTO], &affi_carto->ech_pix_x, 0.001, 255.0, 1, 0 );
		_move_chp_double( sens, &champs[C_ECH_Y_CFG_CRTO], &affi_carto->ech_pix_y, 0.001, 255.0, 1, 0 );
	}
	else
	{
		_move_chp_double( sens, &champs[C_ECH_X_CFG_CRTO], &affi_carto->ech_pap_x, 0.001, 255.0, 1, 0 );
		_move_chp_double( sens, &champs[C_ECH_Y_CFG_CRTO], &affi_carto->ech_pap_y, 0.001, 255.0, 1, 0 );
	}

	_move_chp_flag( sens, &champs[F_ISO_CFG_CRTO], &cfg_carto->isometrique, 0, -1 );
	_move_chp_flag( sens, &champs[F_MIRROIR_X_CFG_CRTO], &cfg_carto->mirroir_x, 0, -1 );
	_move_chp_flag( sens, &champs[F_MIRROIR_Y_CFG_CRTO], &cfg_carto->mirroir_y, 0, -1 );
	_move_chp_flag( sens, &champs[F_MIRROIR_CFG_CRTO], &cfg_carto->inversion_x_y, 0, -1 );
	_move_chp_bt_liste( sens, &champs[BL_MODE_COMPRESSION_CFG_CRTO], &cfg_carto->mode_compression, Carto_Mode_Comp );

	if (sens == SENS_STRUCT_TO_CHAMPS)
	{
		init_chp_peigne_carto( &champs[C_PEIGNE_CFG_CRTO], affi_carto );
		if (affi_carto->palette.unite.toutes_unites_us != NULL)
		{
		#ifdef UTILISE_CARTE_DIGIT
			if (champs[BL_UNIT_CARTO_CFG_CRTO].type.malloc_tableau == 0)
			{
				init_chp_select_unit_sans_carte( &champs[BL_UNIT_CARTO_CFG_CRTO], affi_carto->palette.unite.toutes_unites_us[0] );
				champs[BL_UNIT_CARTO_CFG_CRTO].valeur = affi_carto->palette.unite.numero_unite_us;
			}
		#endif
		}
		else
		{
			champs[BL_UNIT_CARTO_CFG_CRTO].etat.modifie = 1;
			champs[BL_UNIT_CARTO_CFG_CRTO].etat.dessine = 0;
			champs[BL_UNIT_CARTO_CFG_CRTO].type.invisible = 1;
			champs[BL_UNIT_CARTO_CFG_CRTO].type.selectable = 0;
		}

		if (affi_carto->data_carto->convert.type == TYPE_VALEUR_FORMULE)
			val = 1;
		else
			val = 0;

		_move_chp_flag( sens, &champs[F_UTILISE_FORMULE_CFG_CRTO], &val, 0, 1 );
	}
	else
	{
		_move_chp_flag( sens, &champs[F_UTILISE_FORMULE_CFG_CRTO], &val, 0, 1 );
		if (val)
			affi_carto->data_carto->convert.type = TYPE_VALEUR_FORMULE;
		else
			affi_carto->data_carto->convert.type = affi_carto->data_carto->convert.old_type;

		gere_chp_peigne_carto( &champs[C_PEIGNE_CFG_CRTO], affi_carto );
		affi_carto->palette.unite.numero_unite_us = champs[BL_UNIT_CARTO_CFG_CRTO].valeur;
		#ifdef UTILISE_CARTE_DIGIT
		affi_carto->palette.unite.unites_us = affi_carto->palette.unite.toutes_unites_us[affi_carto->palette.unite.numero_unite_us];
		#endif
	}
}

/***********************************************************/

void dialogue_config_visu( struct s_dialogue_carto *dial_carto)
{
	if (dial_carto->cfg_carto)
		edit_config_visu( &dial_carto->pmenu, dial_carto->affi_carto, &dial_carto->affi_carto->config );
}


/***********************************************************/

void dialogue_config_carto( struct s_dialogue_carto *dial_carto)
{
	if (dial_carto->cfg_carto)
		edit_config_carto( &dial_carto->pmenu, dial_carto->affi_carto, &dial_carto->affi_carto->config );
}

/***********************************************************/

void set_config_carto( struct s_affi_carto *affi_carto, struct s_config_generale_carto *cfg_carto)
{
	if (! affi_carto->data_carto->fichier.flags.used)
	{
		affi_carto->config.valeur = ON;
		affi_carto->config.fichier_ascan[0] = 0;
//		affi_carto->config.fichier_palette[0] = 0;
		affi_carto->data_carto->fichier.flags.demande_data_en_memoire = cfg_carto->config.en_memoire;
		affi_carto->config.echelle_x = cfg_carto->config.echelle_x;
		affi_carto->config.echelle_y = cfg_carto->config.echelle_y;
		affi_carto->config.coupe_x = cfg_carto->config.coupe_x;
		affi_carto->config.coupe_y = cfg_carto->config.coupe_y;
		affi_carto->asm.mode_compression = cfg_carto->config.mode_compression;
		affi_carto->data_carto->fichier.flags.demande_index_en_memoire = 1;
	}

	affi_carto->config.marge_echelles = cfg_carto->config.marge_echelles;
	affi_carto->config.marge_coupes = cfg_carto->config.marge_coupes;
	affi_carto->config.mirroir_x = cfg_carto->config.mirroir_x;

	affi_carto->config.taille_ecran_x = cfg_carto->config.taille_ecran_x;
	affi_carto->config.taille_ecran_y = cfg_carto->config.taille_ecran_y;
}

/***********************************************************/

void set_config_ecran_carto( struct s_affi_carto *affi_carto, struct s_config_generale_carto *cfg_carto)
{

	affi_carto->config.taille_ecran_x = cfg_carto->config.taille_ecran_x;
	affi_carto->config.taille_ecran_y = cfg_carto->config.taille_ecran_y;
	affi_carto->config.taille_papier_x = cfg_carto->config.taille_papier_x;
	affi_carto->config.taille_papier_y = cfg_carto->config.taille_papier_y;

}

/***********************************************************/

void calcule_positions_cartos(struct s_carre *carre, struct s_affi_carto **affi_carto, struct s_config_generale_carto *cfg_carto, int max_carto)
{
	int i, j;
	int hc, lc;
	int nbh, nbv;
	int mode_normal;
	int fin_boucle;

	if (cfg_carto->nb_cartos < 1)
		cfg_carto->nb_cartos = 1;

	if (cfg_carto->nb_cartos > max_carto)
		cfg_carto->nb_cartos = max_carto;

	for (i = 0;  i < cfg_carto->nb_cartos;  i++)
	{
		affi_carto[i]->menu.x = 0;
		affi_carto[i]->menu.y = 0;
		affi_carto[i]->menu.lng_x = 0;
		affi_carto[i]->menu.lng_y = 0;
	}

	switch (cfg_carto->nb_cartos)
	{
	case 1:
		nbh = 1;
		nbv = 1;
		mode_normal = 1;
		break;

	case 2:
		mode_normal = 1;
		nbh = 1;
		nbv = 2;
		if (cfg_carto->nb_cartos_horizontales == 1 || cfg_carto->nb_cartos_horizontales == 2)
		{
			nbh = cfg_carto->nb_cartos_horizontales;
			nbv = 2 / cfg_carto->nb_cartos_horizontales;
		}
		break;

	case 3:
		if (cfg_carto->nb_cartos_horizontales == 1 || cfg_carto->nb_cartos_horizontales == 3)
		{
			nbh = cfg_carto->nb_cartos_horizontales;
			nbv = 3 / cfg_carto->nb_cartos_horizontales;
			mode_normal = 1;
		}
		else
		{
			nbh = 2;
			nbv = 2;
			mode_normal = 0;

			hc = carre->y2 / 2;
			lc = carre->x2 / 2;
			for (i = 0;  i < 2;  i++)
			{
				affi_carto[i]->menu.x = carre->x1;
				affi_carto[i]->menu.y = carre->y1 + hc * i;
				affi_carto[i]->menu.lng_x = lc;
				affi_carto[i]->menu.lng_y = hc;
			}
			affi_carto[i]->menu.x = carre->x1 + lc;
			affi_carto[i]->menu.y = carre->y1;
			affi_carto[i]->menu.lng_x = lc;
			affi_carto[i++]->menu.lng_y = hc * 2;
		}
		break;

	case 4:
		mode_normal = 1;
		if (cfg_carto->nb_cartos_horizontales < 1 || cfg_carto->nb_cartos_horizontales > 4)
		{
			nbh = 2;
			nbv = 2;
		}
		else
		{
			nbh = cfg_carto->nb_cartos_horizontales;
			nbv = 4 / cfg_carto->nb_cartos_horizontales;
		}
		break;

	case 5:
		if (cfg_carto->nb_cartos_horizontales == 1 || cfg_carto->nb_cartos_horizontales == 5)
		{
			nbh = cfg_carto->nb_cartos_horizontales;
			nbv = 5 / cfg_carto->nb_cartos_horizontales;
			mode_normal = 1;
		}
		else
		{
			nbh = 3;
			nbv = 2;
			mode_normal = 0;

			lc = carre->x2 / 2;
			hc = carre->y2 / 3;
			for (i = 0;  i < 3;  i++)
			{
				affi_carto[i]->menu.x = carre->x1;
				affi_carto[i]->menu.y = carre->y1 + (hc * (i % 3));
				affi_carto[i]->menu.lng_x = lc;
				affi_carto[i]->menu.lng_y = hc;
			}
			hc = carre->y2 / 2;
			for (j = i, i = 0;  j < 5;  j++, i++)
			{
				affi_carto[j]->menu.x = carre->x1 + lc;
				affi_carto[j]->menu.y = carre->y1 + hc * i;
				affi_carto[j]->menu.lng_x = lc;
				affi_carto[j]->menu.lng_y = hc;
			}
			i = j;
		}
		break;

	case 6:
		mode_normal = 1;
		if (cfg_carto->nb_cartos_horizontales == 1 || cfg_carto->nb_cartos_horizontales == 2
		|| cfg_carto->nb_cartos_horizontales == 3 || cfg_carto->nb_cartos_horizontales == 6)
		{
			nbh = cfg_carto->nb_cartos_horizontales;
			nbv = 6 / cfg_carto->nb_cartos_horizontales;
		}
		else
		{
			nbh = 3;
			nbv = 2;
		}
		break;

	default:
		break;
	}

	if (mode_normal)
	{
		hc = carre->y2 / nbv;
		lc = carre->x2 / nbh;

		if (cfg_carto->nb_cartos == 1)
		{
			for (i = 0;  i < max_carto;  i++)
			{
				affi_carto[i]->menu.x = carre->x1;
				affi_carto[i]->menu.y = carre->y1;
				affi_carto[i]->menu.lng_x = lc;
				affi_carto[i]->menu.lng_y = hc;
			}
		}
		else
		{
			for (i = 0;  i < cfg_carto->nb_cartos;  i++)
			{
				affi_carto[i]->menu.x = carre->x1 + (lc * (i % nbh));
				affi_carto[i]->menu.y = carre->y1 + (hc * (i / nbh));
				affi_carto[i]->menu.lng_x = lc;
				affi_carto[i]->menu.lng_y = hc;
			}
		}
//		i++;
	}

	if (cfg_carto->nb_cartos != 1)
		for (j = i--;  j < max_carto;  j++)
			if (affi_carto[j]->flags.active)
			{
				affi_carto[j]->menu.x = affi_carto[i]->menu.x;
				affi_carto[j]->menu.y = affi_carto[i]->menu.y;
				affi_carto[j]->menu.lng_x = affi_carto[i]->menu.lng_x;
				affi_carto[j]->menu.lng_y = affi_carto[i]->menu.lng_y;
			}

	for (i = 0;  i < max_carto;  i++)
		calcule_zones_carto( affi_carto[i] );

	calcule_place_palette_carto( max_carto, affi_carto, cfg_carto );
	#if 0
	for (i = 0, j = 0;  i < cfg_carto->nb_cartos, j < max_carto;  j++)
		if (affi_carto[j]->flags.active)
			if (cfg_carto->multi_palette)
			{
				affi_carto[j]->palette.nb_couleurs_local = (affi_carto[j]->palette.nb_couleurs_max - NB_COULEUR_DOS) / cfg_carto->nb_cartos;
				affi_carto[j]->palette.offset_couleur_local = NB_COULEUR_DOS + i * (affi_carto[j]->palette.nb_couleurs_local);
				i++;
			}
			else
			{
				affi_carto[j]->palette.nb_couleurs_local = (affi_carto[j]->palette.nb_couleurs_max - NB_COULEUR_DOS);
				affi_carto[j]->palette.offset_couleur_local = NB_COULEUR_DOS;
				i++;
			}
    #endif
}

/***********************************************************/

void calcule_place_palette_carto(	int max_carto, 
									struct s_affi_carto **affi_carto,
									struct s_config_generale_carto *cfg_carto )
{
	int i;
	int j;

	for (i = 0, j = 0;  i < cfg_carto->nb_cartos, j < max_carto;  j++)
		if (affi_carto[j]->flags.active)
			if (cfg_carto->multi_palette)
			{
				affi_carto[j]->palette.nb_couleurs_local = (affi_carto[j]->palette.nb_couleurs_max - NB_COULEUR_DOS) / cfg_carto->nb_cartos;
				affi_carto[j]->palette.offset_couleur_local = NB_COULEUR_DOS + i * (affi_carto[j]->palette.nb_couleurs_local);
				i++;
			}
			else
			{
				affi_carto[j]->palette.nb_couleurs_local = (affi_carto[j]->palette.nb_couleurs_max - NB_COULEUR_DOS);
				affi_carto[j]->palette.offset_couleur_local = NB_COULEUR_DOS;
				i++;
			}

}

/***********************************************************/
#pragma message("init_chp_peigne_carto")
/*
#COM init_chp_peigne_carto:  initialisation de la valeur de peigne carto
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void init_chp_peigne_carto(struct s_champ *champ, struct s_affi_carto * affi_carto)
{

	if (affi_carto->config.peigne_pair)
		champ->valeur = affi_carto->config.compensation_peigne;
	else
		champ->valeur = -affi_carto->config.compensation_peigne;

	champ->etat.modifie = 1;
	champ->maxi = VAL_MAX_PEIGNE;
	champ->mini = -VAL_MAX_PEIGNE;

}

/***********************************************************/
#pragma message("gere_chp_peigne_carto")
/*                   
#COM gere_chp_peigne_carto:  gestion de la valeur de peigne carto
#COM         IN: 
#COM             
#COM 
#COM        OUT:
#COM  
*/

void gere_chp_peigne_carto(struct s_champ *champ, struct s_affi_carto * affi_carto)
{

	if (champ->valeur >= 0)
	{
		if (champ->valeur > VAL_MAX_PEIGNE)
			champ->valeur = VAL_MAX_PEIGNE;

		affi_carto->config.peigne_pair = affi_carto->data_carto->peigne_pair = 1;
		affi_carto->config.compensation_peigne = affi_carto->data_carto->compensation_peigne = champ->valeur;
	}
	else
	{
		if (champ->valeur < -VAL_MAX_PEIGNE)
			champ->valeur = -VAL_MAX_PEIGNE;

		affi_carto->config.peigne_pair = affi_carto->data_carto->peigne_pair = 0;
		affi_carto->config.compensation_peigne = affi_carto->data_carto->compensation_peigne = -champ->valeur;
	}

}

/***********************************************************/

affiche_info_carto(int ecran, struct s_affi_carto * affi_carto)
{
	//Modif EB 28/3/2000
	static char *axes[] = {"X", "Y", "Z", "P", "B", "C", "P", "T"};
	int i;
	char buffer[80];
	long size;
	//modif eb le 14/03/99
	char *texte;
	struct s_data_carto * carto;

//------------------------------------------------------------------------
	if (texte = D16MemAllocClear( MAX_MALLOC, 0 ))
	{
		if (carto = affi_carto->data_carto)
		{
			sprintf( texte, "Nom: %s @@", (char _FAR_DATA *) carto->fichier.nom );

			sprintf( buffer, "Fichier balayage: %s @", (char _FAR_DATA *) carto->fichier.balayage );
			strcat( texte, buffer );

			for (i = 0;  i < MAX_FICHIERS_CARTO_ASSOCIES;  i++)
				if (carto->nom_cartos_associees[i][0])
				{
					sprintf( buffer, "Carto associe : %s @", (char _FAR_DATA *) carto->nom_cartos_associees[i] );
					strcat( texte, buffer );
				}

			if (carto->degagement.valeur != 0)
			{
				sprintf( buffer, "Axe dgagement :%s  valeur: %.0lf@", (char _FAR_DATA *) axes[carto->degagement.axe], carto->degagement.valeur );
				strcat( texte, buffer );
			}

			if (carto->fichier.flags.pas_variable)
			{
				strcat( texte, "Pas variable @" );
			}
			else
			{
				strcat( texte, "Pas fixe @" );
			}

			sprintf( buffer, "%d lignes acquises / %d@%d colonnes@", carto->nb_lignes_acquises, carto->nb_lignes_total, carto->largeur_maxi_ligne );
			strcat( texte, buffer );

			//modif rvf le 14/03/96
			sprintf( buffer, "Nom fichier paramtres: '%s'@", (char _FAR_DATA *) carto->nom_fichier_parametres );
			strcat( texte, buffer );

			sprintf( buffer, "Pas horizontal: %.5lf %s@vertical: %.5lf %s@", carto->pas_horiz, (char _FAR_DATA *) carto->lettre_unite_meca_horiz, carto->pas_vert, (char _FAR_DATA *) carto->lettre_unite_meca_vert );
			strcat( texte, buffer );

			sprintf( buffer, "Axe horizontal: %s, vertical: %s@", (char _FAR_DATA *) axes[carto->axe_horiz], (char _FAR_DATA *) axes[carto->axe_vert] );
			strcat( texte, buffer );

			sprintf( buffer, "Contient %s de la porte %d de la voie %d. @", (char _FAR_DATA *) Carto_Noms_Contenus[carto->convert.type], carto->porte + 1, carto->voie + 1 );
			strcat( texte, buffer );

			sprintf( buffer, "Nom du contenu '%s'.@", (char _FAR_DATA *) carto->contenu_carto );
			strcat( texte, buffer );

			size = filelength( affi_carto->data_carto->fichier.handle );
			sprintf( buffer, "Taille %.1lf Ko. @", (double) size / 1024. );
			strcat( texte, buffer );

			if (affi_carto->signal_carto)
			{
				sprintf( buffer, "@Relier au fichier signal: %s. @", (char _FAR_DATA *) affi_carto->signal_carto->fichier.nom );
				strcat( texte, buffer );
			}
		}
		message( ecran, texte, 0, 0, MESSAGE_PRINT | ICONE_RELAX, 0 );
		D16MemFree( texte );
	}
}

/***********************************************************/

void dialogue_palette_glissante( struct s_dialogue_carto *dial_carto )
{
	if (dial_carto->affi_carto)
		palette_glissante( &dial_carto->pmenu, dial_carto->affi_carto );
}

/***********************************************************/

void dialogue_affiche_info_carto( struct s_dialogue_carto *dial_carto)
{
	if (dial_carto->affi_carto)
		affiche_info_carto( dial_carto->affi_carto->fenetre.ecran, dial_carto->affi_carto );
}

/***********************************************************/

void palette_glissante( struct s_dial_menu * pmenu, struct s_affi_carto *affi_carto)
{
	int cpt;
	int sortir = 0;
	int select = -1;
	int couleur_debut;
	int old_couleur_deb;
	int gliss_demande = 0;
	int largeur_seuils = 0;
	int tab_larg_couleur[NB_SEUILS_MAX];
	int tab_larg_max_couleur[NB_SEUILS_MAX];

	struct s_commande com;
	struct s_dialogue menu;
//-----------------------------------------------------------
	if ((menu.champs = (struct s_champ *) charge_menu( "..\\carto\\PAL_GLIS.BOX", &menu )) != NULL)
	{
		menu.flags.push_demande = 1;
		memset( &com, 0, sizeof (com) );
		affi_carto->flags.interdit_re_calcule_palette = ON;

		menu.ecran = pmenu->ecran;
		menu.x = pmenu->pos.x1;
		menu.y = pmenu->pos.y1;
		if (menu.lng_x < pmenu->pos.x2)
			menu.lng_x = pmenu->pos.x2;
		if (menu.lng_y < pmenu->pos.y2)
			menu.lng_y = pmenu->pos.y2;

		old_couleur_deb = couleur_debut = 0;
		largeur_seuils = calcul_largeur_seuils( tab_larg_couleur, tab_larg_max_couleur, &affi_carto->palette );
		gere_champs_seuils_palette_glissante( couleur_debut, tab_larg_couleur, &menu, affi_carto );

		init_champs_palette_glissante( affi_carto, &menu );

		init_menu( &menu, menu.champs );
		clear_mouse( affi_carto->fenetre.ecran );
		init_champ_couleur_palette_glissante( affi_carto, &menu );

		do	
		{
			gere_commande( &com );
			select = gere_menu( &com, &menu, menu.champs );

			if (select != -1)
				switch (select)
				{
				case L_SORTIR_PG:
					sortir = 1;
					break;

				default:
					break;
				}

			if (com.change)
				switch (com.touche)
				{
				case ESC:
					sortir++;
					break;

				case BAS:
					if ((couleur_debut -= tab_larg_couleur[0]) < 0)
						couleur_debut = 0;

					gliss_demande++;
					break;

				case HAUT:
					if (((couleur_debut += tab_larg_couleur[0]) + largeur_seuils) > affi_carto->palette.nb_couleurs_val)
						couleur_debut = affi_carto->palette.nb_couleurs_val - largeur_seuils;

					gliss_demande++;
					break;

				case GAUCHE:
					largeur_seuils = dec_largeur_seuils( affi_carto->palette.nb_seuils, tab_larg_couleur );
					gliss_demande++;
					break;

				case DROITE:
					largeur_seuils = inc_largeur_seuils( 0, affi_carto->palette.nb_seuils, tab_larg_couleur, tab_larg_max_couleur );
					if ((couleur_debut + largeur_seuils) > affi_carto->palette.nb_couleurs_val)
					{
						largeur_seuils = dec_largeur_seuils( affi_carto->palette.nb_seuils, tab_larg_couleur );
                  /*
						cpt = 0;
						while ((affi_carto->palette.nb_couleurs_val > (couleur_debut + largeur_seuils)) 
						&& (cpt < affi_carto->palette.nb_seuils))
							if (inc_largeur_seuils( cpt, cpt++ + 1, tab_larg_couleur, tab_larg_max_couleur ))
								largeur_seuils++;
                  */
					}
					gliss_demande++;
					break;

				default:
					break;
				}

			if (gliss_demande)
			{
				init_couleur_seuil_palette_glissante( couleur_debut, tab_larg_couleur, affi_carto, &menu );
				gere_champs_seuils_palette_glissante( couleur_debut, tab_larg_couleur, &menu, affi_carto );
				glissement_palette( affi_carto, old_couleur_deb, couleur_debut, largeur_seuils, tab_larg_couleur );
				old_couleur_deb = couleur_debut;
				gliss_demande = 0;
			}
			affiche_carto( affi_carto );
			if (! com.change)
				if (xy_sur_carto( com.x, com.y, affi_carto ))
					edit_carto( ESC, affi_carto );

		}
		while (! sortir);
		fin_menu( &menu, menu.champs );

		affi_carto->flags.demande_trace_carto = ON;
		affi_carto->flags.interdit_re_calcule_palette = OFF;
	}
}

/***********************************************************/

int dec_largeur_seuils( int nb_seuils, int tab[] )
{
	int cpt;
	int largeur;

	for (cpt = 0, largeur = 0;  cpt < nb_seuils;  cpt++)
	{
		if (--tab[cpt] < 1)
			tab[cpt] = 1;

		largeur += tab[cpt];
	}
	return (largeur);
}

/***********************************************************/

int inc_largeur_seuils( int seuil_debut, int nb_seuils, int tab[], int tab_max[] )
{
	int cpt;
	int largeur;

	for (cpt = seuil_debut, largeur = 0;  cpt < nb_seuils;  cpt++)
	{
		if (++tab[cpt] > tab_max[cpt])
			tab[cpt] = tab_max[cpt];

		largeur += tab[cpt];
	}
	return (largeur);
}

/***********************************************************/

init_champ_couleur_palette_glissante( struct s_affi_carto *carto, struct s_dialogue *menu )
{
	int x;
	int y;
	int y1;
	int y2;
	int x1;
	int tmp;
	int lng_y;
	int cpt;
	int cpt_rep;
	int cpt_coul;
	int niv_gris;
	int coul_deb;
	int coul_fin;
	int rep_coul;
	int nb_couleurs;
	static struct s_attributs _FAR_STATIC att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};

	nb_couleurs = carto->palette.nb_couleurs_max - NB_COULEUR_DOS - NB_SEUILS_ERREUR;
	rep_coul = nb_couleurs / carto->palette.nb_couleurs_val;

	y = y1 = menu->y + menu->champs[C_DESSIN_PG].pos_y + menu->champs[C_DESSIN_PG].lng_y - 2;
	x = menu->x + menu->champs[C_DESSIN_PG].pos_x + 1;
	x1 = x + menu->champs[C_DESSIN_PG].lng_x - 2;

	coul_deb = carto->palette.offset_couleur_val;
	coul_fin = coul_deb + carto->palette.nb_couleurs_val;

	tmp = (menu->champs[C_DESSIN_PG].lng_y - 2) % (coul_fin - coul_deb);
	lng_y = (menu->champs[C_DESSIN_PG].lng_y - 2) / (coul_fin - coul_deb);

	for (cpt_coul = coul_deb, cpt = 0;  cpt_coul < coul_fin;  cpt_coul++, cpt++)
	{
		niv_gris = (double) (cpt * rep_coul) * (double) carto->palette.nb_couleurs_max / (double) nb_couleurs;

		if ((cpt_coul - coul_deb) >= carto->palette.nb_seuils)
			for (cpt_rep = 0;  cpt_rep < rep_coul;  cpt_rep++)
				set_palette( carto->fenetre.ecran, cpt_coul + cpt_rep, niv_gris, niv_gris, niv_gris );

		else
			for (cpt_rep = 0;  cpt_rep < rep_coul;  cpt_rep++)
				set_palette( carto->fenetre.ecran, cpt_coul + cpt_rep, carto->palette.rouge_seuil[cpt_coul - coul_deb],
				carto->palette.vert_seuil[cpt_coul - coul_deb], carto->palette.bleu_seuil[cpt_coul - coul_deb] );

		att.couleur = att.fcouleur = cpt_coul;

		/*
		if (cpt > tmp)
			y2 = y1 - lng_y;
		else
			y2 = y1 - lng_y - 1;
      */

		y2 = y1 - lng_y;
		box( carto->fenetre.ecran, x, y1, x1, y2, &att );
		y1 = y2;
	}
	init_couleur_seuil_palette_glissante( 0, NULL, carto, menu );
}

/***********************************************************/

init_couleur_seuil_palette_glissante( int offset_couleur, int tab[], struct s_affi_carto *carto, struct s_dialogue *menu )
{
	int x;
	int y;
	int x1;
	int y1;
	int cpt;
	int ecran;
	int index;
	int cumul = 0;
	static struct s_attributs _FAR_STATIC att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};

	x = menu->x + menu->champs[CD_SEUIL_MIN_PG].pos_x;
	x1 = x + menu->champs[CD_SEUIL_MIN_PG].lng_x;
	ecran = carto->fenetre.ecran;
	hide_mouse( ecran );

	for (cpt = 0;  cpt <= (C_SEUIL_MAXI_PG - C_SEUIL_MINI_PG);  cpt++)
	{
		index = CD_SEUIL_MIN_PG + cpt;
		if (! menu->champs[index].type.invisible)
		{
			y = menu->y + menu->champs[index].pos_y;
			y1 = y + menu->champs[index].lng_y;
			if (tab)
			{
				att.couleur = att.fcouleur = carto->palette.offset_couleur_val + offset_couleur + cumul;
				cumul += tab[cpt];
			}
			else
				att.couleur = att.fcouleur = carto->palette.offset_couleur_val + offset_couleur + cpt;

			box( ecran, x, y, x1, y1, &att );
		}
	}
	show_mouse( ecran );
}

/***********************************************************/

init_champs_palette_glissante( struct s_affi_carto *carto, struct s_dialogue *menu )
{
	int cpt;

	init_chp_unite_carto( &menu->champs[L_UNITE_PG], &carto->palette.unite );
	for (cpt = 0;  cpt <= (C_SEUIL_MAXI_PG - C_SEUIL_MINI_PG);  cpt++)
	{
		if (cpt >= carto->palette.nb_seuils)
			menu->champs[CD_SEUIL_MIN_PG + cpt].type.invisible = 1;

		if (cpt >= carto->palette.nb_seuils + 1)
			menu->champs[C_SEUIL_MINI_PG + cpt].type.invisible = 1;

	}
}

/***********************************************************/

int calcul_largeur_seuils( int tab[], int tab_max[], struct s_palette_carto *palette )
{
	int cpt;
	int nb_seuils;
	int nb_couleurs;
	int retenue = 0;
	int largeur_totale;
	int largeur_couleur;
	int nb_couleur_plus_petite = 0;

	nb_seuils = palette->nb_seuils;
	nb_couleurs = palette->nb_couleurs_val;

	if (nb_couleurs % nb_seuils)
		retenue++;

	largeur_couleur = nb_couleurs / nb_seuils;
	if (retenue)
		nb_couleur_plus_petite = nb_seuils * (largeur_couleur + retenue) - nb_couleurs;

	for (cpt = 0, largeur_totale = 0;  cpt < nb_seuils;  cpt++)
	{
		tab[cpt] = 1;
		largeur_totale += tab[cpt];
		//if (cpt >= (nb_seuils - nb_couleur_plus_petite))
		tab_max[cpt] = largeur_couleur;
		//else
		//tab_max[cpt] = largeur_couleur + retenue;

	}
	return (largeur_totale);

}

/***********************************************************/

void glissement_palette( struct s_affi_carto *carto, int old_debut, int debut, int largeur_palette, int largeur_couleur[] )
{
	int cpt;
	int cptc;
	int cptl;
	int cptr;
	int base;
	int rep_coul;
	int niv_gris;
	int coul_deb;
	int coul_fin;
	int nb_couleurs;
	double coef;

	nb_couleurs = carto->palette.nb_couleurs_max - NB_COULEUR_DOS - NB_SEUILS_ERREUR;
	rep_coul = nb_couleurs / carto->palette.nb_couleurs_val;
	coef = rep_coul * (double) carto->palette.nb_couleurs_max / (double) nb_couleurs;

	coul_deb = carto->palette.offset_couleur_val;
	coul_fin = coul_deb + carto->palette.nb_couleurs_val;
	for (cptc = coul_deb, cpt = 0;  cptc < coul_fin;  cptc++, cpt++)
	{
		niv_gris = (double) cpt * coef;
		for (cptr = 0;  cptr < rep_coul;  cptr++)
			set_palette( carto->fenetre.ecran, cptc + cptr, niv_gris, niv_gris, niv_gris );

	}
	base = debut + coul_deb;
	for (cpt = 0;  cpt < carto->palette.nb_seuils;  cpt++)
		for (cptl = 0;  cptl < largeur_couleur[cpt];  cptl++)
			set_palette( carto->fenetre.ecran, base++, carto->palette.rouge_seuil[cpt], carto->palette.vert_seuil[cpt], carto->palette.bleu_seuil[cpt] );

}

/***********************************************************/

gere_champs_seuils_palette_glissante(int couleur_debut, int tab[], struct s_dialogue *menu, struct s_affi_carto *carto)
{
	int cpt;
	int cumul;
	double valeur;
	double echelle = 1.;

	if (carto->palette.unite.convert)
	{
		if (carto->palette.nb_couleurs_val)
			echelle = (double) (carto->palette.unite.maxi_mesure - carto->palette.unite.mini_mesure) / carto->palette.nb_couleurs_val;

		for (cpt = 0, cumul = 0;  cpt <= carto->palette.nb_seuils;  cumul += tab[cpt++])
		{
			valeur = (couleur_debut + cumul) * echelle;
			if (carto->palette.unite.convert->type == TYPE_AMPLITUDE_US)
				valeur /= 1000.;
			else
				valeur /= (carto->palette.unite.maxi_mesure - carto->palette.unite.mini_mesure);

			init_chp_valeur_carto( valeur, &menu->champs[C_SEUIL_MINI_PG + cpt], &carto->palette.unite );
		}
		affiche_champs_modifie( menu, menu->champs );
	}
}

//-----------------------------------------------------------------------------.

fermer_toutes_carto( struct s_affi_carto **carto )
{
	int cpt;
	int ret = OFF;

	for (cpt = 0;  cpt < NB_AFFI_CARTOS;  cpt++)
		if (fermer_carto( carto[cpt] ))
			ret = ON;

	return (ret);
}

/***********************************************************/

void calcule_cartos_actives( 	int carto, 
										struct s_config_generale_carto * cfg_carto, 
										struct s_affi_carto ** affi_cartos )
{
	int i;
	int nb_carto_active = 0;

	if (cfg_carto->nb_cartos < 1)
		cfg_carto->nb_cartos = 1;

	if (cfg_carto->nb_cartos > cfg_carto->nb_affi_cartos_max)
		cfg_carto->nb_cartos = cfg_carto->nb_affi_cartos_max;

	if (carto < 0)
		carto = 0;

	if (carto >= cfg_carto->nb_affi_cartos_max - 1)
		carto = cfg_carto->nb_affi_cartos_max - 1;

	for (i = 0;  i < cfg_carto->nb_affi_cartos_max;  i++)
		affi_cartos[i]->flags.active = 0;

	nb_carto_active++;
	affi_cartos[carto]->flags.active = 1;

	switch (cfg_carto->nb_cartos)
	{
	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
	case 6:
		for (i = 0;  i < cfg_carto->nb_cartos;  i++)
			if (nb_carto_active < cfg_carto->nb_cartos)
				if (i != carto)
				{
					nb_carto_active++;
					affi_cartos[i]->flags.active = 1;
				}

		break;

	default:
		break;
	}

}

/***********************************************************/

change_configuration_carto(	int select_affi_carto,
										struct s_carre *carre, 
										struct s_config_generale_carto * cfg_carto, 
										struct s_affi_carto ** affi_cartos)
{
	int i;

	calcule_cartos_actives( select_affi_carto, cfg_carto, affi_cartos );
	calcule_positions_cartos( carre, affi_cartos, cfg_carto, cfg_carto->nb_affi_cartos_max );
	for (i = 0;  i < cfg_carto->nb_affi_cartos_max;  i++)
	{
		affi_cartos[i]->flags.tracee = 0;
		affi_cartos[i]->flags.demande_trace_carto = 1;
	}

}

/***********************************************************/

int gere_petite_palette( struct s_affi_carto * affi_carto )
{
	int cpt;
	int sens;
	int pos_x;
	int pos_y;
	int lng_x;
	int lng_y;
	int lng_s;
	int off_x;
	int off_y;
	int ecran;
	int x1, x2, s;
	double valeur;
	char val_seuil[ 10 ];
	struct s_champ seuil;
	struct s_fenetre fenetre;
	struct s_palette_carto *palette;
	struct s_attributs att = { 0, 0, 0, REPLACE, 0xff, 0xffff, 1, 0};
	int mem_mono;

	if (affi_carto->config.palette
	|| affi_carto->config.signal)
	{
		memset( &fenetre, 0, sizeof(struct s_fenetre ) );

		ecran = affi_carto->menu.ecran;
		palette = &affi_carto->palette;
		att.fenetre = &fenetre;

		fenetre.active++;
		fenetre.off_x = 0;
		fenetre.off_y = 0;
		fenetre.x1 = affi_carto->menu.x + affi_carto->menu.champs[BOX_PALETTE].pos_x;
		fenetre.y1 = affi_carto->menu.y + affi_carto->menu.champs[BOX_PALETTE].pos_y;
		fenetre.x2 = fenetre.x1 + affi_carto->menu.champs[BOX_PALETTE].lng_x;
		fenetre.y2 = fenetre.y1 + affi_carto->menu.champs[BOX_PALETTE].lng_y;

		affi_carto->menu.champs[BOX_PALETTE].etat.modifie = 1;
		affi_carto->menu.champs[BOX_PALETTE].etat.dessine = 0;
		affiche_champs_modifie( &affi_carto->menu, affi_carto->menu.champs );
		if (affi_carto->config.palette)
		{
			init_chp_unite_carto( &affi_carto->menu.champs[L_UNITEES_PPL], &palette->unite );

			lng_x = affi_carto->menu.champs[BOX_PALETTE].lng_x - 3 * affi_carto->menu.champs[L_UNITEES_PPL].lng_x;
			pos_x = affi_carto->menu.x + affi_carto->menu.champs[BOX_PALETTE].pos_x + (affi_carto->menu.champs[BOX_PALETTE].lng_x - lng_x) / 2;
			lng_y = affi_carto->menu.champs[BOX_PALETTE].lng_y / 3;
			pos_y = affi_carto->menu.y + affi_carto->menu.champs[BOX_PALETTE].pos_y + (affi_carto->menu.champs[BOX_PALETTE].lng_y - lng_y) / 2;
			lng_s = lng_x / palette->nb_seuils;
			att.couleur = NOIR;

			for (s = 0;  s < palette->nb_seuils;  s++)
			{
				att.fcouleur = (double ) (s + .5) * 
				(double ) palette->nb_couleurs_val / palette->nb_seuils + palette->offset_couleur_val;

				x1 = s * lng_s;
				x2 = (s + 1) * lng_s;
				mem_mono = Ecran[ecran].mode_monochrome;
				set_mode_monochrome( ecran, 0 );

				box( ecran, pos_x + x1, pos_y + lng_y, pos_x + x2, pos_y, &att );

				set_mode_monochrome( ecran, mem_mono );

				att.fcouleur = affi_carto->menu.couleur_fond_menu;
				init_chp_valeur_carto( palette->seuils[s], &seuil, &palette->unite );
				valeur = (double ) seuil.valeur / pow( 10, seuil.pos_virgule );
				sprintf( val_seuil, "%3.2lf", valeur );
				if (s % 2)
				{
					off_y = -(Tableau_fontes[att.fonte_number].hauteur_fonte + 4);
					line( ecran, pos_x + x1, pos_y + lng_y, pos_x + x1, pos_y - 3, &att );
				}
				else
				{
					off_y = lng_y + (Tableau_fontes[att.fonte_number].hauteur_fonte) / 2 + 3;
					line( ecran, pos_x + x1, pos_y + lng_y + 3, pos_x + x1, pos_y, &att );
				}
				off_x = x1 - (strlen( val_seuil ) * Tableau_fontes[att.fonte_number].largeur_fonte) / 2;
				text( ecran, pos_x + off_x, pos_y + off_y, &att, val_seuil );
			}

			init_chp_valeur_carto_direct( palette->unite.maxi_mesure, &seuil, &palette->unite );
			valeur = (double ) seuil.valeur / pow( 10, seuil.pos_virgule );
			sprintf( val_seuil, "%3.2lf", valeur );
			off_x = x2 - (strlen( val_seuil ) * Tableau_fontes[att.fonte_number].largeur_fonte) / 2;
			if (s % 2)
			{
				off_y = -(Tableau_fontes[att.fonte_number].hauteur_fonte + 4);
				line( ecran, pos_x + x2, pos_y + lng_y, pos_x + x2, pos_y - 3, &att );
			}
			else
			{
				off_y = lng_y + (Tableau_fontes[att.fonte_number].hauteur_fonte) / 2 + 3;
				line( ecran, pos_x + x2, pos_y + lng_y + 3, pos_x + x2, pos_y, &att );
			}
			text( ecran, pos_x + off_x, pos_y + off_y, &att, val_seuil );

			affi_carto->menu.champs[L_UNITEES_PPL].fcouleur = NOIR;
			affi_carto->menu.champs[L_UNITEES_PPL].etat.selectionne = 1;
			affi_carto->menu.champs[L_UNITEES_PPL].couleur = affi_carto->menu.couleur_fond_menu;
			affiche_champs_modifie( &affi_carto->menu, affi_carto->menu.champs );
		}
	}
}

int impose_extention_cfc(char *fichier)
{
	if (strstr( strupr( fichier ), ".DAT" ))
	{
		impose_ext( fichier, ".CFC" );
	}
	else
	{
		if (strstr( fichier, ".DA" ))
		{
			remplace( fichier, ".DA", ".CF" );
		}
	}
}

#endif
